Model subclass: #StringHolder
	instanceVariableNames: 'contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ST80 Remnants'!
!StringHolder commentStamp: '<historical>' prior: 0!
I am a kind of Model that includes a piece of text.  In some cases, the text can be edited, and in some the text is a method.

Categories 'code pane menu' and 'message list menu' are messages that may be called by my menus when the text is a method, and when some pane is a list of methods.  Other of my subclasses may ignore these two catagories altogether.!


!StringHolder methodsFor: 'initialize-release'!
defaultContents

	^''! !

!StringHolder methodsFor: 'initialize-release' stamp: 'sw 10/16/1998 11:36'!
embeddedInMorphicWindowLabeled: labelString
	| window |
	window _ (SystemWindow labelled: labelString) model: self.
	window addMorph: (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0 corner: 1@1).
	^ window! !

!StringHolder methodsFor: 'initialize-release' stamp: 'jm 3/24/98 17:56'!
initialize
	"Initialize the state of the receiver with its default contents."

	contents _ self defaultContents.
! !

!StringHolder methodsFor: 'initialize-release' stamp: 'sw 10/16/1998 11:37'!
openAsMorphLabel: labelString 
	"Workspace new openAsMorphLabel: 'Workspace'"
	(self embeddedInMorphicWindowLabeled: labelString) openInWorld! !

!StringHolder methodsFor: 'initialize-release' stamp: 'sw 8/4/1998 18:21'!
openAsMorphLabel: labelString  inWorld: aWorld
	"Workspace new openAsMorphLabel: 'Workspace'"
	| window |
	window _ (SystemWindow labelled: labelString) model: self.

	window addMorph: (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0 corner: 1@1).

	window openInWorld: aWorld! !

!StringHolder methodsFor: 'initialize-release' stamp: 'sw 12/22/1998 00:16'!
openLabel: aString 
	"Create a standard system view of the model, me, a StringHolder and open it.  If in mvc, terminate the active controller so that the new window will immediately be activated."
	self openLabel: aString andTerminate: true! !

!StringHolder methodsFor: 'initialize-release' stamp: 'sma 4/30/2000 10:15'!
openLabel: aString andTerminate: terminateBoolean
	"Create a standard system view of the model, me, a StringHolder and open it.; do not terminate the active process if in mvc"
	| topView codeView |

	Smalltalk isMorphic ifTrue: [^ self openAsMorphLabel: aString].

	topView _ (StandardSystemView new) model: self.
	topView borderWidth: 1.
	topView label: aString.
	topView minimumSize: 100 @ 50.

	codeView _ PluggableTextView on: self 
			text: #contents accept: #acceptContents:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	codeView window: (0@0 extent: 200@200).
	topView addSubView: codeView.
	"self contents size > 0 ifTrue: [
			codeView hasUnacceptedEdits: true].  Is it already saved or not??"
	terminateBoolean
		ifTrue:
			[topView controller open]
		ifFalse:
			[topView controller openNoTerminate]! !


!StringHolder methodsFor: 'accessing' stamp: 'di 5/19/1998 15:34'!
acceptContents: aString 
	"Set aString to be the contents of the receiver.  Return true cuz happy"

	self contents: aString.
	^ true! !

!StringHolder methodsFor: 'accessing'!
contents
	"Answer the contents that the receiver is holding--presumably a string."

	^contents! !

!StringHolder methodsFor: 'accessing' stamp: 'sw 1/12/1999 11:47'!
contents: textOrString 
	"Set textOrString to be the contents of the receiver."

	contents _ textOrString "asString"! !

!StringHolder methodsFor: 'accessing' stamp: 'sw 9/27/1999 14:16'!
contentsChanged
	self changed: #contents! !

!StringHolder methodsFor: 'accessing' stamp: 'tk 4/3/98 22:50'!
contentsSelection
	"Return the interval of text in the code pane to select when I set the pane's contents"

	^ 1 to: 0  "null selection"! !

!StringHolder methodsFor: 'accessing' stamp: 'tk 4/18/1998 14:59'!
selectedClassName
	"I may know what class is currently selected"

	self selectedClass ifNotNil: [^ self selectedClass name].
	^ nil! !

!StringHolder methodsFor: 'accessing' stamp: 'tk 4/18/1998 15:01'!
selectedClassOrMetaClass

	^ self selectedClass	"I don't know any better"! !

!StringHolder methodsFor: 'accessing' stamp: 'tk 4/18/1998 15:22'!
selectedMessageName

	^ nil! !

!StringHolder methodsFor: 'accessing' stamp: 'di 11/23/1998 15:21'!
textContents: aStringOrText 
	"Set aStringOrText to be the contents of the receiver."

	contents _ aStringOrText! !


!StringHolder methodsFor: 'evaluation'!
doItContext
	"Answer the context in which a text selection can be evaluated."

	^nil! !

!StringHolder methodsFor: 'evaluation'!
doItReceiver
	"Answer the object that should be informed of the result of evaluating a 
	text selection."

	^nil! !


!StringHolder methodsFor: 'user edits' stamp: 'di 4/21/1998 11:30'!
clearUserEditFlag
	"Clear the hasUnacceptedEdits flag in all my dependent views."

	self changed: #clearUserEdits! !

!StringHolder methodsFor: 'user edits' stamp: 'tk 4/13/1998 23:07'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !


!StringHolder methodsFor: 'code pane menu' stamp: 'sw 11/8/1999 17:56'!
codePaneMenu: aMenu shifted: shifted
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items in a text pane"
	| donorMenu |
	donorMenu _ shifted
		ifTrue:
			[ParagraphEditor shiftedYellowButtonMenu]
		ifFalse:
			[ParagraphEditor yellowButtonMenu].
	^ aMenu labels: donorMenu labelString lines: donorMenu lineArray selections: donorMenu selections! !

!StringHolder methodsFor: 'code pane menu' stamp: 'wod 5/29/1998 16:35'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then
perform it on myself. If not, send it to otherTarget, presumably the
editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !

!StringHolder methodsFor: 'code pane menu' stamp: 'tk 4/6/98 11:43'!
showBytecodes
	"We don't know how to do this"

	^ self changed: #flash! !

!StringHolder methodsFor: 'code pane menu' stamp: 'di 9/7/1999 11:27'!
spawn: contentsString

	(Workspace new contents: contentsString) openLabel: 'Workspace'
! !


!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/21/1998 08:38'!
browseAllMessages
	"Create and schedule a message set browser on all implementors of all the messages sent by the current method."

	| aClass aName method filteredList |
	(aName _ self selectedMessageName) ifNotNil: [
		method _ (aClass _ self selectedClassOrMetaClass) compiledMethodAt: aName.
		filteredList _ method messages reject: 
			[:each | #(new initialize = ) includes: each].
		Smalltalk browseAllImplementorsOfList: filteredList asSortedCollection
			 title: 'All messages sent in ', aClass name, '.', aName]
! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 16:11'!
browseClass
	"Open an class browser on this class and method"

	self selectedClassOrMetaClass ifNotNil: [
		Browser newOnClass: self selectedClassOrMetaClass 
			selector: self selectedMessageName]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 16:32'!
browseClassRefs

	| cls |
	(cls _ self selectedClass) ifNotNil: [
		Smalltalk browseAllCallsOn: (Smalltalk associationAt: cls theNonMetaClass name)]
! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 15:02'!
browseClassVarRefs
	"1/17/96 sw: devolve responsibility to the class, so that the code that does the real work can be shared"

	| cls |
	(cls _ self selectedClass) ifNotNil: [cls browseClassVarRefs]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 15:02'!
browseClassVariables
	"Browse the class varialbes of the selected class.  2/5/96 sw"

	| cls |
	(cls _ self selectedClass) ifNotNil: [cls browseClassVariables]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 15:02'!
browseInstVarDefs 

	| cls |
	(cls _ self selectedClassOrMetaClass) ifNotNil: [cls browseInstVarDefs]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 15:02'!
browseInstVarRefs 
	"1/26/96 sw: real work moved to class, so it can be shared"

	| cls |
	(cls _ self selectedClassOrMetaClass) ifNotNil: [cls browseInstVarRefs]! !

!StringHolder methodsFor: 'message list menu' stamp: 'wod 5/15/1998 00:54'!
browseMessages
	"Present a menu of all messages sent by the currently selected message. 
	Open a message set browser of all implementors of the message chosen.
	Do nothing if no message is chosen."

	self selectMessageAndEvaluate: [:selector | Smalltalk browseAllImplementorsOf: selector]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/28/1998 09:28'!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	| myClass |
	(myClass _ self selectedClassOrMetaClass) ifNotNil:
		[Browser fullOnClass: myClass selector: self selectedMessageName]! !

!StringHolder methodsFor: 'message list menu' stamp: 'wod 5/15/1998 00:54'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all
	messages sent by it.  Open a message set browser of all implementors
	of the message chosen."

	self selectMessageAndEvaluate: [:selector | Smalltalk browseAllCallsOn: selector]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 15:03'!
browseUnusedMethods
	| classes unsent messageList cls |

	(cls _ self selectedClass) ifNil: [^ self].
	classes _ Array with: cls with: cls class.
	unsent _ Set new.
	classes do: [:c | unsent addAll: c selectors].
	unsent _ Smalltalk allUnSentMessagesIn: unsent.
	messageList _ OrderedCollection new.
	classes do: [:c | (c selectors select: [:s | unsent includes: s]) asSortedCollection
					do: [:sel | messageList add: c name , ' ' , sel]].
	Smalltalk browseMessageList: messageList name: 'Unsent Methods in ', cls name! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 10/12/1999 17:42'!
browseVersions
	"Create and schedule a message set browser on all versions of the 
	currently selected message selector."
	| class selector |
	(selector _ self selectedMessageName) ifNotNil:
		[class _ self selectedClassOrMetaClass.
		VersionsBrowser
			browseVersionsOf: (class compiledMethodAt: selector)
			class: self selectedClass
			meta: class isMeta
			category: self selectedMessageCategoryName
			selector: selector]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/28/1998 19:14'!
buildMessageBrowser
	"Create and schedule a message browser."

	self selectedMessageName ifNil: [^ self].
	Browser openMessageBrowserForClass: self selectedClassOrMetaClass 
		selector: self selectedMessageName editString: nil! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/18/1998 16:06'!
classHierarchy
	"Create and schedule a class list browser on the receiver's hierarchy."

	Utilities spawnHierarchyForClass: self selectedClassOrMetaClass "OK if nil"
		selector: self selectedMessageName
! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 5/8/2000 02:16'!
classListKey: aChar from: view 
	"Respond to a Command key.  I am a model with a list of classes and a 
	code pane, and I also have a listView that has a list of methods.  The 
	view knows how to get the list and selection."

	aChar == $f ifTrue: [^ self findMethod].
	aChar == $r ifTrue: [^ self recent].
	aChar == $h ifTrue: [^ self spawnHierarchy].
	aChar == $x ifTrue: [^ self removeClass].
	^ self messageListKey: aChar from: view! !

!StringHolder methodsFor: 'message list menu' stamp: 'di 4/28/1999 11:34'!
copyName
	"Copy the current selector to the clipboard"
	| selector |
	(selector _ self selectedMessageName) ifNotNil:
		[ParagraphEditor clipboardTextPut: selector asString asText]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/28/1998 18:15'!
fileOutMessage
	"Put a description of the selected message on a file"

	self selectedMessageName ifNotNil: [
		self selectedClassOrMetaClass fileOutMethod: self selectedMessageName]! !

!StringHolder methodsFor: 'message list menu' stamp: 'di 5/6/1998 17:03'!
findMethodInChangeSets
	"Find and open a changeSet containing the current method."

	| aName |
	(aName _ self selectedMessageName) ifNotNil: [
		ChangeSorter browseChangeSetsWithClass: self selectedClassOrMetaClass
					selector: aName]! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/21/1998 09:23'!
inspectInstances
	"Inspect all instances of the selected class."

	| myClass |
	(myClass _ self selectedClassOrMetaClass) ifNotNil:
		[myClass theNonMetaClass inspectAllInstances]. 
! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/21/1998 09:00'!
inspectSubInstances
	"Inspect all instances of the selected class and all its subclasses"

	| aClass |
	(aClass _ self selectedClassOrMetaClass) ifNotNil: [
		aClass theNonMetaClass inspectSubInstances].
! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 5/8/2000 02:59'!
messageListKey: aChar from: view
	"Respond to a Command key.  I am a model with a code pane, and I also
	have a listView that has a list of methods.  The view knows how to get
	the list and selection."

	| sel class |
	(class _ self selectedClassOrMetaClass) ifNil: [^ self arrowKey: aChar from: view].
	sel _ self selectedMessageName.
	aChar == $b ifTrue: [^ Browser fullOnClass: class selector: sel].
	aChar == $N ifTrue: [^ self browseClassRefs].
	aChar == $i ifTrue: [^ self methodHierarchy].
	aChar == $h ifTrue: [^ self classHierarchy].

	sel ifNotNil: 
		[aChar == $m ifTrue: [^ Smalltalk browseAllImplementorsOf: sel].
		aChar == $n ifTrue: [^ Smalltalk browseAllCallsOn: sel].
		aChar == $v ifTrue: [^ self browseVersions].
		aChar == $O ifTrue: [^ self openSingleMessageBrowser].
		aChar == $x ifTrue: [^ self removeMessage]].

	^ self arrowKey: aChar from: view! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 1/13/2000 12:19'!
messageListSelectorTitle
	| selector aString aStamp |
	Preferences timeStampsInMenuTitles
		ifFalse:
			[^ nil].
	(selector _ self selectedMessageName) ifNotNil:
		[aString _ selector truncateWithElipsisTo: 28.
		^ (aStamp _ self timeStamp) size > 0
			ifTrue:
				[aString, String cr, aStamp]
			ifFalse:
				[aString]].
	^ nil! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/21/1998 07:57'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	Utilities methodHierarchyBrowserForClass: self selectedClassOrMetaClass 
			selector: self selectedMessageName
! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 9/21/1999 11:35'!
openSingleMessageBrowser
	| msgName title |
	"Create and schedule a message list browser populated only by the currently selected message"

	(msgName _ self selectedMessageName) ifNil: [^ self].
	Smalltalk browseMessageList: (Array with: (title _ self selectedClassOrMetaClass name, ' ', msgName))
		name: title autoSelect: nil! !

!StringHolder methodsFor: 'message list menu' stamp: 'RAA 12/10/1999 09:36'!
packageListKey: aChar from: view
	"Respond to a Command key in the package pane in the PackageBrowser"
	aChar == $f ifTrue: [^ self findClass].
	^ self classListKey: aChar from: view
! !

!StringHolder methodsFor: 'message list menu' stamp: 'tk 4/28/1998 18:16'!
printOutMessage
	"Write a file with the text of the selected message, for printing by a web browser"

	self selectedMessageName ifNotNil: [
		self selectedClassOrMetaClass fileOutMethod: self selectedMessageName
							asHtml: true]! !

!StringHolder methodsFor: 'message list menu' stamp: 'di 6/17/1998 10:58'!
removeFromCurrentChanges
	"Tell the changes mgr to forget that the current msg was changed."

	Smalltalk changes removeSelectorChanges: self selectedMessageName 
			class: self selectedClassOrMetaClass.! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 1/28/1999 12:34'!
revertAndForget
	"Revert to the previous version of the current method, and tell the changes mgr to forget that it was ever changed.  Danger!!  Use only if you really know what you're doing!!"

	self okToChange ifFalse: [^ self].
	self revertToPreviousVersion.
	self removeFromCurrentChanges.
	self contentsChanged
! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 10/10/1999 22:05'!
revertToPreviousVersion
	"Revert to the previous version of the current method"
	| aClass aSelector  changeRecords |
	self okToChange ifFalse: [^ self].
	aClass _ self selectedClassOrMetaClass.
	aClass ifNil: [^ self changed: #flash].
	aSelector _ self selectedMessageName.
	changeRecords _ aClass changeRecordsAt: aSelector.
	(changeRecords == nil or: [changeRecords size <= 1]) ifTrue: [self changed: #flash.  ^ self beep].
	changeRecords second fileIn.
	self contentsChanged
! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 5/4/2000 13:32'!
selectMessageAndEvaluate: aBlock
	"Allow the user to choose one selector, chosen from the currently selected message's selector, as well as those of all messages sent by it, and evaluate aBlock on behalf of chosen selector.  If there is only one possible choice, simply make it; if there are multiple choices, put up a menu, and evaluate aBlock on behalf of the the chosen selector, doing nothing if the user declines to choose any"

	| selector method messages |
	(selector _ self selectedMessageName) ifNil: [^ self].
	method _ self selectedClassOrMetaClass 
		compiledMethodAt: selector
		ifAbsent: [].
	(method isNil or: [(messages _ method messages) size == 0])
		 ifTrue: [^ aBlock value: selector].
	(messages size == 1 and: [messages includes: selector])
		ifTrue:
			[^ aBlock value: selector].  "If only one item, there is no choice"

	Smalltalk 
		showMenuOf: messages
		withFirstItem: selector
		ifChosenDo: [:sel | aBlock value: sel]! !

!StringHolder methodsFor: 'message list menu' stamp: 'sw 1/26/1999 09:18'!
systemCatListKey: aChar from: view
	"Respond to a Command key.  I am a model with a code pane, and I also have a listView that has a list of methods.  The view knows how to get the list and selection."
	aChar == $f ifTrue: [^ self findClass].
	^ self classListKey: aChar from: view! !

!StringHolder methodsFor: 'message list menu' stamp: 'di 4/2/1999 15:54'!
timeStamp 
	|  selector  aMethod |
	(selector _ self selectedMessageName) ifNotNil:
		[aMethod _ self selectedClassOrMetaClass compiledMethodAt: selector ifAbsent: [nil].
		aMethod ifNotNil: [^ Utilities timeStampForMethod: aMethod]].
	^ String new! !


!StringHolder methodsFor: 'as yet unclassified' stamp: 'sw 9/27/1999 14:10'!
showDiffs
	"For backward compatibility during transition only, lest browsers be unusable for a spell"
	^ false
! !


!StringHolder methodsFor: 'elements' stamp: 'jens 2/2/2009 01:02'!
compareElementsBytecode

	| myClass mySelector myMethod se recompiled |

	(myClass _ self selectedClassOrMetaClass) ifNotNil:
		[mySelector _ self selectedMessageName. 
		myMethod _ myClass compiledMethodAt: mySelector ifAbsent: [^self].


	se _ ((myClass decompilerClass new)
		decompile: mySelector in: myClass method: myMethod) asSyntaxElement.
	se openInWorld;
		position: World center - (se extent // 2)].

	recompiled _ se asCompiledMethodForClass: myClass.
	(recompiled = myMethod)
		ifTrue: [self inform: 'bytecodes match.']
		ifFalse: [self inform: 'bytecodes do NOT match!!'].

	se delete! !

!StringHolder methodsFor: 'elements' stamp: 'jens 2/2/2009 01:01'!
openMessageAsSyntaxElement

	| myClass mySelector myMethod temps se |

	(myClass _ self selectedClassOrMetaClass) ifNotNil:
		[mySelector _ self selectedMessageName. 
		myMethod _ myClass compiledMethodAt: mySelector ifAbsent: [^self].
		temps _ (myClass compilerClass new
						parse: myMethod getSourceFromFile asString in: myClass notifying: nil)
						tempNames.

	se _ ((myClass decompilerClass new withTempNames: temps)
		decompile: mySelector in: myClass method: myMethod) asSyntaxElement.
	se openInWorld;
		position: World center - (se extent // 2)]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StringHolder class
	instanceVariableNames: ''!

!StringHolder class methodsFor: 'class initialization'!
initialize
	"The class variables were initialized once, and subsequently filled with
	information. Re-executing this method is therefore dangerous." 
	 
	"workSpace _ StringHolder new"

	"StringHolder initialize"! !


!StringHolder class methodsFor: 'instance creation' stamp: 'tk 5/4/1998 17:32'!
open
	(Smalltalk at: #Workspace) new openLabel: 'Workspace'
		"Not to be confused with our own class var 'Workspace'"! !

!StringHolder class methodsFor: 'instance creation' stamp: 'tk 5/4/1998 16:41'!
openLabel: aString

	self new openLabel: aString! !


StringHolder initialize!
