ReporterBlockMorph subclass: #MultiArgReporterBlockMorph
	instanceVariableNames: 'addElementMorph removeElementMorph minArgs maxArgs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:59'!
addItem
	self stop.
	self commandSpec: commandSpec, ' %s'! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 22:19'!
addLabel

	super addLabel.
	removeElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90).
	argMorphs size > self minArgs ifTrue: [
		self addMorphBack: removeElementMorph].	
	addElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90).

	(selector = #doMakeNewList or: [
		((selector notNil and: [selector endsWith: 'List']) not
			and: [ maxArgs isNil or: [argMorphs size < maxArgs]])]) 
				ifTrue: [ self addMorphBack: addElementMorph].

	self adjustInternals! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/16/2010 23:59'!
adjustInputParadigm: choice
	"private"

	| newSpec |
	(#(doRunBlockWithArgs doRunBlockWithArgList doForkBlockWithArgs doForkBlockWithArgList doCallBlockWithArgs doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	'with inputs' localized = choice ifTrue: [ 
		(selector endsWith: 'List') ifTrue: [
			selector _ ((selector copyFrom: 1 to: selector size - 'List' size), 's') asSymbol]].
	'with input list' localized = choice ifTrue: [
		(selector endsWith: 'List') ifFalse: [
			selector _ ((selector copyFrom: 1 to: selector size - 1), 'List') asSymbol ]].
	(selector endsWith: 'List') 
		ifTrue: [maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec localized asMacRoman. 
	self commandSpec: newSpec.





! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:00'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(		
			doRun
			doRunBlockWithArgs 
			doRunBlockWithArgList 
			doFork doForkBlockWithArgs 
			doForkBlockWithArgList 
			doReport 
			doCallBlockWithArgs 
			doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	sdict _ Dictionary new.
	argMorphs size = 2  ifTrue: [ 
		((selector endsWith: 'Args') |  (selector endsWith: 'List')) not 
			ifTrue: [
				sdict
					at: #doRun put: #doRunBlockWithArgs;
					at: #doFork put: #doForkBlockWithArgs;
					at: #doReport put: #doCallBlockWithArgs;
					yourself]
			ifFalse: [
				sdict
					at: #doRunBlockWithArgs put: #doRun;
					at: #doRunBlockWithArgList put: #doRun;
					at: #doForkBlockWithArgs put: #doFork;
					at: #doForkBlockWithArgList put: #doFork;
					at: #doCallBlockWithArgs put: #doReport;
					at: #doCallBlockWithArgList put: #doReport;
					yourself]].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [ selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.
	(selector endsWith: 'List') 
		ifTrue: [ maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.
	self commandSpec: newSpec.
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 01:12'!
argumentAt: index
	"Returns the argument morph at the given index."

	^argMorphs at: index.	"BYOB custom blocks don't need argPermutations"
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/15/2010 23:45'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg val eval |
	
	blockTuple _ Array new: argMorphs size + 3.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	1 to: argMorphs size do: [:i |
		arg _ argMorphs at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
				ifTrue: [blockTuple at: i + 3 put: arg asBlockTuple]
				ifFalse: [(arg isKindOf: ExpressionArgMorph)
					ifTrue: [
						val _ arg getExpression.
						arg isNumberExpression
							ifTrue: [val = ' ' asUTF8
								ifTrue: [eval _ val]
								ifFalse: [eval _ val asNumberNoError]]
							ifFalse: [eval _ arg evaluate]]
					ifFalse: [eval _ arg evaluate].
					blockTuple at: i + 3 put: eval]]
			ifFalse: [blockTuple at: i + 3 put: arg asBlockTuple]].
	^ blockTuple
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluate
	"Evalue this block with the given argument list."

	self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	^scratchProc answer	! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: rawArgs
	"Evalue this block with the given argument list."

	self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	^scratchProc answer	! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'CWB 7/19/2011 07:12'!
fixBlockLayoutWrap
	"Update the positions of my submorphs."

	| parts lines line h x y minXForArgs w space left maxX maxHeight extraSpace mh |

	(#(function functionWithArgs doReport doCallWithArgs doCallBlockWithArgs) includes: selector) ifTrue: [
		self updateIsBoolean; layoutChanged].

	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	parts _ self nonControlFlowSubmorphs.
	parts isEmpty ifTrue: [^self].
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	minXForArgs _ self left.
	space _ 4.

	parts do: [:m |
	((m isKindOf: CArgSlotMorph) or: [(m isKindOf: CReporterSlotMorph) or: [(m isKindOf: MultiArgMorph) and: [m isWrapping]]])
		ifTrue: [ 
			line isEmpty ifFalse: [
				lines add: line].
			m left: self left - 5.
			lines add: (OrderedCollection with: m).
			(m isKindOf: MultiArgMorph)
				ifTrue: [m fixArgLayout]
				ifFalse: [m fixBlockLayout].
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
				ifTrue: [m width: 40].
			line _ OrderedCollection new.
			maxX _ maxX max: (left + m width).
			x _ left ]
		ifFalse: [
			(x - left > self wrapWidth and: [m ~~ parts last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].
			(m isKindOf: StringMorph)
				ifTrue: [m color: self labelColor]
				ifFalse: [x _ x max: minXForArgs].

			m left: x.
			(m right - left > 300 and: [line isEmpty not and: [m ~~ parts last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
				maxX _ maxX max: x]].
	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 4.

	"distribute lines vertically"

	space _ 1.
	y _ self top "+ 2" "+ space".
	lines do: [:eachLine |
		maxHeight _ 14.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate or: [ 
			((m isKindOf: CArgSlotMorph) 
			or: [m isKindOf: OSlotMorph]) and: [m isEmptySlot not]] ])
				ifTrue: [mh _ m height + 10]
				ifFalse: [mh _ m height + 2].
			maxHeight _ mh max: maxHeight].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + 1].
		y _ y + maxHeight + space].
	h _ y - self top + space.


	"adjust lines to round / hex shape"

	extraSpace _ 0.
	lines size > 1 
		ifTrue: [extraSpace _ h // 2]
		ifFalse: [ isBoolean
			ifTrue: [extraSpace _ h // 3]].

	parts do: [:m|
		m left: m left + extraSpace].

	w _ w + (extraSpace * 2).

	"adjust CArgSlots"

	parts do: [:m |
		(m isKindOf: CArgSlotMorph)
			ifTrue: [m width: w - (extraSpace * 2) + 6]].

	(parts last isKindOf: CArgSlotMorph) ifTrue: [
		h _ h + space + 5].


	"stack nested Reporters more efficiently:"

	lines size > 1 ifTrue: [
		self height: h.
		lines do: [:l |
			| offset |
			((l first respondsTo: #bodyLeft) and: [(isBoolean and: [l first isBooleanReporter not]) not])
				ifTrue: [ offset _ l first bodyLeft - self bodyLeft]
				ifFalse: [ offset _ l first left - self bodyLeft].
				l do: [:m |
					self isBooleanReporter
						ifTrue: [m left: m left - offset + 2]
						ifFalse: [m left: m left - offset]]].

		maxX _ self left + 5.
		lines do: [:l |
			((l last respondsTo: #bodyRight)  and: [(isBoolean and: [l last isBooleanReporter not]) not])
				ifTrue: [maxX _ maxX max: l last bodyRight]
				ifFalse: [maxX _ maxX max: l last right]].
		self isBooleanReporter
			ifTrue: [self bodyRight: maxX + 2]
			ifFalse: [self bodyRight: maxX].

		"adjust Multi-CArgSlots"

		parts do: [:m | (m isKindOf: MultiArgMorph)
			ifTrue: [m loopsWidth: self bodyRight - self bodyLeft]]]

	ifFalse: [ self extent: w @ h].

	(self ownerThatIsA: ScratchBlockPaletteMorph) ifNotNil: [
		(self ownerThatIsA: ScratchBlockPaletteMorph) fixLayout].

! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:05'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	selector ifNil: [^nil].
	(selector beginsWith: 'doCall')
		ifTrue: [^'doCall'].
	(selector beginsWith: 'doReport')
		ifTrue: [^'doCall'].
	^super helpScreenName
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 14:00'!
maxArgs
	^ maxArgs! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 14:00'!
maxArgs: anInteger
	maxArgs _ anInteger! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/23/2009 23:53'!
minArgs
	^minArgs ifNil: [minArgs _ 0]! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/23/2009 23:56'!
minArgs: anInteger
	minArgs _ anInteger! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/11/2009 20:10'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(addElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self addItem ].
		(removeElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self removeItem ]].
	^super mouseDown: evt! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 11:20'!
organizeArgs: argList
	"Answer an arugments array in which all arguments have been rearranged to the original English permutation"

	^ argList	"no permutations for these higher order blocks"
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:59'!
removeItem
	self stop.
	argMorphs size > self minArgs ifTrue: [
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/6/2010 03:44'!
showValue

	| gotError msg tooltip w worldBounds |
	gotError _ false.

	[self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	msg _ scratchProc answer] ifError: [
		gotError _ true.
		msg _ 'Error!!'].

	(msg isKindOf: Morph)
		ifTrue: [(msg respondsTo: #displayForm)
			ifTrue: [msg _ msg displayForm ]
			ifFalse: [msg _ msg imageForm ]]
		ifFalse: [msg _ msg asString ].

	(self isBooleanReporter or: [msg = 'Error!!']) ifTrue: [
		msg _ msg localized].
	tooltip _ (ScratchReporterToolTipMorph string: msg for: self)
		left: self right;
		bottom: self top.
	ScratchTranslator isRTL ifTrue: [tooltip right: self left].
	gotError ifTrue: [tooltip messageColor: Color red darker].

	w _ self world.
	w addMorphFront: tooltip.
	((worldBounds _ w bounds) containsRect: tooltip bounds) ifFalse:
		[tooltip bounds: (tooltip bounds translatedToBeWithin: worldBounds)].

	self setProperty: #toolTip toValue: tooltip.
	tooltip initialCursorPoint: Sensor cursorPoint.
	tooltip startStepping.

! !
