OSlotMorph subclass: #CReporterSlotMorph
	instanceVariableNames: 'topBarBottom blockBottom '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 7/7/2010 01:44'!
computeHighlightColors

	| h s v |
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	highlightColor1 _ Color h: h s: (s - 0.13) v: (v + 0.1).
	highlightColor2 _ Color h: h s: s v: (v + 0.07).
	shadowColor _ color mixed: 0.55 with: Color black.
! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:43'!
drawBottomBarOn: aCanvas 


	| left barTop barBottom |

	barBottom _ self bottom.


	barTop _ barBottom - 3.
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		aCanvas
			fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
			color: shadowColor]

! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:44'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas


! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:57'!
drawTopBarOn: aCanvas 

	| left right y |

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.

	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: (left + 2) to: right - 1 "gapStart" y: y + 2 color: shadowColor on: aCanvas.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		self drawPoint: (right "- 1")@y color: shadowColor on: aCanvas.
		self drawPoint: (right - 1 "2")@(y + 1) color: shadowColor on: aCanvas]
! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:45'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.

	aCanvas

		fillRectangle: (self topLeft corner: (barRight @ self bottom))
		color: color;

		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 7/6/2010 22:24'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [self color: owner color]].

	newH _ 14.

	self nestedBlock
		ifNotNil: [ (self nestedBlock respondsTo: #fixBlockLayout)
			ifTrue: [ self nestedBlock fixBlockLayout].
			self nestedBlock position: self position + (12@3).
			(self nestedBlock isKindOf: SpecialArgMorph) ifFalse: [
				newH _ self nestedBlock fullBounds height + 6]].

	self height: newH.


	(owner isKindOf: ReporterBlockMorph) 
		ifTrue: [self nestedBlock ifNotNil: [
			self width: self nestedBlock fullBounds width + CBlockBracketThickness]]

! !


!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:01'!
displayForm
	^Form dotOfSize: 1! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'CWB 11/9/2012 22:03'!
ensureSlotWidth: width
"This is a special slotted block and we want to make sure of its width."

	self width: width.! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:15'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #cLambda.
	self commandSpec: '%Z'.
	self addLabel.

	removeElementMorph ifNotNil: [
		removeElementMorph delete]
! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:02'!
isEmptySlot
	^ self nestedBlock isNil! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:55'!
nestedBlock
	self args ifNil: [^ nil].
	self args size < 1 ifTrue: [^ nil].
	^ super nestedBlock! !


!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:14'!
morphEndsLine
"This morph should be the only one on its line (not counting children)."

	^ true.! !

!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:14'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children)."

	^ false.! !

!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:45'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self width: linewidth - 5.! !
