BorderedMorph subclass: #ArgumentPlaceHolderMorph
	instanceVariableNames: 'labelFragment isRaised '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:06'!
acceptDroppingMorph: aBlockMorph event: evt
	"This message is sent when a morph is dropped onto a morph that has agreed to accept the dropped morph by responding 'true' to the wantsDroppedMorph:Event: message. This default implementation just adds the given morph to the receiver."

	labelFragment
		label: aBlockMorph variable;
		isInput: true.
	aBlockMorph delete.
	self template updateSpecWithDnDSpec! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 19:35'!
appear

	self
		isHidden: false;
		appearInactive! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/4/2009 00:44'!
appearActiveFor: aMorph
	self
		extent: aMorph extent + (4@4);
		borderWidth: 4;
		borderColor: Color white;
		color: Color white darker! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/24/2010 23:18'!
appearInactive
	self
		extent: self class dimensions;
		borderWidth: 0;
		color: Color transparent
	! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:46'!
drawEmbeddedOn: aCanvas
	
	| form |
	form _ (ScratchFrameMorph skinAt: #addItem) deepCopy.
	form replaceColor: (form colorAt: 5@5) with: (ScriptableScratchMorph blockColorFor: 'variables') darker.
	form replaceColor: (form colorAt: form center) with: Color white.
	super drawOn: aCanvas.
	aCanvas translucentImage: (form withEmbeddedOutlineColor: owner color width: 1) 
			at: self position + (( self extent - form extent) // 2)
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:49'!
drawOn: aCanvas
	
	isRaised
		ifTrue: [self drawRaisedOn: aCanvas]
		ifFalse: [self drawEmbeddedOn: aCanvas]! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:57'!
drawRaisedOn: aCanvas
	
	| form |
	form _ (ScratchFrameMorph skinAt: #addItem) deepCopy.
	form replaceColor: (form colorAt: 5@5) with: (ScriptableScratchMorph blockColorFor: 'variables').
	form replaceColor: (form colorAt: form center) with: Color white.
	super drawOn: aCanvas.
	aCanvas translucentImage: (form withEmbeddedOutlineColor: owner color width: 1) 
			at: self position + (( self extent - form extent) // 2)
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2010 23:28'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:50'!
handlesMouseOver: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 22:05'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 22:48'!
initialize
	super initialize.
	isRaised _ false.
	labelFragment _ BlockLabelFragment new.
	self
		useRoundedCorners;
		appearInactive;
		updateFragment
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:15'!
labelFragment
	^labelFragment! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 20:31'!
labelFragment: aBlockLabelFragmen
	labelFragment _ aBlockLabelFragmen! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/2/2010 00:00'!
mouseDown: evt
	"Handle a mouse down event"

	| old frag |
	owner isFrozen 
		ifTrue: [^ self]
		ifFalse: [owner isFrozen: true].

	old _ labelFragment deepCopy.
	frag _ BlockLabelFragmentDialog on: labelFragment category: owner category.
 	owner
		isFrozen: false;
		hideArgumentPlaceHolders.
	frag = #cancelled ifTrue: [
		labelFragment _ old.
		^ self]. 
	owner updateSpecWithDnDSpec! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:10'!
mouseEnter: evt

	owner isFrozen 
		ifTrue: [^ self].
	isRaised _ true.
	self changed
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:10'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	owner isFrozen 
		ifTrue: [^ self].
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self appearActiveFor: m ].
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/10/2010 00:56'!
mouseLeave: evt

	owner ifNil: [^ self].
	owner isFrozen 
		ifTrue: [^ self].
	isRaised _ false.
	self changed
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:47'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	owner ifNil: [^ self].
	owner isFrozen 
		ifTrue: [^ self].
	self appearInactive! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:05'!
template

	| template |
	template _ self ownerThatIsA: CustomCommandBlockMorph.
	template ifNil: [
		template _ self ownerThatIsA: CustomReporterBlockMorph].
	^ template 
! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 20:31'!
updateFragment

	labelFragment
		isInput: true;
		label: ''! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 19:34'!
vanish

	self
		isHidden: true;
		extent: 0@0! !

!ArgumentPlaceHolderMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 00:05'!
wantsDroppedMorph: aMorph event: evt
	"Return true if the receiver wishes to accept the given morph, which is being dropped by a hand in response to the given event. The default implementation returns false.
NOTE: the event is assumed to be in global (world) coordinates."

	| template |
	template _ self template.
	template ifNil: [^ false].

	^((aMorph isKindOf: VariableBlockMorph) and: [aMorph isSpecialForm]) and: [
		(template parameterNames includes: aMorph variable) not]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ArgumentPlaceHolderMorph class
	instanceVariableNames: ''!

!ArgumentPlaceHolderMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/24/2010 23:18'!
dimensions
	^ 16@10! !


Object subclass: #BYOBList
	instanceVariableNames: 'contents lastChanged '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BYOBList methodsFor: 'initializing' stamp: 'jens 7/13/2010 19:33'!
initialize
	contents _ OrderedCollection new.
	lastChanged _ Time millisecondClockValue! !


!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:33'!
clear

	contents _ OrderedCollection new.
	self changed.
! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:34'!
contains: anObject

	^ contents includes: anObject! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:35'!
deleteLineAt: aNumber

	contents removeIndex: aNumber.
	self changed! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/14/2010 00:45'!
insertLine: anObject at: aNumber

	contents add: anObject afterIndex: aNumber - 1.
	self changed! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:38'!
lineAt: aNumber

	^ contents at: aNumber! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:38'!
lineCount

	^ contents size
! !

!BYOBList methodsFor: 'list ops' stamp: 'jens 7/13/2010 12:39'!
setLineAt: aNumber to: newContents

	contents at: aNumber put: newContents.
	self changed! !


!BYOBList methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:58'!
at: index

	^ contents at: index! !

!BYOBList methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:34'!
contents

	^ contents! !

!BYOBList methodsFor: 'accessing' stamp: 'jens 7/14/2010 00:26'!
contents: anOrderedCollection

	contents _ anOrderedCollection.
	self changed
! !

!BYOBList methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:33'!
lastChanged

	^ lastChanged! !

!BYOBList methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:52'!
size
	^ contents size! !


!BYOBList methodsFor: 'updating' stamp: 'jens 7/14/2010 04:22'!
changed

	lastChanged _ Time millisecondClockValue. 
	super changed! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BYOBList class
	instanceVariableNames: ''!

!BYOBList class methodsFor: 'demo' stamp: 'jens 7/16/2010 08:19'!
purgeAll
	"for dev purposes only"

	BYOBListWatcherMorph allInstancesDo: [:l | l delete].
	BYOBList allInstancesDo: [:l | l = nil].
	Smalltalk garbageCollect
! !

!BYOBList class methodsFor: 'demo' stamp: 'jens 7/14/2010 00:14'!
test
	"BYOBList test"

	| myList |
	myList _ BYOBList new.
	3 timesRepeat: [
		(BYOBListWatcherMorph on: myList) openInWorld; startStepping]! !


ScratchListMorph subclass: #BYOBListWatcherMorph
	instanceVariableNames: 'list lastUpdated isUpdating '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BYOBListWatcherMorph methodsFor: 'accessing' stamp: 'jens 7/13/2010 12:48'!
list
	^ list! !

!BYOBListWatcherMorph methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:42'!
list: aBYOBList

	list _ aBYOBList.
	self update
! !


!BYOBListWatcherMorph methodsFor: 'initialization' stamp: 'jens 7/14/2010 00:39'!
initialize
	super initialize.
	list _ BYOBList new.
	lastUpdated _ list lastChanged.
	isUpdating _ false! !


!BYOBListWatcherMorph methodsFor: 'dropping/grabbing' stamp: 'jens 7/13/2010 13:00'!
justDroppedInto: aMorph event: evt

	(aMorph isKindOf: ScratchStageMorph) ifTrue: [
		super justDroppedInto: aMorph event: evt.
		self world ifNotNil: [self world startSteppingSubmorphsOf: self].
		^ self].

	"delete me if dropped anywhere but the stage"

"
	self position:  evt hand formerPosition.
	^ self delete

"! !


!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 23:28'!
scrollActiveCellIntoView

	"override my superclass behavior - do nothing"! !

!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 23:32'!
update

	isUpdating ifTrue: [^ self].
	isUpdating _ true.
	self clear.
	1 to: list size do: [:i |
		self privateInsertLine: (list at: i) at: i].
	self layoutChanged.
	lastUpdated _ list lastChanged.
	isUpdating _ false.
		! !

!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 22:28'!
updateList
	list contents: self asArray asOrderedCollection.
	lastUpdated _ list lastChanged! !


!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:17'!
createCell: anObject

	| readout cell font numberRight txt|

	txt _ anObject.
	(anObject isKindOf: String)
		ifFalse: [txt _ anObject printString].

	font _ ScratchFrameMorph getFont: #Watcher.
	readout _ ListMultilineStringMorph new
		borderWidth: 0;
		color: Color transparent;
		textColor: Color white;
		growWithText: true;
		contents: txt font: font.
	readout height: ((ScratchTranslator stringExtent: 'A' font: font) y) + 6.
	ScratchTranslator isRTL
		ifTrue: [numberRight _ self right - 5]
		ifFalse: [numberRight _ self left + self largestIndexWidth + 6].
	ScratchTranslator isRTL
		ifTrue: [readout width: self right - self left - self largestIndexWidth - 33]
		ifFalse: [readout width: self right - numberRight - 25].

	cell _ WatcherReadoutFrameMorph new
		color: ScriptableScratchMorph listBlockColor;
		extent: readout extent + 3;
		addMorphBack: readout.

	(anObject isKindOf: String) ifFalse: [
		cell complexObject: anObject ].

	cell position: scrollPane contents bottomLeft.

	"avoid recursive lists"
	scrollPane contents allMorphs detect: [:m | cell allMorphs includes: m] ifNone: [
		scrollPane contents addMorph: cell].

	^ cell
! !

!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:44'!
noteChangeAtIndex: index

	self updateContents

! !

!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:37'!
privateInsertLine: anObject at: aNumber

	| index newCell |

"
	(anObject isKindOf: list class) ifTrue: [
		(anObject containsRecursive: list) ifTrue: [
			self error: 'attempting to create a recursive list']].
"

	index _ aNumber asInteger.
	(index > 0 and: [index <= (cellMorphs size + 1)]) ifFalse: [
		lastActivityError _ true.
		^ self].

	newCell _ self createCell: anObject.
	index = 1
		ifTrue: [cellMorphs addFirst: newCell]
		ifFalse: [
			index > cellMorphs size
				ifTrue: [cellMorphs addLast: newCell]
				ifFalse: [cellMorphs add: newCell afterIndex: index - 1]].

	self updateCountMorph.

	self updateContents.

"	self noteChangeAtIndex: index."
	^ newCell
! !


!BYOBListWatcherMorph methodsFor: 'stepping' stamp: 'jens 7/15/2010 23:43'!
step

	lastUpdated = list lastChanged
		ifTrue: [^ self].

	self update.
	super step! !


!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:37'!
deleteLineAt: aNumber

	super deleteLineAt: aNumber	.
	list deleteLineAt: aNumber.
	lastUpdated _ list lastChanged! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:57'!
focusCell: cellMorph

	super focusCell: cellMorph.
	lastUpdated _ list lastChanged.
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 23:21'!
focusIndex: anInteger

	super focusIndex: anInteger.
	lastUpdated _ list lastChanged.
	lastActivityIndex _ anInteger
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:44'!
insertLine: aString at: aNumber

	| newCell |
	newCell _ super insertLine: aString at: aNumber.
	list insertLine: aString at: aNumber.
	lastUpdated _ list lastChanged.
	^ newCell
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:38'!
setLineAt: aNumber to: newContents

	super setLineAt: aNumber to: newContents.
	list setLineAt: aNumber to: newContents.
	lastUpdated _ list lastChanged

! !


!BYOBListWatcherMorph methodsFor: 'comparing' stamp: 'jens 7/15/2010 21:27'!
= another

	^ self == another! !


!BYOBListWatcherMorph methodsFor: 'event handling' stamp: 'jens 7/16/2010 00:36'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p listOwner |

	resizeOffset _ nil.
	evt hand toolType = 'CutTool' ifTrue: [
		evt shiftPressed ifFalse: [evt hand toolType: nil].
		^ self delete].

	World activeHand showTemporaryCursor: nil.
	evt hand newKeyboardFocus: nil.
	p _ evt cursorPoint.

	((addItemMorph bounds expandBy: 2) containsPoint: p) ifTrue: [
		^ self insertLine: '' at: (self lineCount + 1)].

	((addSublistMorph bounds expandBy: 2) containsPoint: p) ifTrue: [
		^ list insertLine: BYOBList new at: (self lineCount + 1)].

	listOwner _ self listOwner.
	(((deleteMorph bounds expandBy: 2) containsPoint: p) and: [listOwner notNil]) ifTrue: [
		^ listOwner list deleteLineAt: (listOwner indexOf: self list)].

	evt rightButtonPressed
		ifTrue: [Sensor waitNoButton. ^ self rightButtonMenu]
		ifFalse:	[
			((resizeMorph bounds expandBy: 4) containsPoint: p)
				ifFalse: [evt hand grabMorph: self]
				ifTrue: [resizeOffset _ self bottomRight - p]].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BYOBListWatcherMorph class
	instanceVariableNames: ''!

!BYOBListWatcherMorph class methodsFor: 'instance creation' stamp: 'jens 7/13/2010 12:49'!
on: aBYOBList

	^ self new list: aBYOBList! !


StringDialog subclass: #BlockDialog
	instanceVariableNames: 'allSpritesRadioButton thisSpriteRadioButton spriteSpecificFlag scopeRadioButtons radioButtons commandBlockRadioButton reporterBlockRadioButton booleanBlockRadioButton booleanBlockFlag reporterBlockFlag categoryChooser category userSpec type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:32'!
formTypeCommandOff

	^ (CommandBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 01:27'!
formTypeCommandOn

	^ (CommandBlockMorph new
			color: (ScriptableScratchMorph blockColorFor: category asString); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:51'!
formTypeCommandOver

	^ (CommandBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'command' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:32'!
formTypePredicateOff

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'predicate' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 01:49'!
formTypePredicateOn

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: (ScriptableScratchMorph blockColorFor: category asString); 
			commandSpec: 'predicate' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:52'!
formTypePredicateOver

	^ (ReporterBlockMorph new 
			isBoolean: true; 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'predicate' localized) 
		imageForm.! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/25/2010 02:33'!
formTypeReporterOff

	^ (ReporterBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.2 with: Color veryLightGray); 
			commandSpec: 'reporter' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/11/2010 01:35'!
formTypeReporterOn

	^ (ReporterBlockMorph new color: (ScriptableScratchMorph blockColorFor: category asString); commandSpec: 'reporter' localized) imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 6/22/2010 22:52'!
formTypeReporterOver

	^ (ReporterBlockMorph new 
			color: ((ScriptableScratchMorph blockColorFor: category asString) mixed: 0.4 with: Color veryLightGray); 
			commandSpec: 'reporter' localized) 
		imageForm.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectBooleanBlock

	reporterBlockFlag _ true.
	booleanBlockFlag _ true.
	type _ #boolean.
	booleanBlockRadioButton
		onForm: self formTypePredicateOn;
		overForm: self formTypePredicateOn;
		on.
	commandBlockRadioButton
		offForm: self formTypeCommandOff;
		overForm: self formTypeCommandOver;
		off.
	reporterBlockRadioButton
		offForm: self formTypeReporterOff;
		overForm: self formTypeReporterOver;
		off.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectCommandBlock

	reporterBlockFlag _ false.
	booleanBlockFlag _ false.
	type _ #none.
	booleanBlockRadioButton
		offForm: self formTypePredicateOff;
		overForm: self formTypePredicateOver;
		off.
	commandBlockRadioButton
		onForm: self formTypeCommandOn;
		overForm: self formTypeCommandOn;
		on.
	reporterBlockRadioButton
		offForm: self formTypeReporterOff;
		overForm: self formTypeReporterOver;
		off.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
selectReporterBlock

	reporterBlockFlag _ true.
	booleanBlockFlag _ false.
	type _ #reporter.
	booleanBlockRadioButton
		offForm: self formTypePredicateOff;
		overForm: self formTypePredicateOver;
		off.
	commandBlockRadioButton
		offForm: self formTypeCommandOff;
		overForm: self formTypeCommandOver;
		off.
	reporterBlockRadioButton
		onForm: self formTypeReporterOn;
		overForm: self formTypeReporterOn;
		on.
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 2/2/2010 22:01'!
toggleSpriteSpecific

	spriteSpecificFlag _ spriteSpecificFlag not.
	spriteSpecificFlag
		ifTrue: [
			allSpritesRadioButton off.
			thisSpriteRadioButton on]
		ifFalse: [
			allSpritesRadioButton on.
			thisSpriteRadioButton off].
	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'private' stamp: 'jens 1/11/2010 01:42'!
updateTypeSelection
	#none = type ifTrue: [
		^self selectCommandBlock].

	#boolean = type ifTrue: [
		^self selectBooleanBlock].

	self selectReporterBlock! !


!BlockDialog methodsFor: 'initialization' stamp: 'jens 1/8/2010 00:26'!
buildCategoryChooser

	| catList maxExtent buttons label offForm onForm overForm b pad leftColumnX rightColumnX x y catButtonsExtent |
	catList _ #(
		motion		control
		looks		sensing
		sound		operators
		pen			variables
		other		list).

	categoryChooser _ ImageFrameMorph new.
	categoryChooser initFromForm: (ScratchFrameMorph skinAt: #paintOptionsBackground).

	"Create new buttons, keeping track of the maximum extent."
	maxExtent _ 75@0.
	buttons _ catList collect: [:cat |
		label _ (ScratchTranslator translationFor: cat asString) capitalized.

		(#(other list) includes: cat)
			ifTrue:[
				offForm _ (ScratchFrameMorph skinAt: #variables).
				onForm _ (ScratchFrameMorph skinAt: #variablesPressed).
				overForm _ (ScratchFrameMorph skinAt: #variablesOver)]
			ifFalse: [
				offForm _ (ScratchFrameMorph skinAt: cat).
				onForm _ (ScratchFrameMorph skinAt: (cat, 'Pressed')).
				overForm _ (ScratchFrameMorph skinAt: (cat, 'Over'))].

		ScratchTranslator isRTL
			ifTrue:[
				b _ ResizableToggleButton2 new
					offForm:	(offForm flipBy: #horizontal centerAt: offForm center)
					onForm:		(onForm flipBy: #horizontal centerAt: onForm center)
					overForm:	(overForm flipBy: #horizontal centerAt: overForm center)]
			ifFalse:[
				b _ ResizableToggleButton2 new
					offForm:	offForm
					onForm:		onForm
					overForm:	overForm].
		b
			label: label font: (ScratchFrameMorph getFont: #Category);
			setLabelColor: Color white;
			target: self;
			actionSelector: #category:;
			arguments: (Array with: cat);
			toggleButtonMode: true;
			toggleMode: false.
		ScratchTranslator isRTL
			ifTrue:[b rightJustifyInset: 10]
			ifFalse:[b leftJustifyInset: 10].
		maxExtent _ maxExtent max: (b extent + (3 @ -6)).
		b].

	"calculate catButtonsExtent"
	pad _ 15. "padding on left, right, and betwen the button columns"
	catButtonsExtent _ ((2 * maxExtent x) + (3 * pad)) @ (((catList size // 2) * (maxExtent y + 6)) + 25).

	"place the buttons"
	leftColumnX _ self left + 12 + pad.
	rightColumnX _ leftColumnX + maxExtent x + pad.
	x _ leftColumnX.
	y _ categoryChooser top + 17.
	1 to: buttons size do: [:i |
		b _ buttons at: i.
		b extent: maxExtent.
		categoryChooser addMorph: (b position: x@y).
		i even
			ifTrue: [x _ leftColumnX. y _ y + b height + 6]
			ifFalse: [x _ rightColumnX]].

	categoryChooser width: catButtonsExtent x + 25.
	categoryChooser height: catButtonsExtent y.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 2/26/2010 00:43'!
buildScopeRadioButtons
	| label1 label2 |
	scopeRadioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	allSpritesRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	allSpritesRadioButton
		on;
		target: self;
		actionSelector: #toggleSpriteSpecific.
	label1 _ StringMorph new
		contents: ('For all sprites' localized);
		font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	scopeRadioButtons addMorphBack: allSpritesRadioButton.
	scopeRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	scopeRadioButtons addMorphBack: label1.
	scopeRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	thisSpriteRadioButton _ allSpritesRadioButton fullCopy off.
	label2 _ StringMorph new
		contents: ('For this sprite only' localized);
		font: (ScratchFrameMorph getFont: #NewVariableDialogBox).
	scopeRadioButtons addMorphBack: thisSpriteRadioButton.
	scopeRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	scopeRadioButtons addMorphBack: label2.

	ScratchTranslator isRTL
		ifTrue: [scopeRadioButtons submorphs reversed do: [:m |
			m delete.
			scopeRadioButtons addMorphBack: m]].

! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 1/11/2010 01:53'!
buildTypeChooser
	| spacer |

	spacer _ (Morph new extent: (5@5); color: Color transparent).

	radioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	commandBlockRadioButton _ ToggleButton
		onForm: self formTypeCommandOn
		offForm: self formTypeCommandOff
		overForm: self formTypeCommandOver.
	commandBlockRadioButton
		on;
		target: self;
		actionSelector: #selectCommandBlock.

	radioButtons addMorphBack: commandBlockRadioButton.
	radioButtons addMorphBack: spacer fullCopy.

	reporterBlockRadioButton _ ToggleButton
		onForm: self formTypeReporterOn
		offForm: self formTypeReporterOff
		overForm: self formTypeReporterOver.
	reporterBlockRadioButton
		off;
		target: self;
		actionSelector: #selectReporterBlock.

	radioButtons addMorphBack: reporterBlockRadioButton.
	radioButtons addMorphBack: spacer fullCopy.

	booleanBlockRadioButton _ ToggleButton
		onForm: self formTypePredicateOn
		offForm: self formTypePredicateOff
		overForm: self formTypePredicateOver.
	booleanBlockRadioButton
		off;
		target: self;
		actionSelector: #selectBooleanBlock.

	radioButtons addMorphBack: booleanBlockRadioButton.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 1/12/2010 11:11'!
disableAllButCategory

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 7/19/2010 02:14'!
disableAllButCategoryAndShape

	| keep |

	keep _ Array
				with: messageLineMorphs
				with: radioButtons.


	mainColumn submorphsDo: [: m |
		(keep includes: m)
			ifFalse: [m delete]].

	mainColumn
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);

		addMorphBack: radioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);

		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 6/28/2010 01:14'!
getUserResponse

	| newBlockSpec |
	newBlockSpec _ super getUserResponse.
	newBlockSpec size = 0 ifTrue: [^ #cancelled].
	category  = #other ifTrue: [
		category = #none ].
	^ Array with: newBlockSpec with: reporterBlockFlag with: booleanBlockFlag with: category with: spriteSpecificFlag
! !

!BlockDialog methodsFor: 'initialization' stamp: 'jens 6/28/2010 01:17'!
initialize

	super initialize.
	reporterBlockFlag _ false.
	booleanBlockFlag _ false.
	type _ #none.
	category _ #other.
	spriteSpecificFlag _ false.

	self buildTypeChooser.
	self buildCategoryChooser.
	self buildScopeRadioButtons.

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@6); color: Color transparent);
		addMorphBack: categoryChooser;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: radioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: typeinMorph;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: scopeRadioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.

	self category: category.

! !


!BlockDialog methodsFor: 'interaction' stamp: 'jens 1/29/2010 00:43'!
category: aString

	category _ aString.

	self updateTypeSelection.

	categoryChooser submorphs do: [:m |
		(m isKindOf: ResizableToggleButton2) ifTrue: [
			m arguments first = category
				ifTrue: [m on]
				ifFalse: [m off]]].

	World activeHand newKeyboardFocus: tabFields first.
! !

!BlockDialog methodsFor: 'interaction' stamp: 'jens 1/8/2010 00:50'!
disableTypeDeclaration

	radioButtons isHidden: true! !


!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/29/2010 00:42'!
setCategory: aSymbol

	#none = aSymbol ifTrue: [
		^category _ #other ].
	category _ aSymbol! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/7/2010 19:44'!
setType: aSymbol

	type _ aSymbol! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/7/2010 12:12'!
setUserSpec: aString

	userSpec _ aString! !

!BlockDialog methodsFor: 'accessing' stamp: 'jens 1/11/2010 01:42'!
updateInitialSettings

	self
		initialAnswer: userSpec;
		category: category;
		updateTypeSelection! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockDialog class
	instanceVariableNames: ''!

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 6/22/2010 22:48'!
ask: questionString
	"Put up an instance of me to ask the user for the name for a new variable."

	| dialogBox |
	dialogBox _ self new
		withButtonsForYes: false no: false okay: true cancel: true;
		title: questionString;
		message: 'category:' localized;
		extent: 330@200.
	^ dialogBox getUserResponse
! !

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 10/13/2008 13:59'!
askWithCancel: questionString initialAnswer: aString
	"Put up an instance of me to ask the user for string input (such as file name). The initial response text is set to the given string, which the user can replace or edit. This version includes a cancel button. Answer the empty string if cancelled."

	| dialogBox |
	dialogBox _ self new
		withButtonsForYes: false no: false okay: true cancel: true;
		message: questionString;
		initialAnswer: aString.
	^ dialogBox getUserResponse
! !

!BlockDialog class methodsFor: 'instance creation' stamp: 'jens 6/11/2010 00:09'!
isOpen
	self allInstancesDo: [:bd |
		bd isInWorld ifTrue: [^true]].
	^ false! !


DialogBoxMorph subclass: #BlockEditorFrameMorph
	instanceVariableNames: 'headerMorph bodyMorph hat answerField definition template receiver bin atomicityToggle resizeMorph resizeOffset '
	classVariableNames: 'UserPos UserSize '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:39'!
adjustExtentToAnswerField

	| answerExt newExt |
	answerExt _ self minExtentForAnswer.
	answerExt > self extent
		ifTrue: [ newExt _ answerExt min: World extent ]
		ifFalse: [ newExt _ self extent ].
	self extent: newExt! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:37'!
allBlocks
	| all ans |
	all _ OrderedCollection new.
	hat nextBlock ifNotNil: [
		all addAll: (hat nextBlock allMorphs select: [:m |
			m isKindOf: BlockMorph])].
	answerField ifNotNil: [
		ans _ answerField allMorphs select: [:m |
			m isKindOf: BlockMorph].
		ans size > 0 ifTrue: [
			all addAll: ans]].
	^ all! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:46'!
allBlocksFor: id
	^ self allBlocks select: [:b |
		b isCustomBlock and: [
			b id = id]]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:00'!
buildAnswerField
	| spacer ans |

	(answerField isKindOf: ReporterBlockDropTargetMorph) ifTrue: [
		mainColumn replaceSubmorph: answerField 
						by: (answerField _ Morph new extent: 0@0)].		

	spacer _ answerField.
	#none = definition type
		ifTrue: [^ self].
	ans _ definition answer.
	(ans isKindOf: BlockMorph)
		ifTrue: [ans refreshAttributeArgs].
	#boolean = definition type
		ifTrue: [answerField _ ReporterBlockDropTargetMorph booleanLabelled: 'report' localized argument: ans]
		ifFalse: [
			ans ifNil: [ans _ 'something' localized ].
			answerField _ ReporterBlockDropTargetMorph labelled: 'report' localized argument: ans].
	mainColumn replaceSubmorph: spacer by: answerField.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/19/2010 02:46'!
buildAtomicityToggle

	| labelFont  |

	atomicityToggle ifNotNil: [atomicityToggle delete].

	labelFont _ (ScratchFrameMorph getFont: #UploadTagLabel).

	atomicityToggle _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #watcherButtonPressed)
		offForm: (ScratchFrameMorph skinAt: #watcherButton).

	atomicityToggle
		target: self;
		width: 80;
		actionSelector: #toggleAtomicity;
		borderWidth: 0;
		label: 'atomic' localized
		font: labelFont;
		setLabelColor: (Color gray: 0.3);

		setProperty: #balloonText toValue: 'execute as single block' localized.

	mainColumn addMorph: atomicityToggle.
	atomicityToggle on. 
	self updateAtomicityToggle.

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/3/2010 16:26'!
buildScript
	|nb b|
	nb _ hat nextBlock.
	nb ifNotNil: [nb delete].	
	definition body ifNotNil: [
		b _ definition body fullCopy.
		b refreshAttributeArgs.
		b position: hat position.
		hat nextBlock: b]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 00:01'!
cascade
	| sf match findMatch |
	sf _ self scratchFrame.
	sf purgeBlockEditors.
	findMatch _ [ match _ sf blockEditors detect: [:editor |
		editor ~= self and: [
			editor position = self position]]
		ifNone: [nil]].
	findMatch value.
	[match isNil] whileFalse: [
		self position: match position + (0@20).
		findMatch value]! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:36'!
centerOnScreen

	super centerOnScreen.
	self updateResizeMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/5/2010 03:15'!
definition
	^definition! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 23:34'!
definition: aCustomBlockDefinition

	| def |
	def _ aCustomBlockDefinition.

	hat ifNotNil: [
		def body: hat nextBlock.
		hat delete ].

	(answerField isKindOf: ReporterBlockDropTargetMorph) ifTrue: [
		def type = #none
			ifTrue: [def answer: nil]
			ifFalse: [def answer: answerField argument]].

	definition _ def.
	template _ receiver newCustomBlockFor: def.
	template isTemplate: true.
	template addLabel.
	hat _ ProcedureHatBlockMorph on: template.
	bin addMorph:(hat position: bin position + (10@10)).

	self buildScript.
"	self buildVariables."
	self buildAtomicityToggle.
	self buildAnswerField.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:41'!
extent: aPoint
	
	| w newExtent min|

	min _ self class minExtent max: self minExtentForAnswer.

	newExtent _ aPoint max: min.

	bounds extent = newExtent ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: newExtent.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: newExtent.

	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [ aPoint = self extent ifFalse: [
			self position: w center - (self extent // 2)]]].  "center on screen"

	self keepOnScreen
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:49'!
fixLayoutForExtent: aPoint

	| bFrame bScroller |

	super fixLayoutForExtent: aPoint.

	titleBin ifNotNil: [ titleBin width: aPoint x " - 40" ].

	bin ifNil: [^ self].

	bScroller _ bin owner.
	bFrame _ bScroller owner.

	bFrame extent: aPoint - (70 @ (120 + answerField height)).
	bScroller extent: bFrame extent.

	self updateResizeMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 01:15'!
getUserResponse
	"Wait for the user to respond, then report their response. The symbol #cancel is returned if the user wishes to cancel the operation. True/false is returned if they respond yes/no, and a string is returned if this this a string input dialog and they don't cancel."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	self openInWorld.

	UserPos isNil 
		ifTrue: [ self centerOnScreen ]
		ifFalse: [self snapToUserDimensions ].
	self cascade.
		
	w _ self world.
	self buttons size > 0 ifTrue: [
		w activeHand newKeyboardFocus: self buttons last].
	tabFields size > 0 ifTrue: [
		w activeHand newKeyboardFocus: (tabFields at: 1)].

	done _ false.
	[done] whileFalse: [w doOneCycle].  "wait for user to press a button"

	^ response
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/18/2009 23:58'!
handlesMouseDown: evt
	^true! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2010 00:33'!
hat
	^hat! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:33'!
initialize
	| line container sl |

	super initialize.
	self title: 'Block Editor' localized.
	resizeMorph _ ScratchResizeMorph ofType: #corner.
	line _ AlignmentMorph newRow
		color: Color transparent.

	answerField _ Morph new extent: 0@0.
	mainColumn addMorph: answerField.
	mainColumn addMorph: line.

	container _ Morph new 	color: Color transparent.

	sl _ ScrollFrameMorph2 new
		growthFraction: 0.0;
		color: ScratchFrameMorph scriptsPaneColor.

	bin _ ScratchScriptsMorph new.
	sl contents: bin.

	line addMorphBack: container.

	sl extent: container extent.
	container addMorph: sl.

	self addMorph: resizeMorph.


! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2010 01:53'!
instancesOf: aCustomBlockId

	| binInstances ansInstances |
	binInstances _ bin allMorphs select: [:m|
		((m isKindOf: CustomCommandBlockMorph) or: [
			m isKindOf: CustomReporterBlockMorph]) and: [
				m id = aCustomBlockId]].
	#none = definition type 
		ifTrue: [^binInstances ].
	(answerField argument isKindOf: BlockMorph) ifFalse: [
		^ binInstances].
	ansInstances _ answerField argument allMorphs select: [:m|
		(m isKindOf: CustomReporterBlockMorph) and: [
		m id = aCustomBlockId]].

	^binInstances, ansInstances
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:09'!
justDroppedInto: aMorph event: evt
	"Never embed myself in a morph (e.g. the Stage)."

	super justDroppedInto: aMorph event: evt.
	self keepOnScreen
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:17'!
keepOnScreen

	| min |
	min _ self class minExtent max: self minExtentForAnswer.

	self left < 0 ifTrue: [ self left: 0].
	self top < 0 ifTrue: [ self top: 0].

	self right > Display extent x
		ifTrue: [ resizeOffset 
			ifNil: [ 
				self left: ((Display extent x - self width) max: 0).
				(self right > Display extent x and: [self width > min x])
					ifTrue: [self width: Display extent x - self left ]]
			ifNotNil: [self width: Display extent x - self left]].

	self bottom > Display extent y
		ifTrue: [ resizeOffset 
			ifNil: [	
				self top: ((Display extent y - self height) max: 0). 
				(self bottom > Display extent y and: [self height > min y])
					ifTrue: [self height: Display extent y - self top]]
			ifNotNil: [self height: Display extent y - self top]].

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:37'!
minExtentForAnswer
	answerField ifNil: [^self class minExtent].
	^ answerField extent + (60 @ 180) min: World extent.
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:03'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p |
	p _ evt cursorPoint.
	((resizeMorph bounds expandBy: 4) containsPoint: p)
		ifFalse: [evt hand grabMorph: self]
		ifTrue: [resizeOffset _ self bottomRight - p]
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:12'!
mouseMove: evt

	resizeOffset ifNotNil: [
		self extent: (evt cursorPoint - self topLeft) + resizeOffset ]

! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/19/2009 00:03'!
mouseUp: evt

	resizeOffset _ nil.
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 23:58'!
position: aPoint

	super position: aPoint.! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 13:12'!
receiver: aScriptableScratchMorph
	receiver _ aScriptableScratchMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:59'!
rememberUserDimensions
	self class setUserPos: self position size: self extent! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 18:36'!
scratchFrame
	^receiver ownerThatIsA: ScratchFrameMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2010 01:15'!
snapToUserDimensions

	self extent: UserSize.
	UserPos ifNotNil: [
		self position: UserPos ].
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 09:32'!
step
	resizeOffset notNil | (owner isKindOf: HandMorph)
		ifTrue: [^self ].
	self keepOnScreen 
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 22:58'!
template
	^template! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 15:10'!
toggleAtomicity
	definition toggleAtomicity.
	self updateAtomicityToggle
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 18:40'!
topArgMorphAt: aRectangle exclude: aMorph
	"Give feedback about possible drop targets."

	(answerField isKindOf: ReporterBlockDropTargetMorph) 
		ifFalse: [^nil].
	^answerField topArgMorphAt: aRectangle exclude: aMorph! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/18/2009 23:37'!
updateAtomicityToggle
	definition isAtomic
		ifTrue: [atomicityToggle on]
		ifFalse: [atomicityToggle off].
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:33'!
updateResizeMorph
	resizeMorph ifNotNil: [
		resizeMorph position: self bottomRight - bottomRightForm width ]
! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 18:40'!
wantsDroppedMorph: aMorph event: evt

	(answerField isKindOf: ReporterBlockDropTargetMorph) 
		ifFalse: [^false].
	^answerField wantsDroppedMorph: aMorph event: evt	! !

!BlockEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2011 03:13'!
yes
	"Yes button was pressed."
	| stage sf |

	self rememberUserDimensions.
	self allMorphs do: [:each| 
		(each isKindOf: BlockMorph) ifTrue: [ each litUp: false].
		(each isKindOf: StringFieldMorph) ifTrue: [each keyboardFocusChange: false]].
	definition body: hat nextBlock.
	#none = definition type ifFalse: [
		definition answer: answerField argument ].

	stage _ receiver ownerThatIsA: ScratchStageMorph.
	receiver
		updateCustomBlockDefinitionId: definition id with: definition;
		updateLocalId: definition id withSpec: definition userSpec.

	(definition isGlobal not and: [stage notNil])
		ifFalse: [
			(stage sprites, {stage} copyWithout: receiver) do: [:obj |
				obj
					updateCustomBlockDefinitionId: definition id with: definition;
					updateOnlyLocalId: definition id withSpec: definition userSpec]].	

	sf _ receiver ownerThatIsA: ScratchFrameMorph.
	sf viewerPane categoryChanged: 'variables'.
	#none = definition category ifFalse: [
		sf viewerPane categoryChanged: definition category asString ].
	^ super yes
		
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockEditorFrameMorph class
	instanceVariableNames: ''!

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:35'!
initialize
	"BlockEditorFrameMorph initialize"
	self resetDimensions! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 9/15/2010 00:41'!
minExtent
	^400 @ 300.! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/21/2009 00:34'!
resetDimensions
	UserPos _ nil.
	UserSize _ self minExtent.! !

!BlockEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:56'!
setUserPos: aPoint size: anExtent
	UserPos _ aPoint.
	UserSize _ anExtent.! !


Object subclass: #BlockLabelFragment
	instanceVariableNames: 'label type isInput default isDeleted '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
default
	^ default! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
default: aValue
	default _ aValue! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
delete
	isDeleted _ true! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
initialize

	super initialize.
	isDeleted _ false.
	label _ ''.
	isInput _ false.
	type _ #any.
	default _ ''! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 05:06'!
isDeleted
	^ isDeleted! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
isInput
	^ isInput! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
isInput: aBool
	isInput _ aBool! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 4/18/2010 23:03'!
isLoop

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type = #loop! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:07'!
isMultipleInput

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type endsWith: 'List'! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 20:41'!
isTemplate

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type = #template! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 7/27/2010 01:00'!
isUnevaluated

	isInput ifFalse: [^ false].
	type ifNil: [^ false].
	^ type beginsWith: 'unevaluated'! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:23'!
label
	^label! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 4/27/2010 22:21'!
label: aString

	label _ aString
! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 02:19'!
spec
	| spec |
	isDeleted ifTrue: [^''].
	isInput ifFalse: [^ label].
	label isEmpty ifTrue: [^ label].
	spec _ '%', label asMacRoman. 
	(spec includes: $ ) ifTrue: [
		^ (String with: $"), spec, (String with: $")].
	^spec asUTF8

! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:24'!
type
	^type! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:14'!
type: aSymbol
	type _ aSymbol! !

!BlockLabelFragment methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 00:15'!
updateLabel

	"make sure an ellipsis (...) is added to the label
	if I am a multiple input type - unused for now"

	(self isMultipleInput and: [
		(label endsWith: '...') not]) ifTrue: [
			label _ label, '...'.
			^ self].

	(label endsWith: '...') ifTrue: [
		label _ label copyFrom: 1 to: label size - 3]! !


StringDialog subclass: #BlockLabelFragmentDialog
	instanceVariableNames: 'fragment inputRadioButton textRadioButton slotShapeButton fragmentRadioButtons category isCollapsed slotShapesGroup groupExtent radioObject radioAny radioNumber radioText radioBoolean radioList radioCommand radioReporter radioPredicate radioLoop radioUnevaluated radioUnevaluatedBoolean defaultLabel defaultField divBar singleRadioButton multipleRadioButton externalizedRadioButton '
	classVariableNames: 'Expanded '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockLabelFragmentDialog methodsFor: 'private' stamp: 'jens 1/19/2010 01:39'!
extent: aPoint
	
	bounds extent = aPoint ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: aPoint.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: aPoint.

"	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [self position: w center - (self extent // 2)]]."  "center on screen"
! !

!BlockLabelFragmentDialog methodsFor: 'private' stamp: 'jens 3/5/2010 01:01'!
shouldBeExpanded
	^self class isExpanded! !


!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 2/14/2011 02:03'!
buildSlotTypeChoices
	 | lineObject lineAny lineNumber lineText lineBoolean lineList lineCommand lineReporter linePredicate lineLoop lineUnevaluated lineUnevaluatedBoolean
	picture label typeChooser picSize lineWidth typeLabel typeFont bg titleClr labelClr labelSingle
	labelMultiple labelExternalized temp onForm offForm|

	onForm _  ScratchFrameMorph skinAt: #radioButtonOn.
	offForm _ ScratchFrameMorph skinAt: #radioButton.
"
	onForm _  ScratchFrameMorph skinAt: #watcherButtonPressed.
	offForm _ ScratchFrameMorph skinAt: #watcherButton.
"
	picSize _ 45@25.
	lineWidth _ 155 "125".
	titleClr _ Color gray muchLighter.
	labelClr _ Color white.

	typeChooser _ ImageFrameMorph new.
	bg _ (ScratchFrameMorph skinAt:  #paintOptionsBackground) deepCopy.
	bg replaceColor: (bg colorAt: bg center) with: ScratchFrameMorph palettePaneColor.
	typeChooser initFromForm: bg.
	typeChooser extent: (lineWidth + 20) * 3 @ (picSize y * 9).

	typeFont _ ScratchFrameMorph getFont: #FilePickerEntry.

	typeLabel _ ((StringMorph contents: 'Input type/Shape of slot:' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: typeChooser position + (15@14);
		yourself).

	typeChooser addMorph: typeLabel.

"+++++++++++  object ++++++++++++++++"

	radioObject _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioObject
		off;
		target: self;
		actionSelector: #typeObject;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #object size: picSize).
	label _ (StringMorph contents: 'Object' localized font: typeFont)
		color: labelClr.
	lineObject _ Morph new color: Color transparent.
	lineObject extent: lineWidth @ picSize y.
	picture left: radioObject right.
	label left: picture right; top: 4.
	lineObject
		addMorph: radioObject;
		addMorph: picture;
		addMorph: label.
	lineObject position: typeLabel bottomLeft + (0@10).
	typeChooser addMorph: lineObject.	

"+++++++++++  number ++++++++++++++++"

	radioNumber _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioNumber
		off;
		target: self;
		actionSelector: #typeNumber;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #number size: picSize).
	label _ (StringMorph contents: 'Number' localized font: typeFont)
		color: labelClr.
	lineNumber _ Morph new color: Color transparent.
	lineNumber extent: lineWidth @ picSize y.
	picture left: radioNumber right.
	label left: picture right; top: 4.
	lineNumber
		addMorph: radioNumber;
		addMorph: picture;
		addMorph: label.
	lineNumber position: lineObject bottomLeft.
	typeChooser addMorph: lineNumber.	

"++++++++++++++  text  +++++++++++++"

	radioText _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioText
		off;
		target: self;
		actionSelector: #typeText;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #text size: picSize).
	label _ (StringMorph contents: 'Text' localized font: typeFont)
		color: labelClr.
	lineText _ Morph new color: Color transparent.
	lineText extent: lineWidth @ picSize y.
	picture left: radioText right.
	label left: picture right; top: 4.
	lineText
		addMorph: radioText;
		addMorph: picture;
		addMorph: label. 
	lineText position: lineObject topRight + (10@0).
	typeChooser addMorph: lineText.	

"++++++++++++  list  +++++++++++++++"

	radioList _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioList
		off;
		target: self;
		actionSelector: #typeList;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #list size: picSize).
	label _ (StringMorph contents: 'List' localized font: typeFont)
		color: labelClr.
	lineList _ Morph new color: Color transparent.
	lineList extent: lineWidth @ picSize y.
	picture left: radioList right.
	label left: picture right; top: 4.
	lineList
		addMorph: radioList;
		addMorph: picture;
		addMorph: label. 
	lineList position: lineText topRight + (10@0).
	typeChooser addMorph: lineList.	

"++++++++++++  any  +++++++++++++++"
	
	radioAny _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioAny
		off;
		target: self;
		actionSelector: #typeAny; 
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #any size: picSize).
	label _ (StringMorph contents: 'Any type' localized font: typeFont)
		color: labelClr.
	lineAny _ Morph new color: Color transparent.
	lineAny extent: lineWidth @ picSize y.
	picture left: radioAny right.
	label left: picture right; top: 4.
	lineAny
		addMorph: radioAny;
		addMorph: picture;
		addMorph: label. 
	lineAny position: lineText bottomLeft.
	typeChooser addMorph: lineAny.	

"++++++++++++  bool  +++++++++++++++"

	radioBoolean _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioBoolean
		off;
		target: self;
		actionSelector: #typeBoolean;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #boolean size: picSize).
	label _ (StringMorph contents: 'Boolean (T/F)' localized font: typeFont)
		color: labelClr.
	lineBoolean _ Morph new color: Color transparent.
	lineBoolean extent: lineWidth @ picSize y.
	picture left: radioBoolean right.
	label left: picture right; top: 4.
	lineBoolean
		addMorph: radioBoolean;
		addMorph: picture;
		addMorph: label. 
	lineBoolean position: lineList bottomLeft.
	typeChooser addMorph: lineBoolean.	

"++++++++++++  command  +++++++++++++++"

	radioCommand _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioCommand
		off;
		target: self;
		actionSelector: #typeCommand;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #command size: picSize).
	label _ (StringMorph contents: 'Command (inline)' localized font: typeFont)
		color: labelClr.
	lineCommand _ Morph new color: Color transparent.
	lineCommand extent: lineWidth @ picSize y.
	picture left: radioCommand right.
	label left: picture right; top: 4.
	lineCommand
		addMorph: radioCommand;
		addMorph: picture;
		addMorph: label. 
	lineCommand position: lineNumber left @ lineAny bottom.
	typeChooser addMorph: lineCommand.	

"+++++++++++  reporter  ++++++++++++++++"

	radioReporter _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioReporter
		off;
		target: self;
		actionSelector: #typeReporter;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #reporter size: picSize).
	label _ (StringMorph contents: 'Reporter' localized font: typeFont)
		color: labelClr.
	lineReporter _ Morph new color: Color transparent.
	lineReporter extent: lineWidth @ picSize y.
	picture left: radioReporter right.
	label left: picture right; top: 4.
	lineReporter
		addMorph: radioReporter;
		addMorph: picture;
		addMorph: label. 
	lineReporter position: lineAny bottomLeft.
	typeChooser addMorph: lineReporter.	

"+++++++++++  predicate  ++++++++++++++++"

	radioPredicate _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioPredicate
		off;
		target: self;
		actionSelector: #typePredicate;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #predicate size: picSize).
	label _ (StringMorph contents: 'Predicate' "(Reporter of Boolean)" localized font: typeFont)
		color: labelClr.
	linePredicate _ Morph new color: Color transparent.
	linePredicate extent: lineWidth @ picSize y.
	picture left: radioPredicate right.
	label left: picture right; top: 4.
	linePredicate
		addMorph: radioPredicate;
		addMorph: picture;
		addMorph: label. 
	linePredicate position:  lineBoolean bottomLeft. 
	typeChooser addMorph: linePredicate.

"+++++++++++++  command (C-shape)  ++++++++++++++"

	radioLoop _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioLoop
		off;
		target: self;
		actionSelector: #typeLoop;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #loop size: picSize).
	label _ (StringMorph contents: 'C-shape' localized font: typeFont)
		color: labelClr.
	lineLoop _ Morph new color: Color transparent.
	lineLoop extent: lineWidth @ picSize y.
	picture left: radioLoop right.
	label left: picture right; top: 4.
	lineLoop
		addMorph: radioLoop;
		addMorph: picture;
		addMorph: label. 
	lineLoop position: lineCommand bottomLeft.
	typeChooser addMorph: lineLoop.

"++++++++++++++  any (unevaluated)  +++++++++++++"

	radioUnevaluated _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioUnevaluated
		off;
		target: self;
		actionSelector: #typeUnevaluated;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #unevaluated size: picSize).
	label _ (StringMorph contents: 'Any (unevaluated)' localized font: typeFont)
		color: labelClr.
	lineUnevaluated _ Morph new color: Color transparent.
	lineUnevaluated extent: lineWidth @ picSize y.
	picture left: radioUnevaluated right.
	label left: picture right; top: 4.
	lineUnevaluated
		addMorph: radioUnevaluated;
		addMorph: picture;
		addMorph: label. 
	lineUnevaluated position: lineReporter bottomLeft.
	typeChooser addMorph: lineUnevaluated.	

"++++++++++++++  boolean (unevaluated)  +++++++++++++"

	radioUnevaluatedBoolean _ ToggleButton
		onForm: onForm
		offForm: offForm.
	radioUnevaluatedBoolean
		off;
		target: self;
		actionSelector: #typeUnevaluatedBoolean;
		top: 6.
	picture _ ImageMorph new form: (self slotShapeFormFor: #unevaluatedBoolean size: picSize).
	label _ (StringMorph contents: 'Boolean (unevaluated)' localized font: typeFont)
		color: labelClr.
	lineUnevaluatedBoolean _ Morph new color: Color transparent.
	lineUnevaluatedBoolean extent: lineWidth @ picSize y.
	picture left: radioUnevaluatedBoolean right.
	label left: picture right; top: 4.
	lineUnevaluatedBoolean
		addMorph: radioUnevaluatedBoolean;
		addMorph: picture;
		addMorph: label. 
	lineUnevaluatedBoolean position: linePredicate bottomLeft.
	typeChooser addMorph: lineUnevaluatedBoolean.	

"+++++++++++++++++++++++++++"

	divBar _ ImageMorph new form: (ScratchFrameMorph skinAt: #connector).
	divBar 
		top: lineLoop bottom + 5;
		left: "lineReporter left "typeChooser left + (typeChooser width - (divBar width * 3) // 3).
	typeChooser addMorph: divBar.

	temp _ divBar deepCopy.
	temp position: divBar topRight.
	typeChooser addMorph: temp.

	temp _ divBar deepCopy.
	temp position: divBar topRight + (temp width @ 0).
	typeChooser addMorph: temp.


	singleRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	singleRadioButton
		on;
		target: self;
		actionSelector: #aritySingle;
		position: lineLoop left @ (divBar bottom + 9).
	typeChooser addMorph: singleRadioButton.	

	labelSingle _ ((StringMorph contents: 'Single input.' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: singleRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelSingle.

	defaultLabel _ ((StringMorph contents: 'Default value:' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: labelSingle topRight + (10@0);
		yourself).
	typeChooser addMorph: defaultLabel.

	typeChooser
		addMorph: (defaultField _ StringFieldMorph
			new client: self;
			borderWidth: 2;
			color: "Color lightGray twiceLighter "(Color r: (211/255) g: (214/255) b: (216/255))).
	defaultField
		font: typeFont;
		width: lineWidth;
		position: defaultLabel topRight + (10@-4);
		isNumeric: fragment default isNumber;
		contents: fragment default asString.

	groupExtent _ typeChooser extent.
	slotShapesGroup _ typeChooser.

	multipleRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	multipleRadioButton
		off;
		target: self;
		actionSelector: #arityMultiple;
		position: singleRadioButton bottomLeft + (0@6).
	typeChooser addMorph: multipleRadioButton.	

	labelMultiple _ ((StringMorph contents: 'Multiple inputs (value is list of inputs)' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: multipleRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelMultiple.

	externalizedRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	externalizedRadioButton
		off;
		target: self;
		actionSelector: #externalized;
		position: multipleRadioButton bottomLeft + (0@6).
	typeChooser addMorph: externalizedRadioButton.	

	labelExternalized _ ((StringMorph contents: 'Make internal variable visible to caller' localized font: (ScratchFrameMorph getFont: #Label))
		color: titleClr;
		position: externalizedRadioButton topRight + (4@0);
		yourself).
	typeChooser addMorph: labelExternalized.

! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 1/21/2010 01:29'!
buildWidgets


	| titleLabel inputLabel |
	fragmentRadioButtons _ AlignmentMorph newRow
		color: Color transparent;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.

	textRadioButton _ ToggleButton
		onForm: (ScratchFrameMorph skinAt: #radioButtonOn)
		offForm: (ScratchFrameMorph skinAt: #radioButton).
	textRadioButton
		on;
		target: self;
		actionSelector: #toggleIsInput.

	titleLabel _ ImageMorph new form: self labelButtonForm.
	fragmentRadioButtons addMorphBack: textRadioButton.
	fragmentRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	fragmentRadioButtons addMorphBack: titleLabel.
	fragmentRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	inputRadioButton _ textRadioButton fullCopy off.
	inputLabel _ ImageMorph new form: self inputButtonForm.
	fragmentRadioButtons addMorphBack: inputRadioButton.
	fragmentRadioButtons addMorphBack: (Morph new extent: (5@5); color: Color transparent).
	fragmentRadioButtons addMorphBack: inputLabel "label2".


	fragmentRadioButtons addMorphBack: (Morph new extent: (15@5); color: Color transparent).

	slotShapeButton _ IconicButton new
		labelGraphic: (ScratchFrameMorph skinAt: #arrowOpenComment) borderWidth: 0;
		actionSelector: #toggleExpand;
		target: self;
		actWhen: #buttonDown.
	fragmentRadioButtons addMorphBack: slotShapeButton.

	self buildSlotTypeChoices.

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].
	mainColumn
		addMorphBack: (Morph new extent: (5@6); color: Color transparent);
		addMorphBack: typeinMorph;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: fragmentRadioButtons;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: slotShapesGroup;
		addMorphBack: (Morph new extent: (5@7); color: Color transparent);
		addMorphBack: buttonRow;
		addMorphBack: bottomSpacer.

! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 1/19/2010 01:45'!
initialize

	super initialize.
	category _ #none.
	isCollapsed _ false


! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 2/15/2010 03:40'!
refresh

	self
		setInitialValues;
		updateInputRadioButtons;
		updateArity;
		updateSlotShape;
		withButtonsForYes: false no: false okay: true delete: (fragment label size > 0) cancel: true! !

!BlockLabelFragmentDialog methodsFor: 'initialization' stamp: 'jens 6/7/2010 23:18'!
setInitialValues

	fragment isInput 
		ifTrue: [ 
			fragment label isEmpty
				ifTrue: [ self message: 'Create input name' localized]
				ifFalse: [ self message: 'Edit input name' localized].
			self initialAnswer: (UTF8 withAll: fragment label asMacRoman)]
		ifFalse: [ 
			fragment label isEmpty
				ifTrue: [ self message: 'Create label fragment' localized]
				ifFalse: [ self message: 'Edit label fragment' localized].
			self initialAnswer: fragment label]
! !


!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:52'!
acceptDefaultValue

	| cnts |

	(#(any number text unevaluated) includes: fragment type) 
		ifFalse: [ 
			fragment default: ''. 
			^ self].
		
	#number = fragment type 
		ifTrue: [
			cnts _ defaultField contents.
			cnts = ' ' asUTF8
				ifTrue: [ fragment default: cnts ]
				ifFalse: [ fragment default: cnts asNumberNoError ]]
		ifFalse: [fragment default: defaultField contents asString ]
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
arityMultiple

	singleRadioButton off.
	multipleRadioButton on.
	externalizedRadioButton off.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
aritySingle

	singleRadioButton on.
	multipleRadioButton off.
	externalizedRadioButton off.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/12/2010 05:08'!
deleteItem
	"Delete button was pressed."

	fragment delete.
	response _ fragment.
	done _ true.
	self delete.
	World doOneCycle.  "erase myself from the screen"
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 22:35'!
externalized

	singleRadioButton off.
	multipleRadioButton off.
	externalizedRadioButton on.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/5/2010 01:38'!
getUserResponse

	| txt |
	txt _ super getUserResponse.
	txt size = 0 ifTrue: [^ #cancelled].
	self acceptDefaultValue.
	self class isExpanded: isCollapsed not.
	^ fragment label: txt; yourself
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/27/2010 18:09'!
toggleExpand

	isCollapsed _ isCollapsed not.

	isCollapsed
		ifTrue: [slotShapeButton labelGraphic: (ScratchFrameMorph skinAt: #arrowClosedComment) ]
		ifFalse: [slotShapeButton labelGraphic: (ScratchFrameMorph skinAt: #arrowOpenComment)].

	mainColumn submorphsDo: [: m |
		((m = messageLineMorphs) not) ifTrue: [m delete]].

	isCollapsed
		ifTrue: [ mainColumn
			addMorphBack: (Morph new extent: (5@6); color: Color transparent);
			addMorphBack: typeinMorph;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: fragmentRadioButtons;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: buttonRow;
			addMorphBack: bottomSpacer]
		ifFalse: [ mainColumn
			addMorphBack: (Morph new extent: (5@6); color: Color transparent);
			addMorphBack: typeinMorph;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: fragmentRadioButtons;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: slotShapesGroup;
			addMorphBack: (Morph new extent: (5@7); color: Color transparent);
			addMorphBack: buttonRow;
			addMorphBack: bottomSpacer].

	self extent: mainColumn fullBounds extent + (60@50).

	fragment isInput ifTrue: [self class isExpanded: isCollapsed not].
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/20/2010 02:46'!
toggleExpandIfInput

	self toggleExpand.
	fragment isInput ifFalse: [
		self toggleExpand ]! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/20/2010 13:49'!
toggleIsInput

	fragment isInput: fragment isInput not.
	self updateInputRadioButtons

! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:11'!
typeAny
	fragment type: #any.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeBoolean
	fragment type: #boolean.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:13'!
typeCommand
	fragment type: #command.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeList
	fragment type: #list.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/11/2010 23:14'!
typeLoop
	fragment type: #loop.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:11'!
typeNumber
	fragment type: #number.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 2/14/2011 02:05'!
typeObject
	fragment type: #object.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:13'!
typePredicate
	fragment type: #predicate.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/5/2010 22:54'!
typeReporter
	fragment type: #reporter.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/5/2010 22:53'!
typeReporterSlot
	fragment type: #reporterSlot.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 1/19/2010 23:12'!
typeText
	fragment type: #text.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/8/2010 22:04'!
typeTypeInReporter
	fragment type: #typeInReporter.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:20'!
typeUnevaluated
	fragment type: #unevaluated.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/23/2010 01:01'!
typeUnevaluatedBoolean
	fragment type: #unevaluatedBoolean.
	self updateSlotShape
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 3/9/2010 23:19'!
updateArity

	fragment type = #template
		ifTrue: [
			singleRadioButton off.
			multipleRadioButton off.
			externalizedRadioButton on.
			^ self].

	(fragment type endsWith: 'List')
		ifTrue: [
			multipleRadioButton on.
			singleRadioButton off.
			externalizedRadioButton off]
		ifFalse: [
			singleRadioButton on.
			multipleRadioButton off.
			externalizedRadioButton off]
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 7/20/2010 22:21'!
updateDefaultValue

	| dat |

	(#(any number text unevaluated) includes: fragment type)
		ifFalse: [
			(Array with: defaultLabel with: defaultField) do: [:m |
				m isHidden: true ].
			^ self ].

	dat _ defaultField contents.

	{defaultLabel. defaultField} do: [:m |
		m isHidden: false ].

	#number = fragment type ifTrue: [
		defaultField isNumeric: true.
		(dat = ' ' asUTF8 or: [dat = '' asUTF8])
			ifTrue: [ defaultField contents: ' ' asUTF8 ]
			ifFalse: [ defaultField contents: dat asNumberNoError printString].
		^ self ].

	defaultField
		isNumeric: false.
! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 4/27/2010 18:16'!
updateInputRadioButtons

	fragment isInput 
		ifTrue: [
			inputRadioButton on.
			textRadioButton off.
			slotShapeButton
				isHidden: false;
				isLocked: false.
			self shouldBeExpanded
				ifTrue: [self toggleExpand]]
		ifFalse: [
			textRadioButton on.
			inputRadioButton off.
			slotShapeButton
				isHidden: true;
				lock.
			isCollapsed ifFalse: [
				self toggleExpand]]! !

!BlockLabelFragmentDialog methodsFor: 'interaction' stamp: 'jens 2/14/2011 02:06'!
updateSlotShape

	| type types |

	singleRadioButton isOn ifTrue: [
		fragment type = #template ifTrue: [
			fragment type: #any].
		(fragment type endsWith: 'List') ifTrue: [
			fragment type: (fragment type copyFrom: 1 to: fragment type size - 'List' size) asSymbol]].

	multipleRadioButton isOn ifTrue: [
		fragment type = #template ifTrue: [
			fragment type: #any].
		(fragment type endsWith: 'List') ifFalse: [
			fragment type: (fragment type, 'List') asSymbol]].

	externalizedRadioButton isOn ifTrue: [
		fragment type: #template ].

	types _ Dictionary new.
	types
		at: #any put: radioAny;
		at: #number put: radioNumber;
		at: #text put: radioText;
		at: #boolean put: radioBoolean;
		at: #list put: radioList;
		at: #command put: radioCommand;
		at: #reporter put: radioReporter;
		at: #predicate put: radioPredicate;
		at: #loop put: radioLoop;
		at: #template put: radioAny;
		at: #unevaluated put: radioUnevaluated;
		at: #unevaluatedBoolean put: radioUnevaluatedBoolean;
		at: #object put: radioObject.

	types
		at: #anyList put: radioAny;
		at: #numberList put: radioNumber;
		at: #textList put: radioText;
		at: #booleanList put: radioBoolean;
		at: #listList put: radioList;
		at: #commandList put: radioCommand;
		at: #reporterList put: radioReporter;
		at: #predicateList put: radioPredicate;
		at: #loopList put: radioLoop;
		at: #unevaluatedList put: radioUnevaluated;
		at: #unevaluatedBooleanList put: radioUnevaluatedBoolean;
		at: #objectList put: radioObject.

	type _ fragment type.

	types keysDo: [:key |
		(types at: key) isHidden: true; off].

	types keysDo: [:key |
		#template = type ifFalse: [
			(types at: key) isHidden: false].
		type = key
			ifTrue: [(types at: key) on]].

	self updateDefaultValue! !


!BlockLabelFragmentDialog methodsFor: 'accessing' stamp: 'jens 1/17/2010 20:55'!
category: aSymbol
	category _ aSymbol! !

!BlockLabelFragmentDialog methodsFor: 'accessing' stamp: 'jens 1/12/2010 03:13'!
fragment: aBlockLabelFragment
	fragment _ aBlockLabelFragment! !


!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'jens 8/2/2010 21:50'!
inputButtonForm
	| bg block |
	block _ VariableBlockMorph new commandSpec: 'Input name' localized; color: (ScriptableScratchMorph blockColorFor: 'variables').
	bg _ LabelFragmentBlockMorph new commandSpec: '%i'; color: (ScriptableScratchMorph blockColorFor: category asString).
	bg replaceArgMorph: bg argMorphs first by: block.
	^bg imageForm! !

!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'jens 5/17/2010 01:47'!
labelButtonForm

	| block |

	block _ LabelFragmentBlockMorph new 
		color: (ScriptableScratchMorph blockColorFor: category asString);
		commandSpec: 'Title text' localized.

	^block imageForm
! !

!BlockLabelFragmentDialog methodsFor: 'drawing' stamp: 'jens 2/14/2011 01:59'!
slotShapeFormFor: type size: aPoint

	| specs block slot morph img |

	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #reporter put: '%r';
		at: #predicate put: '%p';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #unevaluatedBoolean put: '%Q';
		at: #object put: '%1'.

	block _ LabelFragmentBlockMorph new
		color: (ScriptableScratchMorph blockColorFor: category asString); 
		commandSpec: '_', (specs at: type), '_'.

	(#(predicate boolean unevaluatedBoolean reporter typeInReporter command text loop reporterSlot) includes: type) ifTrue: [
		block commandSpec: (specs at: type)].

	slot _ block argMorphs first.
	#number = type ifTrue: [
		slot numExpression: ''].	

	block fixBlockLayout.
	img _ ImageMorph new form: block imageForm.

	morph _ Morph new color: Color transparent; extent: aPoint.
	morph addMorph: img.
	img position: morph position + (morph extent - img extent // 2).
	^ morph imageForm
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BlockLabelFragmentDialog class
	instanceVariableNames: ''!

!BlockLabelFragmentDialog class methodsFor: 'instance creation' stamp: 'jens 2/25/2010 23:05'!
on: aBlockLabelFragment category: aSymbol
	"Put up an instance of me to ask the user for the name for a new variable."

	| dialogBox |
	(World allMorphs detect: [:m | m isKindOf: self] ifNone: [nil])
		ifNotNil: [^self].
	dialogBox _ self new
		category: aSymbol;
		fragment: aBlockLabelFragment;
		buildWidgets;
		refresh;
		toggleExpandIfInput.
	^ dialogBox getUserResponse
! !


!BlockLabelFragmentDialog class methodsFor: 'accessing' stamp: 'jens 3/17/2010 22:32'!
isExpanded
	"currently disabled - commented out, -jens"

	^ false "Expanded"! !

!BlockLabelFragmentDialog class methodsFor: 'accessing' stamp: 'jens 3/5/2010 01:01'!
isExpanded: bool
	Expanded _ bool! !


!BlockLabelFragmentDialog class methodsFor: 'class initialization' stamp: 'jens 3/5/2010 01:05'!
initialize
	Expanded _ false! !


StringMorph subclass: #BlockLabelFragmentMorph
	instanceVariableNames: 'labelFragment '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 03:37'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 00:09'!
handlesMouseOver: evt

	^ true
! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:58'!
handlesMouseOverDragging: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 03:41'!
initialize
	super initialize.
	labelFragment _ BlockLabelFragment new! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 02:11'!
labelFragment
	^labelFragment! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 03:58'!
labelFragment: fragment
	labelFragment _ fragment! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:18'!
mouseDown: evt
	"Handle a mouse down event"

	| old frag |
	owner isFrozen 
		ifTrue: [^ self]
		ifFalse: [owner isFrozen: true].

	old _ labelFragment deepCopy.
	frag _ BlockLabelFragmentDialog on: labelFragment category: owner category.

	owner
		isFrozen: false;
		hideArgumentPlaceHolders.
	self color: Color white.

	frag = #cancelled ifTrue: [
		labelFragment _ old.
		^ self].
	owner updateSpecWithDnDSpec! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:15'!
mouseEnter: evt

	owner isFrozen 
		ifTrue: [^ self].
	owner showPlaceHoldersNear: self.
! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/24/2010 23:35'!
mouseEnterDragging: evt

	owner isFrozen 
		ifTrue: [^ self].
	owner showPlaceHoldersNear: self! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:15'!
mouseLeave: evt

	owner isFrozen 
		ifTrue: [^ self].
	self color: Color white! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 04:08'!
mouseLeaveDragging: evt

	(owner notNil and: [owner isFrozen])
		ifTrue: [^ self].
	self color: Color white! !

!BlockLabelFragmentMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 03:42'!
updateFragment

	labelFragment
		isInput: false;
		label: self contents! !


Object subclass: #CustomBlockDefinition
	instanceVariableNames: 'userSpec blockVars body isReporter isAtomic isBoolean answer category type declarations defaults isGlobal '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 7/19/2010 04:11'!
addBlockVariable

	| ans |
	ans _ StringDialog askWithCancel: 'New Block Variable Name' initialAnswer: ''.
	ans isEmpty ifTrue: [^false].
	(self allVarNames includes: ans) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	blockVars add: ans.
	^true! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 6/14/2009 16:20'!
allBlocks
	| all |

	body
		ifNil: [ all _ OrderedCollection new]
		ifNotNil: [
			all _ body allMorphs select: [:m|
				m isKindOf: BlockMorph ]].

	(answer isKindOf: BlockMorph) ifTrue: [
		all _ all, answer allMorphs select: [:m |
		m isKindOf: BlockMorph ]].

	^all! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/24/2008 10:15'!
allVarNames
	^(self varNames, self parameterNames) asSortedCollection! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/22/2010 02:04'!
answer
	(answer respondsTo: #fullCopy)
		ifTrue: [^answer fullCopy].
	^answer! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 10/13/2008 14:29'!
answer: aBlockOrNumber
	answer _ aBlockOrNumber! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/5/2010 00:52'!
answerBlock
	| spec block |

	#boolean = type
		ifTrue: [spec _ 'answer %b']
		ifFalse: [spec _ 'answer %s'].
	
	block _ CommandBlockMorph new
		commandSpec: spec;
		isSpecialForm: true;
		selector: #doAnswer.

	(answer isKindOf: ReporterBlockMorph) ifTrue: [
		^block replaceArgMorph: (block argumentAt: 1) by: answer ].

	#boolean = type ifTrue: [^block].

	answer ifNil: [answer _ ''].

	(answer isKindOf: Array)
		ifTrue: [ block argMorphs first stringExpression: '']
		ifFalse: [block argMorphs first stringExpression: answer ].
	^block! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/7/2010 23:06'!
blockColor
	#none = category
		ifTrue: [^ Color lightGray]
		ifFalse: [^ ScriptableScratchMorph blockColorFor: category]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/14/2010 22:48'!
blockVars: aCollection

	blockVars _ aCollection asSet! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/24/2008 13:00'!
body
	^body! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:04'!
body: aBlock
	body _ aBlock.! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:53'!
category

	"categories can be:

		#none	- a gray block in the variables palette (BYOB legacy)
		#motion
		#looks
		#sound
		#pen
		#control
		#sensing
		#operators
		#variables
	"

	^ category! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:53'!
category: aSymbol

	"categories can be:

		#none	- a gray block in the variables palette (BYOB legacy)
		#motion
		#looks
		#sound
		#pen
		#control
		#sensing
		#operators
		#variables
	"

	category _ aSymbol! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/30/2008 09:44'!
commandSpec

	^self commandSpecFrom: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 4/7/2010 00:53'!
commandSpecFrom: aUserSpec

	|cmd out pname ptype|
	cmd _ ScratchServer new parse: aUserSpec.
	out _ WriteStream on: String new. 
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [
				pname _ each asString allButFirst.
				ptype _ declarations at: pname ifAbsent: [#any].
				out nextPutAll: (self specFor: ptype) ]
			ifFalse: [out nextPutAll: each asString].
		out space ].
	^out contents withoutTrailingBlanks! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:55'!
declarations
	^declarations! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:55'!
declarations: aDictionary
	declarations _ aDictionary! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 12:10'!
defaultOf: parameterName

	defaults ifNil: [defaults _ Dictionary new ].
	^ defaults at: parameterName ifAbsent: ['']! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 12:12'!
defaults
	defaults ifNil: [defaults _ Dictionary new].
	^defaults! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 01:03'!
defaults: aDictionary
	defaults _ aDictionary! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:06'!
deleteBlockVariable
	| ans |
	ans _ (SelectionMenu selections: self varNames) startUp.
	ans ifNil: [^false].
	blockVars remove: ans.
	^true! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/14/2010 20:36'!
id
	^self class idFromSpec: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/26/2008 12:29'!
isAtomic
	^isAtomic! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:04'!
isAtomic: aBoolean
	isAtomic _ aBoolean.! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/3/2010 00:13'!
isGlobal
	^isGlobal ifNil: [isGlobal _ false]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/25/2010 02:26'!
isGlobal: bool
	isGlobal _ bool! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 16:03'!
parameterNames

	^self parameterNamesInSpec: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/2/2010 00:29'!
parameterNamesInSpec: aString

	| cmd out |
	cmd _ ScratchServer new parse: aString asMacRoman.
	out _ OrderedCollection new.
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [out add: (each asString allButFirst) asUTF8]].
	^out asArray! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 2/14/2011 09:56'!
specFor: typeSym
	 | specs |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #commandList put: '%O';
		at: #reporter put: '%r';
		at: #reporterList put: '%R';

"+++++++ deprecated experimental slots    -jens +++++++++++++

		at: #reporterSlot put: '%K';
		at: #reporterSlotList put: '%Q';
		at: #typeInReporter put: '%j';
		at: #typeInReporterList put: '%q';

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++"

		at: #unevaluated put: '%j';
		at: #unevaluatedList put: '%q';
		at: #unevaluatedBoolean put: '%Q';
		at: #unevaluatedBooleanList put: '%K';

		at: #predicate put: '%p';
		at: #predicateList put: '%P';
		at: #list put: '%t';
		at: #listList put: '%u';
		at: #text put: '%T';
		at: #textList put: '%U';
		at: #any put: '%s';
		at: #anyList put:  '%X';
		at: #boolean put: '%b';
		at: #booleanList put: '%V';
		at: #number put: '%n';
		at: #numberList put: '%w';
		at: #template put: '%z';
		at: #loop put: '%G';
		at: #loopList put: '%J';

		at: #object put: '%1';
		at: #objectList put: '%2'.

	^specs at: typeSym ifAbsent: ['%s']! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/15/2010 02:37'!
templates

	"answer a Dictionary of externalized local variables"

	| templates parms |
	templates _ Dictionary new.
	parms _ self parameterNames.
	1 to: parms size do: [:i |
		#template = (self typeOfParameterIndex: i) ifTrue: [
			templates at: i put: (parms at: i)]].
	templates keys size > 0 ifFalse: [
		^nil].
	^templates
! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/26/2008 12:50'!
toggleAtomicity
	self isAtomic: isAtomic not! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/14/2010 23:22'!
type
	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #predicate	- a (round?) reporter reporting boolean function

"

	^ type! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/9/2010 22:49'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #predicate	- a hexagonal reporter block that answers a reporter of a boolean 
    #template	- a sunken variable blob that represents an externalized block variable
"

	type _ aSymbol! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/15/2010 00:07'!
typeOf: parameterName

	^ declarations at: parameterName ifAbsent: [#any]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 16:17'!
typeOfParameterIndex: parmIdx

	^ declarations at: (self parameterNames at: parmIdx ifAbsent: [^ #any])
		ifAbsent: [#any]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 09:39'!
userSpec
	^userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/14/2010 23:01'!
userSpec: aString

	userSpec _ aString.

"
--- this code used to keep deleted parameters around as block vars that could be
----reused -deprecated now (2010-09-15) -jens

	userSpec ifNotNil: [
		blockVars addAll: (self parameterNamesInSpec: userSpec)].
	userSpec _ aString.
	(self parameterNamesInSpec: userSpec) do: [:var |
		blockVars remove: var ifAbsent: []]
"! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/28/2010 00:30'!
varNames

	^blockVars asSortedCollection! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/30/2008 07:55'!
varNamesMenu
	^self allVarNames asArray! !


!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:27'!
fieldsVersion

	^ 4
! !

!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:28'!
initFieldsFrom: anObjStream version: classVersion

	self initFieldsNamed: #(
		userSpec
		blockVars
		isAtomic
		isReporter
		isBoolean
		body
		answer
	) from: anObjStream.

	classVersion = 1 ifTrue: [
		^ self deduceType ].

	"fields added in version 2:"
	self initFieldsNamed: #(
		type
		category
		declarations
	) from: anObjStream.

	"fields added in version 3:"
	self initFieldsNamed: #(
		defaults
	) from: anObjStream.

	"fields added in version 4:"
	self initFieldsNamed: #(
		isGlobal
	) from: anObjStream.
! !

!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:27'!
storeFieldsOn: anObjStream

	self storeFieldsNamed: #(
		userSpec
		blockVars
		isAtomic
		isReporter
		isBoolean
		body
		answer
		type
		category
		declarations
		defaults
		isGlobal
	) on: anObjStream.
! !


!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 1/5/2010 00:00'!
deduceType
	"private - set my return type from the BYOB deprecated legacy attributes #isReporter and #isBoolean.
	use this when reading an old block from file"

	isReporter ifFalse: [ ^ type _ #none ].
	isBoolean ifTrue: [ ^ type _ #boolean ].
	^ type _ #any! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 1/27/2010 01:51'!
fixBlockVarReporters


	body ifNotNil: [
		body allMorphs do: [:m|
			((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph) 
				and: [m isSpecialForm]) ifTrue: [
					m receiver: self ]]].
	answer ifNotNil: [ (answer isKindOf: ReporterBlockMorph)
		ifTrue: [answer allMorphs do: [:m|
			((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph) 
				and: [m isSpecialForm]) ifTrue: [
					m receiver: self ]]]].

! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 10/2/2008 11:53'!
getVar: vName
	^0! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 9/30/2008 10:53'!
ownerThatIsA: aClassName
	^nil! !


!CustomBlockDefinition methodsFor: 'initializing' stamp: 'jens 2/26/2010 00:42'!
initialize
	super initialize.
	category _ #none.	"this will be a gray block in the variables palette (jens)"
	type _ #none.
	declarations _ Dictionary new.
	defaults _ Dictionary new.
	isAtomic _ true.
	isReporter _ false.
	isBoolean _ false.
	blockVars _ Set new.
	isGlobal _ true! !


!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:01'!
isBoolean
	"deprecated, kept for BYOB legacy support (jens)"

	^isBoolean! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:01'!
isBoolean: aBoolean
	"deprecated, kept for BYOB legacy support"

	isBoolean _ aBoolean! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:02'!
isReporter
	"deprecated, kept for BYOB legacy support"

	^isReporter! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:02'!
isReporter: aBoolean
	"deprecated, kept for BYOB legacy support"

	isReporter _ aBoolean! !


!CustomBlockDefinition methodsFor: 'migrating' stamp: 'jens 8/2/2010 21:47'!
migrateBlockVars
	"turn my block vars into a VariableDeclarationBlockMorph"

	| dec vars vn spec blob rest |
	blockVars size > 0 ifFalse: [^self].
	dec _ VariableDeclarationBlockMorph new
			color: Color gray;
			isSpecialForm: true;
			minArgs: 1;
			selector: #doDeclareVariables.

	vars _ self varNames.
		spec _ 'script variables' localized.
	vars size timesRepeat: [ spec _ spec, ' %s' ].
	dec commandSpec: spec.
	1 to: vars size do: [:i |
		vn _ vars at: i.
		blob _ VariableBlockMorph new 
				isSpecialForm: true;
				commandSpec: vn  ";
				color: (ScriptableScratchMorph blockColorFor: 'variables')".
		dec replaceArgMorph: (dec argMorphs at: i) by: blob.
		blockVars remove: vn ].

	rest _ body.
	body _ dec.
	rest ifNotNil: [
		body nextBlock: rest ]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CustomBlockDefinition class
	instanceVariableNames: ''!

!CustomBlockDefinition class methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 20:35'!
idFromSpec: aUserSpecOrCommandSpec

	|cmd out|
	cmd _ ScratchServer new parse: aUserSpecOrCommandSpec.
	out _ WriteStream on: String new.
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [out nextPutAll: '%s' ]
			ifFalse: [out nextPutAll: each asString].
		out space ].
	^out contents withoutTrailingBlanks! !


CommandBlockMorph subclass: #CustomCommandBlockMorph
	instanceVariableNames: 'userSpec isTemplate specParts isFrozen extraSpaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!
!CustomCommandBlockMorph commentStamp: 'jens 1/8/2010 06:09' prior: 0!
some code which could be useful:

| hat template |
hat _ WhenHatBlockMorph new.
hat submorphs do: [:m | (m isKindOf: StringMorph) ifTrue: [m delete]].
template _ CommandBlockMorph new commandSpec: 'this is a long, long road to go down'.
hat replaceArgMorph: hat argMorph by: template.
hat openInWorld


!


!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
allVarNames
	^self definition allVarNames! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 23:31'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping block could be attached."

	isTemplate
		ifTrue: [^#()]
		ifFalse: [ super blockAttachPoints: aSet ]
		! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/30/2010 23:58'!
category

	| def |
	def _ self definition.
	def ifNil: [^#none].
	^ def category! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2010 02:10'!
defaultArgs: defaultValues
	"Set the default values of my arguments from the given list."

	self setDefaultArgs! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:02'!
definition
	^receiver definitionFor: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:20'!
deleteDefinition
	receiver deleteDefinitionId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 23:32'!
editScript
	receiver editScriptId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:44'!
editSpec
	(World allMorphs detect: [:m| m isKindOf: BlockDialog] ifNone: [nil])
		ifNotNil: [^self].
	receiver editSpecId: self id! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:00'!
fieldsVersion

	^ 1
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/18/2010 02:04'!
firstBlockList

	self script
		ifNil: [^ #()]
		ifNotNil: [^ self script blockSequence "collect: [:each | each fullCopy]"]. "added #fullCopy for lambda variable support. -JM"

	 "old code taken out for speed, now the copying is done in #doApplyEval"! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:02'!
initFieldsFrom: anObjStream version: classVersion

	super initFieldsFrom: anObjStream version: classVersion.
	self initFieldsNamed: #(
		userSpec
	) from: anObjStream.

! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 23:03'!
initialize
	super initialize.
	isTemplate _ false.
	isFrozen _ false.
	isSpecialForm _ true.
	self color: Color lightGray! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
isAtomic
	^self definition isAtomic! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 04:03'!
isCustomBlock
	^true! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:20'!
isFunction
	^ false! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 16:19'!
isReporter
	^false! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:58'!
parameterNames
	^self definition parameterNames! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/1/2010 14:13'!
privateSetUserSpec: aString

	userSpec _ aString.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 18:38'!
remove
	|nb sm|
	nb _ self nextBlock.
	(self ownerThatIsA: BlockEditorFrameMorph) isNil
		ifTrue: [
			sm _ self ownerThatIsA: ScratchScriptsMorph.
			(nb notNil & sm notNil) ifTrue: [sm addMorph: nb]]
		ifFalse: [
			sm _ self owner.
			(nb notNil & sm notNil) ifTrue: [sm nextBlock: nb]].
	self delete! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/16/2010 16:37'!
rename

	| def defs choice menu |
	def _ self definition.
	defs _ receiver customBlocks select: [:eachDef |
		eachDef ~= def and: [
			eachDef type = def type and: [
				eachDef category = def category ]]].
	defs _ defs asSortedCollection: [:x :y |
		x id <= y id].
	menu _ CustomMenu new.
	defs do: [:eachDef |
		menu addIcon: (receiver lambda: eachDef id) imageForm toolTip: nil action: eachDef].
	choice _ menu startUp: nil withCaption: nil at: self topRight.
	choice ifNil: [^ self].
	self userSpec: choice userSpec! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/3/2010 22:17'!
replaceArgMorph: argMorph by: newMorph

	| def typ pname i val |
	super replaceArgMorph: argMorph by: newMorph.
	(newMorph isKindOf: ExpressionArgMorph) ifTrue: [
		def _ self definition.
		i _ argMorphs indexOf: newMorph.
		pname _ def parameterNames at: i.
		typ _ def typeOf: pname.
		val _ def defaultOf: pname.
		#number = typ
			ifTrue: [newMorph numExpression: val] 
			ifFalse: [newMorph defaultValue: val]]! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:35'!
rightButtonMenu

	| menu choice |
	menu _ CustomMenu new.
	menu add: 'help' action: #presentHelpScreen.
	menu addLine.
	isTemplate 
		ifTrue: [menu add: 'change category' action: #editSpec ]
		ifFalse: [menu add: 'edit' action: #editScript].

	((owner isKindOf: ScratchBlockPaletteMorph) or: [isTemplate]) ifFalse: [
		menu add: 'relabel' action: #rename.
		menu addLine.
		menu add: 'duplicate' action: #duplicate.
		menu add: '- this block' action: #fastDuplicate.

		(self owner isKindOf: BlockMorph) ifFalse: [  "can't yet delete a blocks inside a script"
			menu add: 'delete' action: #delete]].

	(owner isKindOf: ScratchBlockPaletteMorph) ifTrue: [
		menu add: 'delete block definition' action: #deleteDefinition ].

	(choice _ menu localize; startUp) ifNil: [^ self].
	self perform: choice.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 09:59'!
script
	^self definition body! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 02:28'!
sequence
	^self firstBlockList! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/14/2010 21:55'!
setDefaultArgs

	| a def parms typ |

	def _ self definition.
	parms _ def parameterNames.
	1 to: argMorphs size do: [:i |
		a _ argMorphs at: i.
		(a isKindOf: ArgMorph) ifTrue: [
			(a isKindOf: MultiArgMorph)
				ifTrue: [a addArgSlot]
				ifFalse: [
					typ _ def typeOf: (parms at: i ifAbsent: [nil]).
					#number = typ
						ifTrue: [a numExpression: (def defaultOf: (parms at: i ifAbsent: [nil]))]
						ifFalse: [a defaultValue: (def defaultOf: (parms at: i ifAbsent: [nil]))]]]]! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/30/2008 11:03'!
start
	isTemplate ifTrue: [^self].
	super start! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 20:01'!
storeFieldsOn: anObjStream

	super storeFieldsOn: anObjStream.
	self storeFieldsNamed: #(
		userSpec
	) on: anObjStream.
! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/29/2008 11:27'!
userSpec
	^userSpec! !

!CustomCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/16/2010 02:55'!
userSpec: aString
	| cat def |

	userSpec _ aString.
	isTemplate ifTrue: [self removeVariableTemplates].
	cat _ self category.
	cat ifNotNil: [
		self color: (ScriptableScratchMorph blockColorFor: cat asString) ].
	def _ receiver definitionFor: self id.
	def ifNil: [^ self].
	self commandSpec: def commandSpec.
	self addLabel! !


!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/27/2010 22:06'!
addLabel

	| tokens args nextArgIndex m next part frontSpace backSpace |
	commandSpec ifNil: [^ self].

	isTemplate ifFalse: [
		^ self addLabelToNonTemplate].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ commandSpec findTokens: ' '.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove any excess arg morphs from the list."
	[argMorphs size > args size] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))].

	nextArgIndex _ 1.

	extraSpaces _ Array new: 2.

	"insert a place holder on front"
	frontSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 1 put: frontSpace.
	self addMorphBack: frontSpace.


	specParts _ OrderedCollection new.
	part _ ArgumentPlaceHolderMorph new.
	self addMorphBack: part.
	specParts add: part.
	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m.
		specParts add: m.
		part _ ArgumentPlaceHolderMorph new.
			self addMorphBack: part.
			specParts add: part ].

	"insert another place holder at the back"
	backSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 2 put: backSpace.
	self addMorphBack: backSpace.

	self isReporter ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	self addVariableTemplates.
	self hideArgumentPlaceHolders! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/5/2010 00:46'!
addLabelToNonTemplate
	"Add a label for my command and arguments. This is the method that really creates the whole block."

	| tokens args nextArgIndex m next argValues eachArg eachValue pn pt def |
	commandSpec ifNil: [^ self].

	"remember the values of the arguments"
	argValues _ OrderedCollection new.
	argMorphs do: [:a |
		(a isKindOf: BlockMorph)
			ifTrue: [argValues add: a]
			ifFalse: [(a isKindOf: MultiArgMorph)
				ifTrue: [argValues add: a listValue]
				ifFalse: [(a isKindOf: ExpressionArgMorph)
					ifTrue: [ a isNumberExpression
						ifTrue: [a getExpression = ' ' asUTF8
							ifTrue: [argValues add: a getExpression]
							ifFalse: [argValues add: a getExpression asNumberNoError]]
						ifFalse: [argValues add: a getExpression]]
					ifFalse: [a isEmptySlot
						ifFalse: [argValues add: a evaluate]]]]].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ CommandBlockMorph parseCommandSpec: commandSpec.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove all arg morphs from the list."
	[argMorphs size > 0 ] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		def _ self definition.
		def isNil
			ifTrue: [pt _ #any]
			ifFalse: [ pt _ def typeOfParameterIndex: argMorphs size + 1].
		#template = pt 
			ifTrue: [
				pn _ def parameterNames at: argMorphs size + 1.
				argMorphs addLast: 	(VariableBlockMorph new 
					isSpecialForm: true; 
					selector: #getVar:;
"					color: (ScriptableScratchMorph blockColorFor: 'variables');"
					commandSpec: pn)]
			ifFalse: [argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))]].

	nextArgIndex _ 1.

	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m].

	(self isReporter and: [submorphs isEmpty not]) ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	"now try restoring the former arguments (jens)"
	1 to: argMorphs size do: [:i |
		eachArg _ argMorphs at: i.
		eachValue _ argValues at: i ifAbsent: [nil].
		eachValue ifNotNil: [(eachValue isKindOf: BlockMorph)
			ifTrue: [(eachArg acceptsTypeOf: eachValue)
				ifTrue: [ (({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachArg class) and: [eachArg class = eachValue class])
					ifTrue: [self replaceArgMorph: eachArg by: eachValue]
					ifFalse: [({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachValue class)
						ifTrue: [((eachArg respondsTo: #attachBlock:) and: [(eachValue respondsTo: #nestedBlock) and: [eachValue nestedBlock notNil]])
							ifTrue: [eachArg attachBlock: eachValue nestedBlock]]
						ifFalse: [self replaceArgMorph: eachArg by: eachValue]]]
				ifFalse: [((eachArg isKindOf: VariableBlockMorph) and: [
							eachValue isKindOf: VariableBlockMorph])
								ifTrue: [eachArg commandSpec: eachValue commandSpec]]]
			ifFalse: [ 
				((eachArg isKindOf: ExpressionArgMorph) and: [eachArg isNumberExpression])
					ifTrue: [eachArg defaultValue: eachValue "asNumberNoError"]
					ifFalse: [ (eachValue isKindOf: ScratchListMorph)
						ifTrue: [eachArg defaultValue: eachValue]
						ifFalse: [eachArg defaultValue: eachValue asString]]]]]


! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 8/2/2010 21:47'!
addVariableTemplates
	| parms varBlock idx |
	parms _ self definition parameterNames.
	1 to: parms size do: [: i |
		varBlock _ VariableBlockMorph new. 
		varBlock
			isSpecialForm: true;
			receiver: self definition;
			selector: #getBlockVar:;
			commandSpec: (parms at: i);
"			color: (ScriptableScratchMorph blockColorFor: 'variables');"
			updateFragment;
			parameterType: (self definition typeOf: (parms at: i));
			parameterDefaultValue: (self definition defaultOf: (parms at: i));
			yourself.
		idx _ specParts indexOf: (self argumentAt: i).
		idx > 0 ifTrue: [ specParts at: idx put: varBlock].
		self replaceArgMorph: (self argumentAt: i) by: varBlock.
		varBlock addLabel]

! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/2/2010 00:21'!
getDnDSpec
	| s |
	s _ ''.
	specParts do: [:part | 
		s _ s, ' ', (part labelFragment spec) asMacRoman].
	^s withoutLeadingBlanks asUTF8! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/24/2008 15:22'!
handleTool: toolName hand: hand
	isTemplate ifFalse: [super handleTool: toolName hand: hand ]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 2/15/2010 22:35'!
hideArgumentPlaceHolders

	isFrozen ifTrue: [^ self].
	extraSpaces ifNotNil: [
		extraSpaces do: [:each |
			each extent: ArgumentPlaceHolderMorph dimensions ]].
	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m vanish]]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 23:07'!
isFrozen
	^ isFrozen! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 23:04'!
isFrozen: bool
	isFrozen _ bool! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 16:08'!
isPartsBin
	^isTemplate! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 10/9/2008 08:39'!
isTemplate
	^isTemplate! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 16:00'!
isTemplate: aBoolean
	isTemplate _ aBoolean! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/27/2010 21:41'!
labelMorphFor: aString

	| s |

	isTemplate ifFalse: [^super labelMorphFor: aString].

	s _ aString.
	commandSpec isUnicode ifTrue: [s _ UTF8 withAll: s].
	^ (BlockLabelFragmentMorph contents: s font: (ScratchFrameMorph getFont: #Label))
		color: self labelColor;
		updateFragment;
		yourself
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 12/4/2009 01:06'!
removeParameter: varBlock

	| idx |
	idx _ specParts indexOf: varBlock.
	idx = 0 ifTrue: [^self].
	specParts at: idx put: ArgumentPlaceHolderMorph new.
	self updateSpecWithDnDSpec! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/23/2008 18:28'!
removeVariableTemplates
	argMorphs do: [:each| each delete ].
	argMorphs _ OrderedCollection new! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/1/2010 22:49'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nextBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].
	(isTemplate and: [ 
		owner isKindOf: ProcedureHatBlockMorph]) 
			ifTrue: [^nil].

	^ super rootForGrabOf: aMorph
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/21/2010 19:59'!
showArgumentPlaceHolders

	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m appear]]! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 4/30/2010 14:09'!
showEdgePlaceHolders

	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces ifNil: [^ self].
	extraSpaces do: [:each |
		each extent: 0@0].
	
	specParts first appear.
	specParts last appear.
! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 1/24/2010 23:34'!
showPlaceHoldersNear: aLabelFragment

	| idx |
	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces do: [:each |
		each extent: 0@0].
	
	idx _ submorphs indexOf: aLabelFragment.
	(submorphs at: idx - 1) appear.
	(submorphs at: idx + 1) appear.

	(aLabelFragment isKindOf: VariableBlockMorph)
		ifFalse: [aLabelFragment color: color twiceDarker]


! !

!CustomCommandBlockMorph methodsFor: 'template' stamp: 'jens 9/15/2010 00:38'!
updateSpecWithDnDSpec
	"the spec has been changed by way of drag'n'drop (Jens' design) 
	or direct editing (Brian's design).

	We need to:

	1.	determine the new command spec
	2. 	check for input constraints
	3.	determine the new parameters and their types (declarations) and defaults
	4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition
	7.	update the Block Editor
	8.	update the Scratch Window
"

	| newSpec parms defaults oldid newid types def  stage affected eachDef be sf |

	"1.	determine the new command spec"

	def _ self definition.
	def ifNil: [^self].
	oldid _ self id.

	newSpec _ self getDnDSpec. 
	newSpec isEmpty ifTrue: [
		self addLabel.
		^ self ].	

	newid _ CustomBlockDefinition idFromSpec: newSpec. 

	"2. 	check for input constraints"

	parms _ def parameterNamesInSpec: newSpec.
	parms size > parms asSet size ifTrue: [
		DialogBoxMorph warn: 'a parameter with that label already exists'.
		self addLabel.
		^ self ].	

	((newid ~= oldid) and: [receiver existsBlockId: newid global: def isGlobal]) ifTrue: [
		DialogBoxMorph warn: 'a block with that label already exists'.
		self addLabel.
		^ self ].	

	"3.	determine the new parameters and their types (declarations) and defaults"

	types _ Dictionary new.
	defaults _ Dictionary new.
	(specParts select: [:part | part labelFragment isInput ]) do: [:m |
		types at: m labelFragment label put: m labelFragment type.
		defaults at: m labelFragment label put: m labelFragment default ].

	"4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition"

	stage _ receiver ownerThatIsA: ScratchStageMorph.

	def isGlobal not | stage isNil
		ifTrue: [
			def
				declarations: types;
				defaults: defaults.
			affected _ receiver instancesOf: oldid.
			def userSpec: newSpec.
			affected do: [:eachBlock|
				eachBlock
					privateSetUserSpec: newSpec;
					commandSpec: def commandSpec]]
		ifFalse: [
			stage sprites, {stage} do: [:obj | 
				eachDef _  obj definitionFor: oldid.
				eachDef ifNotNil: [
					eachDef
						declarations: types copy;
						defaults: defaults copy.
					affected _ obj instancesOf: oldid.
					eachDef userSpec: newSpec.
					affected do: [:eachBlock|
						eachBlock
							privateSetUserSpec: newSpec;
							commandSpec: eachDef commandSpec]]]].

	"7.	update the Block Editor"

	be _ self ownerThatIsA: BlockEditorFrameMorph.

	be definition
		declarations: types copy;
		defaults: defaults copy;
		userSpec: newSpec.

	affected _ be instancesOf: oldid.
	affected do: [:eachBlock|
		eachBlock
			privateSetUserSpec: newSpec;
			commandSpec: def commandSpec].

	"8.	update the Scratch Window"

	sf _ receiver ownerThatIsA: ScratchFrameMorph.
	sf viewerPane categoryChanged: 'variables'.
	#none = def category ifFalse: [
		sf viewerPane categoryChanged: def category asString ]
! !


!CustomCommandBlockMorph methodsFor: 'stack/tuple conversion' stamp: 'jens 7/20/2010 23:07'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple argList arg val eval |
	blockTuple _ Array new: argMorphs size + 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: userSpec.

	argList _ argMorphs.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [(arg isKindOf: MultiArgMorph)
				ifTrue: [ blockTuple at: i + 4 put: arg listValue convertStacksToTuples] "a list"
				ifFalse: [ ((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
					ifTrue: [blockTuple at: i + 4 put: arg asBlockTuple]
					ifFalse: [(arg isKindOf: ExpressionArgMorph)
						ifTrue: [
							val _ arg getExpression.
							arg isNumberExpression
								ifTrue: [val = ' ' asUTF8
									ifTrue: [eval _ val]
									ifFalse: [eval _ val asNumberNoError]]
								ifFalse: [eval _ arg getExpression]]
						ifFalse: [eval _ arg evaluate].
						blockTuple at: i + 4 put: eval]]]
			ifFalse: [blockTuple at: i + 4 put: arg asBlockTuple]].
	^ blockTuple
! !


!CustomCommandBlockMorph methodsFor: 'identification' stamp: 'jens 1/14/2010 20:36'!
id
	^CustomBlockDefinition idFromSpec: userSpec! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CustomCommandBlockMorph class
	instanceVariableNames: ''!

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 5/21/2010 03:14'!
codeOwner
	^ 'jens owns the byob code :-)'! !

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 5/21/2010 02:39'!
owner
	^ 'jens'! !

!CustomCommandBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 9/23/2008 17:45'!
template
	^self new isTemplate: true! !


ReporterBlockMorph subclass: #CustomReporterBlockMorph
	instanceVariableNames: 'userSpec isTemplate specParts isFrozen extraSpaces '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 4/27/2010 22:06'!
addLabel

	| tokens args nextArgIndex m next part frontSpace backSpace |
	commandSpec ifNil: [^ self].

	isTemplate ifFalse: [
		^ self addLabelToNonTemplate].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ commandSpec findTokens: ' '.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove any excess arg morphs from the list."
	[argMorphs size > args size] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m.

		"if the argument we're throwing out is anything complicated, we'd like to keep it around in the world."
		(m isKindOf: BlockMorph) ifTrue: [m openInWorld]].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))].

	nextArgIndex _ 1.

	extraSpaces _ Array new: 2.

	"insert a place holder on front"
	frontSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 1 put: frontSpace.
	self addMorphBack: frontSpace.


	specParts _ OrderedCollection new.
	part _ ArgumentPlaceHolderMorph new.
	self addMorphBack: part.
	specParts add: part.
	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m.
		specParts add: m.
		part _ ArgumentPlaceHolderMorph new.
			self addMorphBack: part.
			specParts add: part ].

	"insert another place holder at the back"
	backSpace _ Morph new 
		color: Color transparent; 
		extent: ArgumentPlaceHolderMorph dimensions;
		yourself.
	extraSpaces at: 2 put: backSpace.
	self addMorphBack: backSpace.

	self isReporter ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	self addVariableTemplates.
	self hideArgumentPlaceHolders! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 10/5/2010 00:26'!
addLabelToNonTemplate
	"Add a label for my command and arguments. This is the method that really creates the whole block."

	| tokens args nextArgIndex m next argValues eachArg eachValue pn pt def |
	commandSpec ifNil: [^ self].

	"remember the values of the arguments"
	argValues _ OrderedCollection new.
	argMorphs do: [:a |
		(a isKindOf: BlockMorph)
			ifTrue: [argValues add: a]
			ifFalse: [(a isKindOf: MultiArgMorph)
				ifTrue: [argValues add: a listValue]
				ifFalse: [(a isKindOf: ExpressionArgMorph)
					ifTrue: [ a isNumberExpression
						ifTrue: [a getExpression = ' ' asUTF8
							ifTrue: [argValues add: a getExpression]
							ifFalse: [argValues add: a getExpression asNumberNoError]]
						ifFalse: [argValues add: a getExpression]]
					ifFalse: [a isEmptySlot
						ifFalse: [argValues add: a evaluate]]]]].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ CommandBlockMorph parseCommandSpec: commandSpec.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove all arg morphs from the list."
	[argMorphs size > 0 ] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		def _ self definition.
		def isNil
			ifTrue: [pt _ #any]
			ifFalse: [ pt _ def typeOfParameterIndex: argMorphs size + 1].
		#template = pt 
			ifTrue: [
				pn _ def parameterNames at: argMorphs size + 1.
				argMorphs addLast: 	(VariableBlockMorph new 
					isSpecialForm: true; 
					selector: #getVar:;
"					color: (ScriptableScratchMorph blockColorFor: 'variables');"
					commandSpec: pn)]
			ifFalse: [argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))]].

	nextArgIndex _ 1.

	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: (UTF8 withAll: s)].
		self addMorphBack: m].

	(self isReporter and: [submorphs isEmpty not]) ifTrue: [
		m _ submorphs first.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphFront: (Morph new color: Color transparent; extent: 2@5)].

		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].

	"now try restoring the former arguments (jens)"
	1 to: argMorphs size do: [:i |
		eachArg _ argMorphs at: i.
		eachValue _ argValues at: i ifAbsent: [nil].
		eachValue ifNotNil: [(eachValue isKindOf: BlockMorph)
			ifTrue: [(eachArg acceptsTypeOf: eachValue)
				ifTrue: [ (({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachArg class) and: [eachArg class = eachValue class])
					ifTrue: [self replaceArgMorph: eachArg by: eachValue]
					ifFalse: [({CSlotMorph. OSlotMorph. CArgSlotMorph. CReporterSlotMorph} includes: eachValue class)
						ifTrue: [((eachArg respondsTo: #attachBlock:) and: [(eachValue respondsTo: #nestedBlock) and: [eachValue nestedBlock notNil]])
							ifTrue: [eachArg attachBlock: eachValue nestedBlock]]
						ifFalse: [self replaceArgMorph: eachArg by: eachValue]]]
				ifFalse: [((eachArg isKindOf: VariableBlockMorph) and: [
							eachValue isKindOf: VariableBlockMorph])
								ifTrue: [eachArg commandSpec: eachValue commandSpec]]]
			ifFalse: [ 
				((eachArg isKindOf: ExpressionArgMorph) and: [eachArg isNumberExpression])
					ifTrue: [eachArg defaultValue: eachValue "asNumberNoError"]
					ifFalse: [ (eachValue isKindOf: ScratchListMorph)
						ifTrue: [eachArg defaultValue: eachValue]
						ifFalse: [eachArg defaultValue: eachValue asString]]]]]


! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 8/2/2010 21:47'!
addVariableTemplates
	| parms varBlock idx |
	parms _ self definition parameterNames.
	1 to: parms size do: [: i |
		varBlock _ VariableBlockMorph new. 
		varBlock
			isSpecialForm: true;
			receiver: self definition;
			selector: #getBlockVar:;
			commandSpec: (parms at: i);
"			color: (ScriptableScratchMorph blockColorFor: 'variables');"
			updateFragment;
			parameterType: (self definition typeOf: (parms at: i));
			parameterDefaultValue: (self definition defaultOf: (parms at: i));
			yourself.
		idx _ specParts indexOf: (self argumentAt: i).
		idx > 0 ifTrue: [ specParts at: idx put: varBlock].
		self replaceArgMorph: (self argumentAt: i) by: varBlock.
		varBlock addLabel]

! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 10/5/2010 13:23'!
getDnDSpec
	| s |
	s _ ''.
	specParts do: [:part | 
		s _ s, ' ', (part labelFragment spec) asMacRoman].
	^s withoutLeadingBlanks asUTF8! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:21'!
handleTool: toolName hand: hand
	isTemplate ifFalse: [super handleTool: toolName hand: hand ]! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 2/15/2010 22:35'!
hideArgumentPlaceHolders

	isFrozen ifTrue: [^ self].
	extraSpaces ifNotNil: [
		extraSpaces do: [:each |
			each extent: ArgumentPlaceHolderMorph dimensions ]].
	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m vanish]]! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/22/2010 00:28'!
isFrozen
	^ isFrozen! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/22/2010 00:32'!
isFrozen: bool
	isFrozen _ bool! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/22/2010 00:28'!
isInterestedIn: aMorph

	isTemplate ifFalse: [^ false].
	^((aMorph isKindOf: VariableBlockMorph) and: [aMorph isSpecialForm]) and: [
		(self parameterNames includes: aMorph variable) not]! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:21'!
isPartsBin
	^isTemplate! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:22'!
isTemplate
	^isTemplate! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:22'!
isTemplate: aBoolean
	isTemplate _ aBoolean! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 9/2/2010 00:43'!
labelMorphFor: aString

	| s |

	isTemplate ifFalse: [^super labelMorphFor: aString].

	s _ aString.
	commandSpec isUnicode ifTrue: [s _ UTF8 withAll: s].
	^ (BlockLabelFragmentMorph contents: s font: (ScratchFrameMorph getFont: #Label))
		color: self labelColor;
		updateFragment;
		yourself
! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:22'!
removeParameter: varBlock

	| idx |
	idx _ specParts indexOf: varBlock.
	idx = 0 ifTrue: [^self].
	specParts at: idx put: ArgumentPlaceHolderMorph new.
	self updateSpecWithDnDSpec! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:22'!
removeVariableTemplates
	argMorphs do: [:each| each delete ].
	argMorphs _ OrderedCollection new! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/12/2010 22:23'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nextBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].
	(isTemplate and: [ owner isKindOf: ProcedureHatBlockMorph]) ifTrue: [^nil].

	^ super rootForGrabOf: aMorph
! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/22/2010 00:29'!
showArgumentPlaceHolders

	submorphs do: [:m |
		(m isKindOf: ArgumentPlaceHolderMorph)
			ifTrue: [m appear]]! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 4/30/2010 14:10'!
showEdgePlaceHolders

	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces ifNil: [^ self].
	extraSpaces do: [:each |
		each extent: 0@0].
	
	specParts first appear.
	specParts last appear.
! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 1/25/2010 00:57'!
showPlaceHoldersNear: aLabelFragment

	| idx |
	isFrozen ifTrue: [^ self].
	self hideArgumentPlaceHolders.
	extraSpaces do: [:each |
		each extent: 0@0].
	
	idx _ submorphs indexOf: aLabelFragment.
	(submorphs at: idx - 1) appear.
	(submorphs at: idx + 1) appear.

	(aLabelFragment isKindOf: VariableBlockMorph)
		ifFalse: [aLabelFragment color: color twiceDarker]


! !

!CustomReporterBlockMorph methodsFor: 'template' stamp: 'jens 10/5/2010 12:38'!
updateSpecWithDnDSpec
	"the spec has been changed by way of drag'n'drop (Jens' design) 
	or direct editing (Brian's design).

	We need to:

	1.	determine the new command spec
	2. 	check for input constraints
	3.	determine the new parameters and their types (declarations) and defaults
	4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition
	7.	update the Block Editor
	8.	update the Scratch Window
"

	| newSpec parms defaults oldid newid types def  stage affected eachDef be sf |

	"1.	determine the new command spec"

	def _ self definition.
	def ifNil: [^self].
	oldid _ self id.

	newSpec _ self getDnDSpec. 
	newSpec isEmpty ifTrue: [
		self addLabel.
		^ self ].	

	newid _ CustomBlockDefinition idFromSpec: newSpec. 

	"2. 	check for input constraints"

	parms _ def parameterNamesInSpec: newSpec.
	parms size > parms asSet size ifTrue: [
		DialogBoxMorph warn: 'a parameter with that label already exists'.
		self addLabel.
		^ self ].	

	((newid ~= oldid) and: [receiver existsBlockId: newid global: def isGlobal]) ifTrue: [
		DialogBoxMorph warn: 'a block with that label already exists'.
		self addLabel.
		^ self ].	

	"3.	determine the new parameters and their types (declarations) and defaults"

	types _ Dictionary new.
	defaults _ Dictionary new.
	(specParts select: [:part | part labelFragment isInput ]) do: [:m |
		types at: m labelFragment label put: m labelFragment type.
		defaults at: m labelFragment label put: m labelFragment default ].

	"4. 	update the definition's parameters declaration dictionary
	5. 	update every instance of the definition if it is global
	6.	update the definition's userSpec -> update every instance of the definition"

	stage _ receiver ownerThatIsA: ScratchStageMorph.

	def isGlobal not | stage isNil
		ifTrue: [
			def
				declarations: types;
				defaults: defaults.
			affected _ receiver instancesOf: oldid.
			def userSpec: newSpec.
			affected do: [:eachBlock|
				eachBlock
					privateSetUserSpec: newSpec;
					commandSpec: def commandSpec]]
		ifFalse: [
			stage sprites, {stage} do: [:obj | 
				eachDef _  obj definitionFor: oldid.
				eachDef ifNotNil: [
					eachDef
						declarations: types copy;
						defaults: defaults copy.
					affected _ obj instancesOf: oldid.
					eachDef userSpec: newSpec.
					affected do: [:eachBlock|
						eachBlock
							privateSetUserSpec: newSpec;
							commandSpec: eachDef commandSpec]]]].

	"7.	update the Block Editor"

	be _ self ownerThatIsA: BlockEditorFrameMorph.

	be definition
		declarations: types copy;
		defaults: defaults copy;
		userSpec: newSpec.

	affected _ be instancesOf: oldid.
	affected do: [:eachBlock|
		eachBlock
			privateSetUserSpec: newSpec;
			commandSpec: def commandSpec].

	"8.	update the Scratch Window"

	sf _ receiver ownerThatIsA: ScratchFrameMorph.
	sf viewerPane categoryChanged: 'variables'.
	#none = def category ifFalse: [
		sf viewerPane categoryChanged: def category asString ]
! !


!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
allVarNames
	^self definition allVarNames! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 16:18'!
answer
	self definition answer! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 03:19'!
canBecomeWatcher

	^ false
! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 01:25'!
category

	^ self definition category! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2010 02:10'!
defaultArgs: defaultValues
	"Set the default values of my arguments from the given list."

	self setDefaultArgs! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:10'!
definition
	^receiver definitionFor: self id! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:20'!
deleteDefinition
	receiver deleteDefinitionId: self id! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 23:32'!
editScript
	receiver editScriptId: self id! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 22:44'!
editSpec
	(World allMorphs detect: [:m| m isKindOf: BlockDialog] ifNone: [nil])
		ifNotNil: [^self].
	receiver editSpecId: self id! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: rawArgs
	"Evalue this block with the given argument list."

	self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	^scratchProc answer	! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
fieldsVersion

	^ 1
! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/18/2010 02:04'!
firstBlockList

	| list |
	self script
		ifNil: [list _ Array with: self definition answerBlock]
		ifNotNil: [list _ self script blockSequence, (Array with: self definition answerBlock)].
	^ list 

		"collect: [:each| each fullCopy]"  "old code taken out for speed, now the copying is done in #doApplyEval"

! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
initFieldsFrom: anObjStream version: classVersion

	super initFieldsFrom: anObjStream version: classVersion.
	self initFieldsNamed: #(
		userSpec
	) from: anObjStream.

! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 00:27'!
initialize
	super initialize.
	isTemplate _ false.
	isFrozen _ false.
	isSpecialForm _ true.
	self color: Color lightGray! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
isAtomic
	^self definition isAtomic! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 04:03'!
isCustomBlock
	^true! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:20'!
isFunction
	^ true! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 16:19'!
isReporter
	^true! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
parameterNames
	^self definition parameterNames! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/1/2010 14:14'!
privateSetUserSpec: aString

	userSpec _ aString.
! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/17/2008 13:23'!
remove

	self aboutToBeGrabbedBy: nil.
	self delete! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/16/2010 02:18'!
rename

	| def defs choice menu |
	def _ self definition.
	defs _ receiver customBlocks select: [:eachDef |
		eachDef ~= def and: [
			eachDef type = def type and: [
				eachDef category = def category ]]].
	menu _ CustomMenu new.
	defs do: [:eachDef |
		menu addIcon: (receiver lambda: eachDef id) imageForm toolTip: nil action: eachDef].
	choice _ menu startUp: nil withCaption: nil at: self topRight.
	choice ifNil: [^ self].
	self userSpec: choice userSpec! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/3/2010 22:20'!
replaceArgMorph: argMorph by: newMorph

	| def typ pname i val |
	super replaceArgMorph: argMorph by: newMorph.
	(newMorph isKindOf: ExpressionArgMorph) ifTrue: [
		def _ self definition.
		i _ argMorphs indexOf: newMorph.
		pname _ def parameterNames at: i.
		typ _ def typeOf: pname.
		val _ def defaultOf: pname.
		#number = typ
			ifTrue: [newMorph numExpression: val] 
			ifFalse: [newMorph defaultValue: val]]! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:36'!
rightButtonMenu

	| menu choice |
	self isTemplate ifTrue: [^ self].
	menu _ CustomMenu new.
	menu add: 'help' action: #presentHelpScreen.
	menu addLine.
	menu add: 'edit' action: #editScript.

	(owner isKindOf: ScratchBlockPaletteMorph) ifFalse: [

		menu add: 'relabel' action: #rename.
		menu addLine.
		menu add: 'duplicate' action: #duplicate.
		(self owner isKindOf: BlockMorph) ifFalse: [  "can't yet delete a blocks inside a script"
			menu add: 'delete' action: #delete]].

	(owner isKindOf: ScratchBlockPaletteMorph) ifTrue: [
		menu add: 'delete block definition' action: #deleteDefinition ].

	(choice _ menu localize; startUp) ifNil: [^ self].
	self perform: choice.
! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
script
	^self definition body! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 02:28'!
sequence
	^self firstBlockList! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2010 00:09'!
setDefaultArgs

	| a def parms typ |

	def _ self definition.
	parms _ def parameterNames.
	1 to: argMorphs size do: [:i |
		a _ argMorphs at: i.
		(a isKindOf: ArgMorph) ifTrue: [
			(a isKindOf: MultiArgMorph)
				ifTrue: [a addArgSlot]
				ifFalse: [
					typ _ def typeOf: (parms at: i).
					#number = typ
						ifTrue: [a numExpression: (def defaultOf: (parms at: i))]
						ifFalse: [a defaultValue: (def defaultOf: (parms at: i))]]]]! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/9/2010 00:48'!
showValue

	| gotError msg tooltip w worldBounds |
	gotError _ false.

	[self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	msg _ scratchProc answer] ifError: [
		gotError _ true.
		msg _ 'Error!!'].

	(msg isKindOf: Morph)
		ifTrue: [(msg respondsTo: #displayForm)
			ifTrue: [msg _ msg displayForm ]
			ifFalse: [msg _ msg imageForm ]]
		ifFalse: [msg _ msg asString ].

	((self isBooleanReporter or: [msg = 'Error!!']) and: [msg isKindOf: String]) ifTrue: [
		msg _ msg localized].
	tooltip _ (ScratchReporterToolTipMorph string: msg for: self)
		left: self right;
		bottom: self top.
	ScratchTranslator isRTL ifTrue: [tooltip right: self left].
	gotError ifTrue: [tooltip messageColor: Color red darker].

	w _ self world.
	w ifNil: [^self].
	w addMorphFront: tooltip.
	((worldBounds _ w bounds) containsRect: tooltip bounds) ifFalse:
		[tooltip bounds: (tooltip bounds translatedToBeWithin: worldBounds)].

	self setProperty: #toolTip toValue: tooltip.
	tooltip initialCursorPoint: Sensor cursorPoint.
	tooltip startStepping.

! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
storeFieldsOn: anObjStream

	super storeFieldsOn: anObjStream.
	self storeFieldsNamed: #(
		userSpec
	) on: anObjStream.
! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 14:37'!
userSpec
	^userSpec! !

!CustomReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 03:26'!
userSpec: aString
	| cat |

	userSpec _ aString.
	isTemplate ifTrue: [self removeVariableTemplates].
	cat _ self category.
	cat ifNotNil: [
		self color: (ScriptableScratchMorph blockColorFor: cat asString) ].
	self commandSpec: (receiver definitionFor: self id) commandSpec.
	self addLabel! !


!CustomReporterBlockMorph methodsFor: 'identification' stamp: 'jens 1/14/2010 20:36'!
id
	^CustomBlockDefinition idFromSpec: userSpec! !


!CustomReporterBlockMorph methodsFor: 'stack/tuple conversion' stamp: 'jens 7/20/2010 22:59'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple argList arg val eval |
	blockTuple _ Array new: argMorphs size + 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: userSpec.

	argList _ argMorphs.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [(arg isKindOf: MultiArgMorph)
				ifTrue: [ blockTuple at: i + 4 put: arg listValue convertStacksToTuples] "a list"
				ifFalse: [ ((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
					ifTrue: [blockTuple at: i + 4 put: arg asBlockTuple]
					ifFalse: [(arg isKindOf: ExpressionArgMorph)
						ifTrue: [
							val _ arg getExpression.
							arg isNumberExpression
								ifTrue: [val = ' ' asUTF8
									ifTrue: [eval _ val]
									ifFalse: [eval _ val asNumberNoError]]
								ifFalse: [eval _ arg getExpression]]
						ifFalse: [eval _ arg evaluate].
						blockTuple at: i + 4 put: eval]]]
			ifFalse: [blockTuple at: i + 4 put: arg asBlockTuple]].
	^ blockTuple
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CustomReporterBlockMorph class
	instanceVariableNames: ''!

!CustomReporterBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 22:27'!
template
	^self new isTemplate: true! !


DialogBoxMorph subclass: #DebuggerFrameMorph
	instanceVariableNames: 'resizeMorph resizeOffset contentsFrame contentsMorph scroller thread varButton returnValue '
	classVariableNames: 'UserPos UserSize '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
centerOnScreen
	super centerOnScreen.
	self updateResizeMorph! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/29/2010 23:00'!
createButtons
	"Replace my current buttons with the ones specified."
	"Note: The button row morph was created by initialize; I just replace its contents with a new collection of buttons."

	| spacer jump cb |
	spacer _ Morph new extent: 10@5; color: Color transparent.
	buttonRow removeAllMorphs.

	buttonRow addMorphBack: (self buttonLabel: '>' action: #resume).

	buttonRow addMorphBack: (self buttonLabel: '>|' action: #stepNext).

	buttonRow addMorphBack: (jump _ (self buttonLabel: '>>' action: #jumpOver)).
	buttonRow addMorphBack: spacer fullCopy.

	buttonRow addMorphBack: (varButton _ (self buttonLabel: 'variables' localized action: #varMenu)).
	buttonRow addMorphBack: spacer fullCopy.

	buttonRow submorphs do: [:b |
		(b isKindOf: ResizableToggleButton2) ifTrue: [tabFields add: b]].

	cb _ thread currentBlock.
	cb nextBlock ifNil: [^jump isHidden: true].
	({CBlockMorph. IfElseBlockMorph. CustomCommandBlockMorph. CustomReporterBlockMorph} 
		includes: cb class) 
			ifFalse: [jump isHidden: true]! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 17:43'!
extent: aPoint
	
	| newExtent min|

	min _ self class minExtent.
"	contentsMorph ifNotNil: [
		min _ min + contentsMorph extent + (0 @ 5)]."

	newExtent _ aPoint max: min.

	bounds extent = newExtent ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: newExtent.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: newExtent.

	self keepOnScreen
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 17:38'!
fixLayoutForExtent: aPoint

	super fixLayoutForExtent: aPoint.

	titleBin ifNotNil: [ titleBin width: aPoint x - 40 ].


	contentsFrame ifNil: [^self ].

	contentsFrame extent: aPoint - (65 @ 105).
	scroller extent: contentsFrame extent.
"
	contentsMorph position: contentsFrame position + (contentsFrame extent - contentsMorph extent // 2).
"

	self updateResizeMorph! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:52'!
getUserResponse
	"Wait for the user to respond, then report their response. The symbol #cancel is returned if the user wishes to cancel the operation. True/false is returned if they respond yes/no, and a string is returned if this this a string input dialog and they don't cancel."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	self openInWorld.
	UserPos isNil 
		ifTrue: [ self centerOnScreen ]
		ifFalse: [self snapToUserDimensions ].
		
	w _ self world.
	self buttons size > 0 ifTrue: [
		w activeHand newKeyboardFocus: self buttons last].
	tabFields size > 0 ifTrue: [
		w activeHand newKeyboardFocus: (tabFields at: 1)].

	done _ false.
	[done] whileFalse: [w doOneCycle].  "wait for user to press a button, this effectively pauses all other threads as well -jens"

	^ response
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
handlesMouseDown: evt
	^true! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/21/2010 02:59'!
hasVars

	| vars env |

	returnValue ifNotNil: [^ true].
	
	(thread currentBlock receiver isKindOf: VariableFrame)
		ifTrue: [vars _ thread currentBlock receiver ]
		ifFalse: [vars _ thread temporaryVariables ].

	vars vars keys size > 0 ifTrue: [^true].

	env _ thread currentEnvironment.
	env ifNotNil: [ env = vars ifFalse: [
		env vars keys size > 0 ifTrue: [^ true]]].

	^ false! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 17:48'!
initialize

	super initialize.
	self title: 'Debugger'.
	resizeMorph _ ScratchResizeMorph ofType: #corner.

	scroller _ ScrollFrameMorph2 new
		growthFraction: 0.0;
		color: Color transparent "ScratchFrameMorph scriptsPaneColor".

	contentsMorph := ImageMorph new.
	contentsFrame := Morph new color: Color transparent; extent: 150 @ 80.
	scroller extent: contentsFrame extent.
	contentsFrame addMorph: scroller.
	scroller contents: contentsMorph.

	mainColumn addMorph: contentsFrame.

	self addMorph: resizeMorph.


! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/9/2010 23:54'!
jumpOver
	thread jumpOver.
	self yes! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
justDroppedInto: aMorph event: evt
	"Never embed myself in a morph (e.g. the Stage)."

	super justDroppedInto: aMorph event: evt.
	self keepOnScreen
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
keepOnScreen

	| min |
	min _ self class minExtent.

	self left < 0 ifTrue: [ self left: 0].
	self top < 0 ifTrue: [ self top: 0].

	self right > Display extent x
		ifTrue: [ resizeOffset 
			ifNil: [ 
				self left: ((Display extent x - self width) max: 0).
				(self right > Display extent x and: [self width > min x])
					ifTrue: [self width: Display extent x - self left ]]
			ifNotNil: [self width: Display extent x - self left]].

	self bottom > Display extent y
		ifTrue: [ resizeOffset 
			ifNil: [	
				self top: ((Display extent y - self height) max: 0). 
				(self bottom > Display extent y and: [self height > min y])
					ifTrue: [self height: Display extent y - self top]]
			ifNotNil: [self height: Display extent y - self top]].

! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p |
	p _ evt cursorPoint.
	((resizeMorph bounds expandBy: 4) containsPoint: p)
		ifFalse: [evt hand grabMorph: self]
		ifTrue: [resizeOffset _ self bottomRight - p]
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
mouseMove: evt

	resizeOffset ifNotNil: [
		self extent: (evt cursorPoint - self topLeft) + resizeOffset ]

! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
mouseUp: evt

	resizeOffset _ nil.
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 20:41'!
on: aScratchProcess

	thread _ aScratchProcess.

	self 
		createButtons;
		updateContents;
		getUserResponse

! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 20:41'!
on: aScratchProcess returnValue: obj

	thread _ aScratchProcess.
	returnValue _ obj.

	self 
		createButtons;
		updateContents;
		getUserResponse

! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:50'!
rememberUserDimensions
	self class setUserPos: self position size: self extent! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 11:50'!
resume
	thread resume.
	self yes! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:51'!
snapToUserDimensions

	self extent: UserSize.
	UserPos ifNotNil: [
		self position: UserPos ].
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
step
	resizeOffset notNil | (owner isKindOf: HandMorph)
		ifTrue: [^self ].
	self keepOnScreen 
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 11:49'!
stepNext
	thread nextStep.
	self yes! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/10/2010 00:47'!
updateContents

	| block rcvr lbl |
	block _ thread currentBlock.

	contentsMorph ifNil: [^self].
	block ifNotNil: [
		rcvr _ block receiver.
		(rcvr respondsTo: #objName)
			ifTrue: [lbl _ rcvr objName]
			ifFalse: [ 
				lbl _ 'Debugger' localized.
				(block respondsTo: #variable) ifTrue: [
					lbl _ block variable]].
		returnValue isNil
			ifTrue: [ self title: lbl]
			ifFalse: [ self title: lbl, ' ^'].
		contentsMorph form: block imageForm ].

	self hasVars ifFalse: [
		varButton isHidden: true ]
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 23:32'!
updateResizeMorph
	resizeMorph ifNotNil: [
		resizeMorph position: self bottomRight - "resizeMorph extent - " bottomRightForm width ]
! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/29/2010 23:00'!
varMenu

	| menu vars env mh mw |
	menu _ CustomMenu new.

	returnValue ifNotNil: [
		menu add: 'report value' localized toolTip: returnValue action: nil.
		menu addLine].
	
	(thread currentBlock receiver isKindOf: VariableFrame)
		ifTrue: [vars _ thread currentBlock receiver ]
		ifFalse: [vars _ thread temporaryVariables ].

	vars vars keys asSortedCollection do: [:vname |
		menu add: vname toolTip: (vars vars at: vname) action: nil].

	menu addLine. 

	env _ thread currentEnvironment.
	env ifNotNil: [ env = vars ifFalse: [
		env vars keys asSortedCollection do: [:vname |
			menu add: vname toolTip: (env vars at: vname) action: nil]]].

	menu build.
	mh _ menu menuForm height.
	mw _ menu menuForm width.

	menu startUpWithCaption: nil at: (varButton left + (varButton width - mw // 2)) @ (varButton top - mh)! !

!DebuggerFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:51'!
yes
	"Yes button was pressed."

	self rememberUserDimensions.
	super yes.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DebuggerFrameMorph class
	instanceVariableNames: ''!

!DebuggerFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:55'!
initialize
	"DebuggerFrameMorph initialize"
	self resetDimensions! !

!DebuggerFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/10/2010 00:12'!
minExtent
	^350 @ 180.! !

!DebuggerFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:54'!
resetDimensions
	UserPos _ nil.
	UserSize _ self minExtent.! !

!DebuggerFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 21:53'!
setUserPos: aPoint size: anExtent
	UserPos _ aPoint.
	UserSize _ anExtent.! !


DialogBoxMorph subclass: #ElementsEditorFrameMorph
	instanceVariableNames: 'editor initialClass initialMethod resizeMorph resizeOffset '
	classVariableNames: 'UserPos UserSize '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
centerOnScreen
	super centerOnScreen.
	self updateResizeMorph! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
definition: aCustomBlockDefinition

	definition _ aCustomBlockDefinition.
	template _ CustomCommandBlockMorph template.
	template receiver: receiver.
	template userSpec: definition userSpec.
	bin addMorph:(template position: bin position + (10@10)).
	self buildScript.
	self buildVariables.
	self buildAtomicityToggle.
	self buildAnswerField.! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:09'!
extent: aPoint
	
	| w newExtent min|

	min _ self class minExtent.

	newExtent _ aPoint max: min.

	bounds extent = newExtent ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: newExtent.
		self layoutChanged.
		self changed].

	self fixLayoutForExtent: newExtent.

	UserPos isNil & resizeOffset isNil ifTrue: [
		w _ self world.
		w ifNotNil: [self position: w center - (self extent // 2)]].  "center on screen"

	self keepOnScreen
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:58'!
fixLayoutForExtent: aPoint

	super fixLayoutForExtent: aPoint.

	titleBin ifNotNil: [ titleBin width: aPoint x - 40 ].

	editor ifNil: [^self ].

	editor extent: aPoint - (65 @ 105).

	self updateResizeMorph! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:42'!
getUserResponse
	"Wait for the user to respond, then report their response. The symbol #cancel is returned if the user wishes to cancel the operation. True/false is returned if they respond yes/no, and a string is returned if this this a string input dialog and they don't cancel."
	"Details: This is invoked synchronously from the caller. In order to keep processing inputs and updating the screen while waiting for the user to respond, this method has its own version of the World's event loop."

	| w |
	self openInWorld.

	editor onMethod: initialMethod ofClass: initialClass.

	UserPos isNil 
		ifTrue: [ self centerOnScreen ]
		ifFalse: [self snapToUserDimensions ].
		
	w _ self world.
	self buttons size > 0 ifTrue: [
		w activeHand newKeyboardFocus: self buttons last].
	tabFields size > 0 ifTrue: [
		w activeHand newKeyboardFocus: (tabFields at: 1)].

	done _ false.
	[done] whileFalse: [w doOneCycle].  "wait for user to press a button"

	^ response
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
handlesMouseDown: evt
	^true! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:16'!
initialize
	super initialize.
	self title: 'Elements Editor'.
	resizeMorph _ ScratchResizeMorph ofType: #corner.
	
	editor := ElementsMethodEditorMorph new.

	mainColumn addMorph: editor.

	self addMorph: resizeMorph.


! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
justDroppedInto: aMorph event: evt
	"Never embed myself in a morph (e.g. the Stage)."

	super justDroppedInto: aMorph event: evt.
	self keepOnScreen
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
keepOnScreen

	| min |
	min _ self class minExtent.

	self left < 0 ifTrue: [ self left: 0].
	self top < 0 ifTrue: [ self top: 0].

	self right > Display extent x
		ifTrue: [ resizeOffset 
			ifNil: [ 
				self left: ((Display extent x - self width) max: 0).
				(self right > Display extent x and: [self width > min x])
					ifTrue: [self width: Display extent x - self left ]]
			ifNotNil: [self width: Display extent x - self left]].

	self bottom > Display extent y
		ifTrue: [ resizeOffset 
			ifNil: [	
				self top: ((Display extent y - self height) max: 0). 
				(self bottom > Display extent y and: [self height > min y])
					ifTrue: [self height: Display extent y - self top]]
			ifNotNil: [self height: Display extent y - self top]].

! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p |
	p _ evt cursorPoint.
	((resizeMorph bounds expandBy: 4) containsPoint: p)
		ifFalse: [evt hand grabMorph: self]
		ifTrue: [resizeOffset _ self bottomRight - p]
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseMove: evt

	resizeOffset ifNotNil: [
		self extent: (evt cursorPoint - self topLeft) + resizeOffset ]

! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
mouseUp: evt

	resizeOffset _ nil.
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:41'!
onMethod: sel ofClass: cls

	initialClass _ cls.
	initialMethod _ sel.
	self 
		withButtonsForYes: false no: false okay: true cancel: false;
		getUserResponse
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
rememberUserDimensions
	self class setUserPos: self position size: self extent! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
snapToUserDimensions

	self extent: UserSize.
	UserPos ifNotNil: [
		self position: UserPos ].
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
step
	resizeOffset notNil | (owner isKindOf: HandMorph)
		ifTrue: [^self ].
	self keepOnScreen 
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
updateResizeMorph
	resizeMorph ifNotNil: [
		resizeMorph position: self bottomRight - "resizeMorph extent - " bottomRightForm width ]
! !

!ElementsEditorFrameMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 01:33'!
yes
	"Yes button was pressed."
	SyntaxElementMorph allSubInstances do: [:element |
		(element ownerThatIsA: ElementsMethodEditorMorph)
			ifNil: [element delete]].
	self rememberUserDimensions.
	super yes.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ElementsEditorFrameMorph class
	instanceVariableNames: ''!

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
initialize
	"BlockEditorFrameMorph initialize"
	self resetDimensions! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:47'!
minExtent
	^600 @ 430.! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
resetDimensions
	UserPos _ nil.
	UserSize _ self minExtent.! !

!ElementsEditorFrameMorph class methodsFor: 'as yet unclassified' stamp: 'jens 8/24/2009 00:07'!
setUserPos: aPoint size: anExtent
	UserPos _ aPoint.
	UserSize _ anExtent.! !


ReporterBlockMorph subclass: #LabelFragmentBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!LabelFragmentBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2010 11:32'!
addLabel
	"Add a label for my command and arguments. This is the method that really creates the whole block."
	"Details: We remove all the pieces of this block, and then reassemble them, being careful not to destroy any argument morphs that we might still want to use. This is helpful if someone adds/removes parameters from a hat block."

	| tokens args nextArgIndex m next |
	commandSpec ifNil: [^ self].

	"we make sure not to remove the next block."
	next _ self nextBlock.
	self removeAllMorphsIn: (self submorphs reject: [:t | t = next]).

	tokens _ self parseCommandSpecPreservingBlanks: commandSpec.
	args _ tokens select: [:s | CommandBlockMorph isArgSpec: s].

	"remove any excess arg morphs from the list."
	[argMorphs size > args size] whileTrue: [
		m _ argMorphs last.
		argMorphs remove: m.

		"if the argument we're throwing out is anything complicated, we'd like to keep it around in the world."
		(m isKindOf: BlockMorph) ifTrue: [m openInWorld]].

	"create new arg morphs."
	[argMorphs size < args size] whileTrue: [
		argMorphs addLast: (self argMorphFor: (args at: argMorphs size + 1))].

	nextArgIndex _ 1.

	tokens do: [:s |
		(CommandBlockMorph isArgSpec: s)
			ifTrue:	[
				m _ argMorphs at: nextArgIndex.
				nextArgIndex _ nextArgIndex + 1]
			ifFalse:	[
				m _ self labelMorphFor: s].
		self addMorphBack: m].

	self isReporter ifTrue: [

		"attempt to embed ReporterScripts more gracefully. Has some issues, 
		commented out for now, (jens)"
		
		"self adjustReporterLayoutForLambda."
		
		m _ submorphs last.
		((m isKindOf: ChoiceArgMorph) | (m isKindOf: SpriteArgMorph)) ifTrue: [  "add spacer"
			self addMorphBack: (Morph new color: Color transparent; extent: 2@5)]].
! !

!LabelFragmentBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/6/2010 23:01'!
drawOn: aCanvas 

	| right topY bottomY xInset c toggle l t cArgs clip |
	self computeHighlightColors.

	l _ OrderedCollection new.

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	toggle _ 0.
	[topY >= 0] whileTrue: [
		topY = 0 ifTrue: [c _ highlightColor1].
		topY = 1 ifTrue: [c _ highlightColor2].
		topY > 1 ifTrue: [c _ color].
		self addHLineFrom: xInset to: right - xInset y: topY color: c to: l.
		(topY > 1) & (xInset > 0) ifTrue: [
			self addPoint: xInset@topY 
				color: (toggle < 2 ifTrue: [shadowColor] ifFalse: [color])
				to: l.
			self addPoint: (right - xInset - 1)@topY 
				color: (toggle < 2 ifTrue: [color] ifFalse: [shadowColor])
				to: l].

		c _ bottomY = (self height - 1) ifTrue: [shadowColor] ifFalse: [color].
		self addHLineFrom: xInset to: right - xInset y: bottomY color: c to: l.
		xInset > 0 ifTrue: [
			self addPoint: xInset@bottomY 
				color: (toggle > 1 ifTrue: [highlightColor1] ifFalse: [color])
				to: l.
			self addPoint: (right - xInset - 1)@bottomY 
				color: (toggle > 1 ifTrue: [color] ifFalse: [shadowColor])
				to: l].

		toggle < 2 
			ifTrue: [ 
				xInset _ xInset + 1.2.
				toggle _ toggle + 1 ]
			ifFalse: [
				xInset _ xInset - 1.
				toggle _ toggle + 1.
				toggle > 4 ifTrue: [
					toggle _ 0]].
		bottomY _ bottomY + 1.
		topY _ topY - 1].

	cArgs _ self nonControlFlowSubmorphs select: [:s | (s isKindOf: CArgSlotMorph) or: [s isKindOf: CReporterSlotMorph]].
	cArgs isEmpty 
		ifFalse: [
			cArgs do: [:ca |
				t _ OrderedCollection new.
				l do: [:pair |
					self addAreasOf: pair first outside: ca bounds color: pair second to: t].
			l _ t].
			t _ OrderedCollection new.
			clip _ (self right + 4 - (self height // 2) @ self top) corner: self bottomRight.
			l do: [:pair |
				self addAreasOf: pair first outside: clip color: pair second to: t].
			l _ t].
	
	l do: [:pair |
		aCanvas fillRectangle: pair first color: pair second ].
! !

!LabelFragmentBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/6/2010 23:04'!
fixBlockLayout
	self fixBlockLayoutNoWrap.
	(self submorphs select: [:m | (m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph]]) do: [:m |
		m width: 50]! !

!LabelFragmentBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:58'!
parseCommandSpecPreservingBlanks: aCommandSpec
	"Answer an array of token strings containing my keywords and argument specs."

	| result len i j spec k |
	result _ OrderedCollection new.
	spec _ aCommandSpec.
	(spec isKindOf: UTF8) ifTrue: [spec _ String withAll: spec].
	len _ aCommandSpec size.

	i _ 1.
	[(i < len) and: [(spec at: i) isSeparator]] whileTrue: [i _ i + 1].
	[i <= len] whileTrue: [
		j _ spec indexOf: $% startingAt: i.
		j > 0
			ifTrue: [
				j > i ifTrue: [result addLast: (spec copyFrom: i to: j - 1)].
				j < len
					ifTrue: [k _ j + 1.
						((spec at: k) isLetter | (spec at: k) isDigit) 	"digits added for BYOB  -Jens"
							ifTrue: [[(k+1 <= len) and: [(spec at: k+1) isDigit]] whileTrue:[
								k _ k + 1].
								(k >= len)
									ifTrue: [result addLast: (spec copyFrom: j to: len).
										i _ len + 1]
									ifFalse: [result addLast: (spec copyFrom: j to: k).
										i _ k+1]]
							ifFalse: [result addLast: '%'.
										i _ j + 1]]
					ifFalse: [result addLast: '%'.
						i _ j + 2]]
			ifFalse: [
				result addLast: (spec copyFrom: i to: len).
				i _ len + 1]].

	result _ result select: [:s | s ~= ' '].
	^ result asArray collect: [:s | s copyReplaceAll: '_' with: ' ' asTokens: false]
! !


CommandBlockMorph subclass: #MultiArgCommandBlockMorph
	instanceVariableNames: 'addElementMorph removeElementMorph minArgs maxArgs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:49'!
addItem
	self stop.
	self commandSpec: commandSpec, ' %s'.


! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 22:21'!
addLabel

	super addLabel.
	removeElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90).
	argMorphs size > self minArgs ifTrue: [
		self addMorphBack: removeElementMorph].	
	addElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90).

	(selector = #doMakeNewList or: [
		((selector notNil and: [selector endsWith: 'List']) not
			and: [ maxArgs isNil or: [argMorphs size < maxArgs]])]) 
				ifTrue: [ self addMorphBack: addElementMorph].

	self adjustInternals! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 23:19'!
adjustInputParadigm: choice
	"private"

	| newSpec |

	(#(doRunBlockWithArgs doRunBlockWithArgList doForkBlockWithArgs doForkBlockWithArgList doCallBlockWithArgs doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	'with inputs' localized = choice ifTrue: [ 
		(selector endsWith: 'List') ifTrue: [
			selector _ ((selector copyFrom: 1 to: selector size - 'List' size), 's') asSymbol]].
	'with input list' localized = choice ifTrue: [
		(selector endsWith: 'List') ifFalse: [
			selector _ ((selector copyFrom: 1 to: selector size - 1), 'List') asSymbol ]].
	(selector endsWith: 'List') 
		ifTrue: [maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec localized asMacRoman. 
	self commandSpec: newSpec.





! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/16/2010 23:43'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(		
			doRun
			doRunBlockWithArgs 
			doRunBlockWithArgList 
			doFork doForkBlockWithArgs 
			doForkBlockWithArgList 
			doReport 
			doCallBlockWithArgs 
			doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	sdict _ Dictionary new.
	argMorphs size = 2  ifTrue: [ 
		((selector endsWith: 'Args') |  (selector endsWith: 'List')) not 
			ifTrue: [
				sdict
					at: #doRun put: #doRunBlockWithArgs;
					at: #doFork put: #doForkBlockWithArgs;
					at: #doReport put: #doCallBlockWithArgs;
					yourself]
			ifFalse: [
				sdict
					at: #doRunBlockWithArgs put: #doRun;
					at: #doRunBlockWithArgList put: #doRun;
					at: #doForkBlockWithArgs put: #doFork;
					at: #doForkBlockWithArgList put: #doFork;
					at: #doCallBlockWithArgs put: #doReport;
					at: #doCallBlockWithArgList put: #doReport;
					yourself]].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [ selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.
	(selector endsWith: 'List') 
		ifTrue: [ maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.
	self commandSpec: newSpec.
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 01:12'!
argumentAt: index
	"Returns the argument morph at the given index."

	^argMorphs at: index.	"BYOB custom blocks don't need argPermutations"

! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/15/2010 23:43'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg val eval |
	
	blockTuple _ Array new: argMorphs size + 3.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	1 to: argMorphs size do: [:i |
		arg _ argMorphs at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
				ifTrue: [blockTuple at: i + 3 put: arg asBlockTuple]
				ifFalse: [(arg isKindOf: ExpressionArgMorph)
					ifTrue: [
						val _ arg getExpression.
						arg isNumberExpression
							ifTrue: [val = ' ' asUTF8
								ifTrue: [eval _ val]
								ifFalse: [eval _ val asNumberNoError]]
							ifFalse: [eval _ arg evaluate]]
					ifFalse: [eval _ arg evaluate].
					blockTuple at: i + 3 put: eval]]
			ifFalse: [blockTuple at: i + 3 put: arg asBlockTuple]].
	^ blockTuple
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/25/2010 01:05'!
fixBlockLayoutWrap
	"Update the positions of my submorphs."

	| parts lines line h x y minXForArgs nextB w space left maxX maxHeight mh |

	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	parts _ self nonControlFlowSubmorphs.
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	minXForArgs _ self left.
	space _ 4.

	parts do: [:m |
	((m isKindOf: CArgSlotMorph) or: [(m isKindOf: CReporterSlotMorph) or: [(m isKindOf: MultiArgMorph) and: [m isWrapping]]])
		ifTrue: [ 
			line isEmpty ifFalse: [
				lines add: line].
			m left: "self" left.
			lines add: (OrderedCollection with: m).
			(m isKindOf: MultiArgMorph)
				ifTrue: [m fixArgLayout]
				ifFalse: [m fixBlockLayout].
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
				ifTrue: [m width: 40].
			line _ OrderedCollection new.
			maxX _ maxX max: left + m width.
			x _ left ]
		ifFalse: [
			(x - left > 400 and: [m ~~ parts last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].
			(m isKindOf: StringMorph)
				ifTrue: [m color: self labelColor]
				ifFalse: [x _ x max: minXForArgs].

			m left: x.
			(m fullBounds right - left > 400 and: [line isEmpty not and: [m ~~ parts last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
			maxX _ maxX max: x]].
	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 37.

	"distribute lines vertically"

	space _ 2.
	y _ self top + 2 "4" "space".
	lines do: [:eachLine |
		maxHeight _ 14.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate 
			or: [((m isKindOf: CArgSlotMorph) or: [m isKindOf: OSlotMorph]) and: [m isEmptySlot not]] ])
				ifTrue: [mh _ m height + 5]
				ifFalse: [mh _ m height].
			maxHeight _ mh max: maxHeight.
			(m isKindOf: CArgSlotMorph) ifTrue: [
				maxHeight _ m height - 4]].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + 1].
		y _ y + maxHeight + space].

	"adjust CArgSlots"

	parts do: [:m |
		((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
			ifTrue: [m width: w - 5]].

	self isStop
		ifTrue: [h _ y - self top + space]
		ifFalse: [h _ y - self top + space + 4.].

	(parts last isKindOf: CArgSlotMorph) ifTrue: [
		h _ h + space + 5].
	
	self extent: w @ h.

	"adjust Multi-CArgSlots"

	parts do: [:m | (m isKindOf: MultiArgMorph)
		ifTrue: [m loopsWidth: w - 5]].

	(nextB _ self nextBlock) ifNotNil: [
		nextB position: self left@(self bottom - 4).
		nextB fixBlockLayout].
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/7/2010 23:59'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	selector ifNil: [^nil].
	(selector beginsWith: 'doRun')
		ifTrue: [^'doRun'].
	(selector beginsWith: 'doFork')
		ifTrue: [^'doFork'].
	^super helpScreenName
! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 23:39'!
maxArgs
	^ maxArgs! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/17/2010 23:39'!
maxArgs: anInteger
	maxArgs _ anInteger! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 00:38'!
minArgs
	^minArgs ifNil: [minArgs _ 0]! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/1/2009 13:01'!
minArgs: anInteger
	minArgs _ anInteger! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 00:38'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(addElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self addItem ].
		(removeElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self removeItem ]].
	^super mouseDown: evt! !

!MultiArgCommandBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:49'!
removeItem
	self stop.
	argMorphs size > self minArgs ifTrue: [
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ].
! !


ArgMorph subclass: #MultiArgMorph
	instanceVariableNames: 'text type minArgCount defaultArgCount isWrapping '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:25'!
addArg: aBlockOrValue

	| newMorph newSubs |
	((aBlockOrValue isKindOf: CommandBlockMorph) or: [
		aBlockOrValue isKindOf: ArgMorph])
		ifTrue: [newMorph _ aBlockOrValue]
		ifFalse: [newMorph _ self newSlot].
	newMorph owner ifNotNil: [
		newMorph owner privateRemoveMorph: newMorph].
	newMorph layoutChanged.
	newMorph privateOwner: self.
	newSubs _ Array new: submorphs size + 1.
	1 to: submorphs size - 2 do: [:i |
		newSubs at: i put: (submorphs at: i) ].
	newSubs at: submorphs size - 1 put: newMorph.
	newSubs at: submorphs size put: self lessButton.
	newSubs at: submorphs size + 1 put: self moreButton.
	submorphs _ newSubs.
	newMorph changed.
	self layoutChanged	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:01'!
addArgSlot

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	self addArg: self newSlot;
	fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 22:02'!
argMorphToReplace: aBlock
	^ self newSlot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:04'!
buildControls

	submorphs do: [:sm | sm delete].

	self addMorphBack: ((StringMorph contents: text font: (ScratchFrameMorph getFont: #Label))
		color: ((owner respondsTo: #labelColor) ifTrue: [owner labelColor] ifFalse: [Color white])).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90)).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90)).

	self fixArgLayout
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/6/2010 23:30'!
color
	(owner respondsTo: #color) ifTrue: [
		^owner color]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/24/2010 23:18'!
contrastColor
	submorphs do: [:m |	(m isKindOf: BlockMorph)
		ifTrue: [ m contrastColor ]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount
	^ defaultArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount: anInt
	defaultArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2011 00:40'!
defaultValue: aScratchListMorph
	"Set my default value"

	| element |

	(aScratchListMorph isKindOf: ScratchListMorph)
		ifFalse: [^ self].
	1 to: aScratchListMorph lineCount do: [:i |
		element _ aScratchListMorph lineAt: i.
		((element isKindOf: ReporterBlockMorph)
		and: [(element isKindOf: ArgMorph) not])
			ifTrue: [self addArg: element]
			ifFalse: [
				self addArgSlot.
				(element isKindOf: ReporterBlockMorph)
					ifTrue: [((element respondsTo: #body) and: [element body notNil])
						ifTrue: [
							self replaceSubmorph: self elements last by: element 
							"self elements last replaceArgMorph: self elements last args first by: element body"]]
					ifFalse: [ 
						element = 'nil' asUTF8
							ifTrue: [element _ nil].
						self elements last defaultValue: element ]]]
		! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:44'!
elements
	^ submorphs reject: [:sm |
		(sm isKindOf: ImageMorph)
		or: [sm isKindOf: StringMorph]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:12'!
evaluate
	 | list |

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [^implicitValue].

	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		list insertLine:  (ScriptableScratchMorph new asListElement: each evaluate) at: (list lineCount + 1) ].
	list updateCountMorph.
	list fixLayout.
	list startStepping.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 00:51'!
fixArgLayoutNoWrap

	| maxHeight newWidth x space shouldHide visible |

	x _ self left.
	space _ 4.
	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	visible _ submorphs select: [:sm| sm isVisible].
	maxHeight _ (visible collect: [:sm | sm height]) max.
	visible do: [: sm |
		(sm = self label or: [| e | e _ self elements. e isEmpty or: [sm = e first]]) 
			ifTrue: [ x _ x - 2]
			ifFalse: [ x _ x + space].
		sm position: x @ (self top + (maxHeight - sm height // 2)).
		sm changed.
		x _ x + sm width].
	newWidth _ x - self left.
	self extent: newWidth @ maxHeight.
	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:13'!
handlesMouseDown: evt

	| more less |
	more _ self moreButton.
	less _ self lessButton.
	^ (more isVisible & (more containsPoint: evt cursorPoint))
		or: [less isVisible & (less containsPoint: evt cursorPoint)]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
initialize

	super initialize.
	isWrapping _ false.
	self color: Color transparent.
	self borderWidth: 0.
	text _ ''.
	type _ #any.
	minArgCount _ 0.
	defaultArgCount _ 1.
	self buildControls.
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/22/2010 01:03'!
isEmptySlot


	^self elements isEmpty! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:30'!
isLambdaForm
	^false! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
isWrapping
	^isWrapping
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:45'!
label
	^ submorphs first! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
lessButton
	^ submorphs at: submorphs size - 1! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:14'!
listValue
	 | list item |
	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		(each isKindOf: ReporterBlockMorph)
			ifTrue: [item _ each]
			ifFalse: [each isEmptySlot
				ifTrue: [item _ nil]
				ifFalse: [item _ each evaluate]].
		list insertLine: (ScriptableScratchMorph new asListElement: item) at: (list lineCount + 1) ].
	list updateCountMorph.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:13'!
loopsWidth: anInteger

	| parts |

	type = #loop ifFalse: [^ self].
	self width: (anInteger max: 50).
	parts _ submorphs select: [:sm | (sm isKindOf: CArgSlotMorph) or: [sm isKindOf: CReporterSlotMorph]].
	parts do: [:m |
		m width: self width ]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
minArgCount
	^ minArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:07'!
minArgCount: anInt
	minArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
moreButton
	^ submorphs at: submorphs size! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:26'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(self moreButton containsPoint: evt cursorPoint)
			ifTrue: [^self addArgSlot ].
		(self lessButton containsPoint: evt cursorPoint)
			ifTrue: [^self removeArgSlot ]].
	^super mouseDown: evt
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
newSlot

	| specs slot |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #reporter put: '%r';
		at: #predicate put: '%p';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #unevaluatedBoolean put: '%Q';
		at: #objSlot put: '%1'.

" +++ deprecated experimental slots    -jens ++++++

		at: #reporterSlot put: '%K';
		at: #typeInReporter put: '%j'.

+++++++++++++++++++++++++++++++++++++++++++++++"

	slot _ CommandBlockMorph new uncoloredArgMorphFor: (specs at: type ifAbsent: [ '%s']).
	slot defaultValue: ''.
	^slot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:00'!
removeArgSlot

	| oldArg  |

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	oldArg _ submorphs at: submorphs size - 2.
	((oldArg isKindOf: BlockMorph) and: [(oldArg isKindOf: ArgMorph) not])
		ifTrue: [World addMorph: oldArg]
		ifFalse: [oldArg delete].
	self fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 03:59'!
replaceArgMorph: oldArg by: newArg

	self replaceSubmorph: oldArg by: newArg
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 21:51'!
tabFields

	| fields |
	fields _	OrderedCollection new.
	submorphs do: [:m |
		(m isKindOf: ReporterBlockMorph)
			ifTrue: [fields addAll: m tabFields ]
			ifFalse: [(m isKindOf: ExpressionArgMorph)
				ifTrue: [fields add: m]]].
	^ fields! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:51'!
text
	^ text! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:50'!
text: aString
	text _ aString! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 14:29'!
topBlock

	(owner isKindOf: BlockMorph) ifTrue: [
		^owner topBlock].
	^nil
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 15:32'!
transparentRect
	^ self position corner: (self right@submorphs last top)! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:08'!
type
	^type! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none			- a puzzle shaped command block
    #any			- a non-typed round reporter block (can be anything)
    #string			- a round reporter block that answers a string
    #number		- a round reporter block that answers a number
    #list				- a round reporter block that answers a number
    #boolean		- a hexagonal reporter block that answers a boolean
    #command		- a round reporter block that answers a procedure (a command block)
    #reporter		- a round reporter block that answers a function (a reporter block)
    #predicate		- a hexagonal reporter block that answers a reporter of a boolean 
    #template		- a sunken variable blob that represents an externalized block variable
    #loop			- a C-shaped slot
    #reporterSlot		- a C-shaped reporter slot
    #typeInReporter	- a rectangular reporter slot that can be typed into
    #unevaluated	- a rectangular type-in slot that auto-lambdafies
    #unevaluatedBoolean
    #objSlot

"

	type _ aSymbol! !


!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:32'!
receiver

	"needed for error handling"
	(owner isKindOf: BlockMorph) ifTrue: [
		^owner receiver].
	^nil

! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:36'!
showError
	"Make this block to show an error."

	(owner isKindOf: BlockMorph) ifTrue: [
		owner showError]! !


!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:25'!
addArg: aBlockOrValue

	| newMorph newSubs |
	((aBlockOrValue isKindOf: CommandBlockMorph) or: [
		aBlockOrValue isKindOf: ArgMorph])
		ifTrue: [newMorph _ aBlockOrValue]
		ifFalse: [newMorph _ self newSlot].
	newMorph owner ifNotNil: [
		newMorph owner privateRemoveMorph: newMorph].
	newMorph layoutChanged.
	newMorph privateOwner: self.
	newSubs _ Array new: submorphs size + 1.
	1 to: submorphs size - 2 do: [:i |
		newSubs at: i put: (submorphs at: i) ].
	newSubs at: submorphs size - 1 put: newMorph.
	newSubs at: submorphs size put: self lessButton.
	newSubs at: submorphs size + 1 put: self moreButton.
	submorphs _ newSubs.
	newMorph changed.
	self layoutChanged	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:01'!
addArgSlot

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	self addArg: self newSlot;
	fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 22:02'!
argMorphToReplace: aBlock
	^ self newSlot! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:04'!
buildControls

	submorphs do: [:sm | sm delete].

	self addMorphBack: ((StringMorph contents: text font: (ScratchFrameMorph getFont: #Label))
		color: ((owner respondsTo: #labelColor) ifTrue: [owner labelColor] ifFalse: [Color white])).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90)).

	self addMorphBack: (ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90)).

	self fixArgLayout
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/6/2010 23:30'!
color
	(owner respondsTo: #color) ifTrue: [
		^owner color]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/24/2010 23:18'!
contrastColor
	submorphs do: [:m |	(m isKindOf: BlockMorph)
		ifTrue: [ m contrastColor ]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount
	^ defaultArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
defaultArgCount: anInt
	defaultArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2011 00:40'!
defaultValue: aScratchListMorph
	"Set my default value"

	| element |

	(aScratchListMorph isKindOf: ScratchListMorph)
		ifFalse: [^ self].
	1 to: aScratchListMorph lineCount do: [:i |
		element _ aScratchListMorph lineAt: i.
		((element isKindOf: ReporterBlockMorph)
		and: [(element isKindOf: ArgMorph) not])
			ifTrue: [self addArg: element]
			ifFalse: [
				self addArgSlot.
				(element isKindOf: ReporterBlockMorph)
					ifTrue: [((element respondsTo: #body) and: [element body notNil])
						ifTrue: [
							self replaceSubmorph: self elements last by: element 
							"self elements last replaceArgMorph: self elements last args first by: element body"]]
					ifFalse: [ 
						element = 'nil' asUTF8
							ifTrue: [element _ nil].
						self elements last defaultValue: element ]]]
		! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:44'!
elements
	^ submorphs reject: [:sm |
		(sm isKindOf: ImageMorph)
		or: [sm isKindOf: StringMorph]]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:12'!
evaluate
	 | list |

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [^implicitValue].

	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		list insertLine:  (ScriptableScratchMorph new asListElement: each evaluate) at: (list lineCount + 1) ].
	list updateCountMorph.
	list fixLayout.
	list startStepping.
	^list	! !

!MultiArgMorph methodsFor: '-- all --' stamp: 'jens 7/7/2010 00:06'!
fixArgLayout

	| maxHeight x space shouldHide lines line left maxX parts w y mh h isMultiC |

	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	isMultiC _ #(loop reporterSlot) includes: type.
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left.
	left _ x.
	maxX _ x.
	space _ 4.

	isMultiC ifTrue: [
		self width: 50 ].

	parts _ submorphs select: [:sm| sm isVisible and: [(sm isKindOf: StringMorph) not]].

	parts do: [:m |
	(m isKindOf: ReporterBlockMorph) & isMultiC
		ifTrue: [ "in this case just break up into lines, don't distribute yet"
			m left: self left.
			lines add: (OrderedCollection with: m).
			m fixBlockLayout.
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph]) ifTrue: [
				m width: self width].
			maxX _ maxX max: left + m width.
			x _ left ]
		ifFalse: [
			(x - left > 300 and: [m ~~ submorphs last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].

			m left: x.
			(m right - left > 300 and: [line isEmpty not and: [m ~~ submorphs last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
				maxX _ maxX max: x]].

	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 4.

	isWrapping _ lines size > 1.

	"distribute lines vertically"

	space _ 0.
	y _ self top.
	isWrapping & isMultiC not ifTrue: [
		space _ 1.
		y _ self top + 2].
	lines do: [:eachLine |
		maxHeight _ 10.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate and: [m isEmptySlot not]])
				ifTrue: [mh _ m height + 7]
				ifFalse: [mh _ m height].
			maxHeight _ mh max: maxHeight].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2)].
		y _ y + maxHeight + space].
	h _ y - self top + space.

	self extent: w @ h.

	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 00:51'!
fixArgLayoutNoWrap

	| maxHeight newWidth x space shouldHide visible |

	x _ self left.
	space _ 4.
	shouldHide _ (submorphs size - 3 > minArgCount) not.
	self lessButton isHidden: shouldHide.
	self label isHidden: shouldHide.
	visible _ submorphs select: [:sm| sm isVisible].
	maxHeight _ (visible collect: [:sm | sm height]) max.
	visible do: [: sm |
		(sm = self label or: [| e | e _ self elements. e isEmpty or: [sm = e first]]) 
			ifTrue: [ x _ x - 2]
			ifFalse: [ x _ x + space].
		sm position: x @ (self top + (maxHeight - sm height // 2)).
		sm changed.
		x _ x + sm width].
	newWidth _ x - self left.
	self extent: newWidth @ maxHeight.
	self layoutChanged.
	owner ifNotNil: [owner layoutChanged].

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/12/2010 00:13'!
handlesMouseDown: evt

	| more less |
	more _ self moreButton.
	less _ self lessButton.
	^ (more isVisible & (more containsPoint: evt cursorPoint))
		or: [less isVisible & (less containsPoint: evt cursorPoint)]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
initialize

	super initialize.
	isWrapping _ false.
	self color: Color transparent.
	self borderWidth: 0.
	text _ ''.
	type _ #any.
	minArgCount _ 0.
	defaultArgCount _ 1.
	self buildControls.
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/22/2010 01:03'!
isEmptySlot


	^self elements isEmpty! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/22/2010 02:30'!
isLambdaForm
	^false! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/21/2010 23:44'!
isWrapping
	^isWrapping
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:45'!
label
	^ submorphs first! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
lessButton
	^ submorphs at: submorphs size - 1! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 02:14'!
listValue
	 | list item |
	list _ ScratchListMorph new.
	list listName: '' target: nil.
	self elements do: [:each |
		(each isKindOf: ReporterBlockMorph)
			ifTrue: [item _ each]
			ifFalse: [each isEmptySlot
				ifTrue: [item _ nil]
				ifFalse: [item _ each evaluate]].
		list insertLine: (ScriptableScratchMorph new asListElement: item) at: (list lineCount + 1) ].
	list updateCountMorph.
	^list	! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:13'!
loopsWidth: anInteger

	| parts |

	type = #loop ifFalse: [^ self].
	self width: (anInteger max: 50).
	parts _ submorphs select: [:sm | (sm isKindOf: CArgSlotMorph) or: [sm isKindOf: CReporterSlotMorph]].
	parts do: [:m |
		m width: self width ]
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:08'!
minArgCount
	^ minArgCount! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:07'!
minArgCount: anInt
	minArgCount _ anInt! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:18'!
moreButton
	^ submorphs at: submorphs size! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 23:26'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(self moreButton containsPoint: evt cursorPoint)
			ifTrue: [^self addArgSlot ].
		(self lessButton containsPoint: evt cursorPoint)
			ifTrue: [^self removeArgSlot ]].
	^super mouseDown: evt
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
newSlot

	| specs slot |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #reporter put: '%r';
		at: #predicate put: '%p';
		at: #list put: '%t';
		at: #text put: '%T';
		at: #any put: '%s';
		at: #boolean put: '%b';
		at: #number put: '%n';
		at: #loop put: '%G';
		at: #unevaluated put: '%j';
		at: #unevaluatedBoolean put: '%Q';
		at: #objSlot put: '%1'.

" +++ deprecated experimental slots    -jens ++++++

		at: #reporterSlot put: '%K';
		at: #typeInReporter put: '%j'.

+++++++++++++++++++++++++++++++++++++++++++++++"

	slot _ CommandBlockMorph new uncoloredArgMorphFor: (specs at: type ifAbsent: [ '%s']).
	slot defaultValue: ''.
	^slot! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:32'!
receiver

	"needed for error handling"
	(owner isKindOf: BlockMorph) ifTrue: [
		^owner receiver].
	^nil

! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 01:00'!
removeArgSlot

	| oldArg  |

	(owner isKindOf: BlockMorph) ifTrue: [
		owner stop].

	oldArg _ submorphs at: submorphs size - 2.
	((oldArg isKindOf: BlockMorph) and: [(oldArg isKindOf: ArgMorph) not])
		ifTrue: [World addMorph: oldArg]
		ifFalse: [oldArg delete].
	self fixArgLayout! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 03:59'!
replaceArgMorph: oldArg by: newArg

	self replaceSubmorph: oldArg by: newArg
! !

!MultiArgMorph methodsFor: 'error handling' stamp: 'jens 3/22/2010 14:36'!
showError
	"Make this block to show an error."

	(owner isKindOf: BlockMorph) ifTrue: [
		owner showError]! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 21:51'!
tabFields

	| fields |
	fields _	OrderedCollection new.
	submorphs do: [:m |
		(m isKindOf: ReporterBlockMorph)
			ifTrue: [fields addAll: m tabFields ]
			ifFalse: [(m isKindOf: ExpressionArgMorph)
				ifTrue: [fields add: m]]].
	^ fields! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:51'!
text
	^ text! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/11/2010 22:50'!
text: aString
	text _ aString! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 14:29'!
topBlock

	(owner isKindOf: BlockMorph) ifTrue: [
		^owner topBlock].
	^nil
! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/22/2010 15:32'!
transparentRect
	^ self position corner: (self right@submorphs last top)! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2010 23:08'!
type
	^type! !

!MultiArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:36'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none			- a puzzle shaped command block
    #any			- a non-typed round reporter block (can be anything)
    #string			- a round reporter block that answers a string
    #number		- a round reporter block that answers a number
    #list				- a round reporter block that answers a number
    #boolean		- a hexagonal reporter block that answers a boolean
    #command		- a round reporter block that answers a procedure (a command block)
    #reporter		- a round reporter block that answers a function (a reporter block)
    #predicate		- a hexagonal reporter block that answers a reporter of a boolean 
    #template		- a sunken variable blob that represents an externalized block variable
    #loop			- a C-shaped slot
    #reporterSlot		- a C-shaped reporter slot
    #typeInReporter	- a rectangular reporter slot that can be typed into
    #unevaluated	- a rectangular type-in slot that auto-lambdafies
    #unevaluatedBoolean
    #objSlot

"

	type _ aSymbol! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MultiArgMorph class
	instanceVariableNames: ''!

!MultiArgMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/15/2010 23:49'!
type: aSymbol
	^ self new
		type: aSymbol;
		text: '';
		buildControls! !


ReporterBlockMorph subclass: #MultiArgReporterBlockMorph
	instanceVariableNames: 'addElementMorph removeElementMorph minArgs maxArgs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:59'!
addItem
	self stop.
	self commandSpec: commandSpec, ' %s'! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 22:19'!
addLabel

	super addLabel.
	removeElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: 90).
	argMorphs size > self minArgs ifTrue: [
		self addMorphBack: removeElementMorph].	
	addElementMorph _ ImageMorph new form: (ArgMorph dropDownMenuForm rotateBy: -90).

	(selector = #doMakeNewList or: [
		((selector notNil and: [selector endsWith: 'List']) not
			and: [ maxArgs isNil or: [argMorphs size < maxArgs]])]) 
				ifTrue: [ self addMorphBack: addElementMorph].

	self adjustInternals! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/16/2010 23:59'!
adjustInputParadigm: choice
	"private"

	| newSpec |
	(#(doRunBlockWithArgs doRunBlockWithArgList doForkBlockWithArgs doForkBlockWithArgList doCallBlockWithArgs doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	'with inputs' localized = choice ifTrue: [ 
		(selector endsWith: 'List') ifTrue: [
			selector _ ((selector copyFrom: 1 to: selector size - 'List' size), 's') asSymbol]].
	'with input list' localized = choice ifTrue: [
		(selector endsWith: 'List') ifFalse: [
			selector _ ((selector copyFrom: 1 to: selector size - 1), 'List') asSymbol ]].
	(selector endsWith: 'List') 
		ifTrue: [maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec localized asMacRoman. 
	self commandSpec: newSpec.





! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:00'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(		
			doRun
			doRunBlockWithArgs 
			doRunBlockWithArgList 
			doFork doForkBlockWithArgs 
			doForkBlockWithArgList 
			doReport 
			doCallBlockWithArgs 
			doCallBlockWithArgList)
		includes: selector) ifFalse: [^ self ].

	sdict _ Dictionary new.
	argMorphs size = 2  ifTrue: [ 
		((selector endsWith: 'Args') |  (selector endsWith: 'List')) not 
			ifTrue: [
				sdict
					at: #doRun put: #doRunBlockWithArgs;
					at: #doFork put: #doForkBlockWithArgs;
					at: #doReport put: #doCallBlockWithArgs;
					yourself]
			ifFalse: [
				sdict
					at: #doRunBlockWithArgs put: #doRun;
					at: #doRunBlockWithArgList put: #doRun;
					at: #doForkBlockWithArgs put: #doFork;
					at: #doForkBlockWithArgList put: #doFork;
					at: #doCallBlockWithArgs put: #doReport;
					at: #doCallBlockWithArgList put: #doReport;
					yourself]].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [ selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.
	(selector endsWith: 'List') 
		ifTrue: [ maxArgs _ 3]
		ifFalse: [maxArgs _ nil].		
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.
	self commandSpec: newSpec.
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 01:12'!
argumentAt: index
	"Returns the argument morph at the given index."

	^argMorphs at: index.	"BYOB custom blocks don't need argPermutations"
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/15/2010 23:45'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg val eval |
	
	blockTuple _ Array new: argMorphs size + 3.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	1 to: argMorphs size do: [:i |
		arg _ argMorphs at: i.
		(arg isKindOf: ArgMorph) | (arg isKindOf: EventTitleMorph)
			ifTrue: [((arg isKindOf: CSlotMorph) or: [arg isKindOf: OSlotMorph])
				ifTrue: [blockTuple at: i + 3 put: arg asBlockTuple]
				ifFalse: [(arg isKindOf: ExpressionArgMorph)
					ifTrue: [
						val _ arg getExpression.
						arg isNumberExpression
							ifTrue: [val = ' ' asUTF8
								ifTrue: [eval _ val]
								ifFalse: [eval _ val asNumberNoError]]
							ifFalse: [eval _ arg evaluate]]
					ifFalse: [eval _ arg evaluate].
					blockTuple at: i + 3 put: eval]]
			ifFalse: [blockTuple at: i + 3 put: arg asBlockTuple]].
	^ blockTuple
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluate
	"Evalue this block with the given argument list."

	self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	^scratchProc answer	! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: rawArgs
	"Evalue this block with the given argument list."

	self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	^scratchProc answer	! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/8/2010 23:48'!
fixBlockLayoutWrap
	"Update the positions of my submorphs."

	| parts lines line h x y minXForArgs w space left maxX maxHeight extraSpace mh |

	(#(function functionWithArgs doReport doCallWithArgs doCallBlockWithArgs) includes: selector) ifTrue: [
		self updateIsBoolean; layoutChanged].

	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	parts _ self nonControlFlowSubmorphs.
	parts isEmpty ifTrue: [^self].
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	minXForArgs _ self left.
	space _ 4.

	parts do: [:m |
	((m isKindOf: CArgSlotMorph) or: [(m isKindOf: CReporterSlotMorph) or: [(m isKindOf: MultiArgMorph) and: [m isWrapping]]])
		ifTrue: [ 
			line isEmpty ifFalse: [
				lines add: line].
			m left: self left - 5.
			lines add: (OrderedCollection with: m).
			(m isKindOf: MultiArgMorph)
				ifTrue: [m fixArgLayout]
				ifFalse: [m fixBlockLayout].
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
				ifTrue: [m width: 40].
			line _ OrderedCollection new.
			maxX _ maxX max: (left + m width).
			x _ left ]
		ifFalse: [
			(x - left > 300 and: [m ~~ parts last]) ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].
			(m isKindOf: StringMorph)
				ifTrue: [m color: self labelColor]
				ifFalse: [x _ x max: minXForArgs].

			m left: x.
			(m right - left > 300 and: [line isEmpty not and: [m ~~ parts last]])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
				maxX _ maxX max: x]].
	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 4.

	"distribute lines vertically"

	space _ 1.
	y _ self top "+ 2" "+ space".
	lines do: [:eachLine |
		maxHeight _ 14.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate or: [ 
			((m isKindOf: CArgSlotMorph) 
			or: [m isKindOf: OSlotMorph]) and: [m isEmptySlot not]] ])
				ifTrue: [mh _ m height + 10]
				ifFalse: [mh _ m height + 2].
			maxHeight _ mh max: maxHeight].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + 1].
		y _ y + maxHeight + space].
	h _ y - self top + space.


	"adjust lines to round / hex shape"

	extraSpace _ 0.
	lines size > 1 
		ifTrue: [extraSpace _ h // 2]
		ifFalse: [ isBoolean
			ifTrue: [extraSpace _ h // 3]].

	parts do: [:m|
		m left: m left + extraSpace].

	w _ w + (extraSpace * 2).

	"adjust CArgSlots"

	parts do: [:m |
		(m isKindOf: CArgSlotMorph)
			ifTrue: [m width: w - (extraSpace * 2) + 6]].

	(parts last isKindOf: CArgSlotMorph) ifTrue: [
		h _ h + space + 5].


	"stack nested Reporters more efficiently:"

	lines size > 1 ifTrue: [
		self height: h.
		lines do: [:l |
			| offset |
			((l first respondsTo: #bodyLeft) and: [(isBoolean and: [l first isBooleanReporter not]) not])
				ifTrue: [ offset _ l first bodyLeft - self bodyLeft]
				ifFalse: [ offset _ l first left - self bodyLeft].
				l do: [:m |
					self isBooleanReporter
						ifTrue: [m left: m left - offset + 2]
						ifFalse: [m left: m left - offset]]].

		maxX _ self left + 5.
		lines do: [:l |
			((l last respondsTo: #bodyRight)  and: [(isBoolean and: [l last isBooleanReporter not]) not])
				ifTrue: [maxX _ maxX max: l last bodyRight]
				ifFalse: [maxX _ maxX max: l last right]].
		self isBooleanReporter
			ifTrue: [self bodyRight: maxX + 2]
			ifFalse: [self bodyRight: maxX].

		"adjust Multi-CArgSlots"

		parts do: [:m | (m isKindOf: MultiArgMorph)
			ifTrue: [m loopsWidth: self bodyRight - self bodyLeft]]]

	ifFalse: [ self extent: w @ h].

	(self ownerThatIsA: ScratchBlockPaletteMorph) ifNotNil: [
		(self ownerThatIsA: ScratchBlockPaletteMorph) fixLayout].

! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:05'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	selector ifNil: [^nil].
	(selector beginsWith: 'doCall')
		ifTrue: [^'doCall'].
	(selector beginsWith: 'doReport')
		ifTrue: [^'doCall'].
	^super helpScreenName
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 14:00'!
maxArgs
	^ maxArgs! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/18/2010 14:00'!
maxArgs: anInteger
	maxArgs _ anInteger! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/23/2009 23:53'!
minArgs
	^minArgs ifNil: [minArgs _ 0]! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/23/2009 23:56'!
minArgs: anInteger
	minArgs _ anInteger! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/11/2009 20:10'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	evt hand newKeyboardFocus: nil.
	evt anyButtonPressed ifTrue: [
		(addElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self addItem ].
		(removeElementMorph containsPoint: evt cursorPoint)
			ifTrue: [^self removeItem ]].
	^super mouseDown: evt! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/24/2009 11:20'!
organizeArgs: argList
	"Answer an arugments array in which all arguments have been rearranged to the original English permutation"

	^ argList	"no permutations for these higher order blocks"
! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/24/2010 00:59'!
removeItem
	self stop.
	argMorphs size > self minArgs ifTrue: [
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !

!MultiArgReporterBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/6/2010 03:44'!
showValue

	| gotError msg tooltip w worldBounds |
	gotError _ false.

	[self start.
	scratchProc stepUntilDoneFor: (receiver ownerThatIsA: ScratchStageMorph).
	msg _ scratchProc answer] ifError: [
		gotError _ true.
		msg _ 'Error!!'].

	(msg isKindOf: Morph)
		ifTrue: [(msg respondsTo: #displayForm)
			ifTrue: [msg _ msg displayForm ]
			ifFalse: [msg _ msg imageForm ]]
		ifFalse: [msg _ msg asString ].

	(self isBooleanReporter or: [msg = 'Error!!']) ifTrue: [
		msg _ msg localized].
	tooltip _ (ScratchReporterToolTipMorph string: msg for: self)
		left: self right;
		bottom: self top.
	ScratchTranslator isRTL ifTrue: [tooltip right: self left].
	gotError ifTrue: [tooltip messageColor: Color red darker].

	w _ self world.
	w addMorphFront: tooltip.
	((worldBounds _ w bounds) containsRect: tooltip bounds) ifFalse:
		[tooltip bounds: (tooltip bounds translatedToBeWithin: worldBounds)].

	self setProperty: #toolTip toValue: tooltip.
	tooltip initialCursorPoint: Sensor cursorPoint.
	tooltip startStepping.

! !


MultiArgReporterBlockMorph subclass: #LambdaBlockMorph
	instanceVariableNames: 'parameters variables initialFrame type declarations isAtomic '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 5/4/2010 23:34'!
displayBlock

	| top b ans|

	b _ self optimized body.
	b ifNil: [^self fullCopy].

	parameters isEmpty ifTrue: [ 
		self optimized sequence first selector = #doAnswer ifTrue: [
			ans _ self optimized sequence first argMorphs first fullCopy.
			(ans isKindOf: ArgMorph) ifTrue: [^self].
			(ans isKindOf: CommandScriptBlockMorph) ifFalse: [
				ans allMorphs do: [:m | (m isKindOf: BlockMorph) ifTrue: [
						m isContrasted: false; addLabel]].
					^ ans]].
			^b].

	top _ self parameterTopBlock.
	top attachBlock: b.
	^top! !

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 4/14/2010 00:25'!
displayForm

	| block |

	block _ self displayBlock.
	block allMorphs do: [:m |
		(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout ]].
	^ block imageForm withOutlineColor: ScratchFrameMorph scriptsPaneColor width: 4! !

!LambdaBlockMorph methodsFor: 'visualisation' stamp: 'jens 8/4/2010 03:44'!
parameterTopBlock
	"private - for display purposes only"

	| block arg |
	block _ CommandBlockMorph new.
	block color: Color lightGray.
	block commandSpec: 'input names:' localized.

	parameters do: [:p |
		arg _ ReporterBlockMorph new.
		arg color: VariableFrame variableBlockColor.
		arg commandSpec: p.
		block addArg: arg].

	^ block


! !


!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 00:10'!
addVariable

	| ans |
	ans _ StringDialog askWithCancel: 'New Block Variable Name' initialAnswer: ''.
	ans isEmpty ifTrue: [^false].
	(self allVarNames includes: ans) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	variables add: ans.
	initialFrame add: ans.
	self rightButtonMenu! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 22:53'!
allVarNames
	^ (parameters, variables) asSortedCollection! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:36'!
bind: varName to: varFrame as: alias

	"for externalized local variables"

	self privateBody allMorphsDo: [:m |
		(m isKindOf: VariableBlockMorph) ifTrue: [
			m variable = varName ifTrue: [
				m
					receiver: varFrame;
					alias: alias ]]]! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 21:57'!
body
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2011 00:32'!
checkBoxLabelled: aString marked: aBool width: anInt
	"answer a form consisting of a checkbox and a label - used for the EDIT menu in BYOB"

	| box label pic line cnts |
	aBool
		ifTrue: [pic _ ScratchFrameMorph skinAt: #watcherButtonPressed]
		ifFalse: [pic _ ScratchFrameMorph skinAt: #watcherButton].
	box _ ImageMorph new form: pic. 
	
	ScratchTranslator useSqueakRendering
		ifTrue: [cnts _ ' ', aString localized asMacRoman]
		ifFalse: [cnts _ ' ' asUTF8, aString localized].

	label _ StringMorph contents: cnts font: Preferences standardMenuFont.
	line _ Morph new color: Color transparent.
	line height: (box height max: label height).
	line width: (box width + label width max: anInt).
	box left: line left.
	box top: line top + (line height - box height // 2).
	label left: box right.
	label top: line top + (line height - label height // 2).
	line addMorph: box.
	line addMorph: label.
	^ line imageForm

! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:53'!
declarations
	^declarations! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:53'!
declarations: aDictionary
	declarations _ aDictionary! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 04:39'!
evaluate
	^self optimized! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: rawArgs

	^self optimized! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:10'!
fixInitialFrame
	initialFrame _ VariableFrame forNames: self allVarNames.
	self allMorphsDo: [:m |
		((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph)
		and: [m isSpecialForm & (initialFrame scope includes: m variable)]) ifTrue: [
			m receiver: initialFrame ]]! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:43'!
initialFrame: aVariableFrame
	initialFrame _ aVariableFrame! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:16'!
initialize
	super initialize.
	type _ #none.
	parameters _ OrderedCollection new.
	variables _ OrderedCollection new.
	declarations _ Dictionary new.
	isAtomic _ false.
	initialFrame _ VariableFrame new! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:18'!
isAtomic
	^ isAtomic! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:18'!
isAtomic: aBoolean
	isAtomic _ aBoolean! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 23:08'!
isBooleanFunction
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:17'!
isFunction
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 20:33'!
isLambdaForm
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 20:34'!
isPartsBin
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/6/2010 01:34'!
morphToShow
"	^ self body ifNil: [self]"

	^ImageMorph new form:  self displayForm! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newChangeVarBlock: varName

	| block |
	block _ SetterBlockMorph new
		initChangerForVar: varName;
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #changeBlockVar:by: ";
		color: (ScriptableScratchMorph blockColorFor: 'variables')".
	block expressionArg stringExpression: '0'.
	^ block
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newSetVarBlock: varName

	| block |
	block _ SetterBlockMorph new
		initSetterForVar: varName;
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #setBlockVar:to:  ";
		color: (ScriptableScratchMorph blockColorFor: 'variables')".
	block expressionArg stringExpression: '0'.
	^ block
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:46'!
newVarBlock: varName

	^ VariableBlockMorph new
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #getBlockVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: varName
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 11:22'!
optimized
	^ (self fullCopy)
		fixInitialFrame! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 01:52'!
parameterNames
	^ parameters! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 02:34'!
parameters
	^ parameters! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
parameters: anOrderedCollection
	 parameters _ anOrderedCollection! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:32'!
privateBody
	self subclassResponsibility! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:09'!
removeLastArg

	| idx |
	idx _ argMorphs size.
	(argMorphs at: idx) delete.
	argMorphs at: idx put: nil.
	initialFrame remove: parameters last.
	parameters removeLast.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 00:53'!
removeVariable
	| ans |
	ans _ (SelectionMenu selections: variables asSortedCollection) startUp.
	ans ifNil: [^false].
	variables remove: ans.
	initialFrame remove: ans.
	variables isEmpty ifFalse: [
		self rightButtonMenu]
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 01:19'!
renameParm: old to: new

	(self allVarNames includes: new) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	initialFrame renameVar: old to: new.
	parameters at: (parameters indexOf: old) put: new.
	^true! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2011 00:31'!
rightButtonMenu

	| menu choice block vn atomic |

	"first create the widest label"

	atomic _ self checkBoxLabelled: 'atomic'
				marked: self isAtomic
				width: 0.

	menu _ CustomMenu new.
	menu add: 'help' action: #presentHelpScreen.
	menu addLine.
	menu add: 'duplicate' action: #duplicate.
	(self owner isKindOf: BlockMorph) ifFalse: [  "can't yet delete a blocks inside a script"
		menu add: 'delete' action: #delete].
	menu addLine.

	menu addIcon: atomic
			toolTip: 'execute as single block'
			action: #toggleAtomicity.


"
	menu add: (isAtomic ifTrue: ['atomic -> interleafed'] ifFalse: ['interleafed -> atomic']) action: #toggleAtomicity.
"

	"menu add: 'make a block variable' action: #addVariable.
	variables isEmpty ifFalse: [
		menu add: 'delete a bock variable' action: #removeVariable.
		menu addLine.
		variables asSortedCollection do: [:vName |
			menu addIcon: (self newVarBlock: vName) imageForm toolTip: nil action: {vName} ]].
	initialFrame varNamesMenu isEmpty ifFalse: [
		menu addLine.
		vn _ initialFrame varNamesMenu first.
		menu addIcon: (self newSetVarBlock: vn) imageForm toolTip: nil action: #setVar.
		menu addIcon: (self newChangeVarBlock: vn) imageForm toolTip: nil action: #changeVar ]."


	(choice _ menu localize; startUp "WithCaption: 'BYOB'") ifNil: [^ self].
	(choice isKindOf: Array) ifTrue: [
		block _ self newVarBlock: choice first.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	#setVar = choice ifTrue: [
		block _ self newSetVarBlock: vn.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	#changeVar = choice ifTrue: [
		block _ self newChangeVarBlock: vn.
		World activeHand attachMorph: block.
		block center: World activeHand position.
		^ self ].
	self perform: choice.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:05'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nestedBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].
	"(self isLambdaForm and: [ owner isKindOf: ScratchScriptsMorph]) ifTrue: [^nil]."

	^ super rootForGrabOf: aMorph
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/5/2010 02:29'!
sequence
	^self body blockSequence! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 22:13'!
showValue

	| tooltip w worldBounds |

	tooltip _ (ScratchReporterToolTipMorph string: self morphToShow imageForm for: self)
		left: self right;
		bottom: self top.
	ScratchTranslator isRTL ifTrue: [tooltip right: self left].

	w _ self world.
	w addMorphFront: tooltip.
	((worldBounds _ w bounds) containsRect: tooltip bounds) ifFalse:
		[tooltip bounds: (tooltip bounds translatedToBeWithin: worldBounds)].

	self setProperty: #toolTip toValue: tooltip.
	tooltip initialCursorPoint: Sensor cursorPoint.
	tooltip startStepping.
! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/7/2010 02:21'!
toggleAtomicity

	isAtomic _ isAtomic not! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:42'!
type
	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)

"

	^ type! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/9/2010 22:49'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #template	- a sunken variable blob that represents an externalized block variable
"

	type _ aSymbol! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
variables
	^ variables! !

!LambdaBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 05:19'!
variables: anOrderedCollection
	 variables _ anOrderedCollection! !


!LambdaBlockMorph methodsFor: 'private' stamp: 'jens 5/10/2010 00:17'!
updateReferencesUsing: aDictionary

	super updateReferencesUsing: aDictionary.
	parameters _ parameters collect:
		[:old | aDictionary at: old ifAbsent: [old]].
	variables _ variables collect:
		[:old | aDictionary at: old ifAbsent: [old]].
	declarations _ declarations collect:
		[:old | aDictionary at: old ifAbsent: [old]].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LambdaBlockMorph class
	instanceVariableNames: ''!


BooleanArgMorph subclass: #PredicateArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!PredicateArgMorph methodsFor: 'drawing' stamp: 'jens 7/21/2010 19:29'!
drawOn: aCanvas 

	| h s v darkerC lighterC right topY bottomY xInset c |
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	darkerC _ Color h: h s: (s - 0.3) v: (v - 0.3).
	lighterC _ Color h: h s: (s - 0.2) v: (v + 0.2).

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	[topY >= 0] whileTrue: [
		self drawHLineFrom: xInset to: (xInset + 2) y: topY color: darkerC on: aCanvas.
		c _ (topY <= 1) ifTrue: [darkerC] ifFalse: [color].
		self drawHLineFrom: xInset + 2 to: right - (xInset + 1) y: topY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 1)) to: (right - xInset) y: topY color: darkerC on: aCanvas.

		self drawHLineFrom: xInset to: (xInset + 1) y: bottomY color: lighterC on: aCanvas.
		c _ (bottomY >= (self height - 2)) ifTrue: [lighterC] ifFalse: [color].
		self drawHLineFrom: xInset + 1 to: right - (xInset + 1) y: bottomY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 2)) to: (right - xInset) y: bottomY color: lighterC on: aCanvas.

		xInset _ xInset + 1.	
		bottomY _ bottomY + 1.
		topY _ topY - 1].

! !


HatBlockMorph subclass: #ProcedureHatBlockMorph
	instanceVariableNames: 'argMorph lastState '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ProcedureHatBlockMorph methodsFor: 'initialization' stamp: 'jens 1/12/2010 09:06'!
initialize

	super initialize.
	argMorph _ ExpressionArgMorph new.

	self removeAllMorphs.
	self addMorphBack: argMorph.
! !


!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 6/22/2010 20:41'!
argMorph

	self nonControlFlowSubmorphs do: [:m |
		(m isKindOf: ArgMorph) ifTrue: [^ m].
		((m isKindOf: BlockMorph) and: [m isCustomBlock]) ifTrue: [^ m]].
	^ nil
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
argMorphToReplace: aMorph
	"Answer a new argument morph to be used to replace the given morph."

	aMorph ~= argMorph ifTrue: [^ nil].
	^ BooleanArgMorph new
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| argTuple |
	argTuple _ (argMorph isKindOf: ArgMorph)
		ifTrue: [argMorph evaluate]
		ifFalse: [argMorph asBlockTuple].

	^ Array with: #byob with: '' with: self class name with: argTuple
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
evaluateCondition
	"Answer true if my condition is true."

	| arg |
	arg _ submorphs detect: [:m | m isKindOf: ReporterBlockMorph] ifNone: [^ false].
	^ arg evaluate
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
fixBlockLayout
	"Update the positions of my submorphs."

	| x centerY nextB |
	argMorph ifNil: [^ self].  "happens during initialization"

	blockLayoutNeeded ifFalse: [^ self].
	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	((argMorph isKindOf: ArgMorph) and: [argMorph owner = self])
		ifTrue: [argMorph fixArgLayout].
	self height: 26 + argMorph height.

	x _ self left + 8.
	centerY _ bounds center y + 5.
	self nonControlFlowSubmorphs do: [:m |
		m position: x@(centerY - (m height // 2)).
		x _ x + m width + 5].

	self width: ((x + 4 - self left) max: self hatTopForm width).

	(nextB _ self nextBlock) ifNotNil: [
		nextB top: self bottom - 4.
		nextB fixBlockLayout].
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	^ 'whenHat'
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
nextBlock
	"Answer the block following myself in the block sequence or nil if I am the last block in the sequence. Each block is a submorph of the previous block."

	^ self submorphs
		detect: [:m | (m isKindOf: BlockMorph) and: [m ~= argMorph]]
		ifNone: [nil]
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
printHatNameOn: aStream
	"Append a human-readable string for this hat block's name to the given stream."

	aStream nextPutAll: 'when '.
	self printCodeSubmorph: argMorph on: aStream.
	aStream nextPutAll: ' becomes true'; cr.
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
replaceArgMorph: oldMorph by: newMorph
	"Replace oldMorph with newMorph. This is done when dropping a reporter block onto my argument."

	argMorph _ newMorph.
	self replaceSubmorph: oldMorph by: newMorph.
	self layoutChanged.
! !

!ProcedureHatBlockMorph methodsFor: 'other' stamp: 'jens 1/12/2010 09:04'!
triggered
	"Answer true if my condition has just become true."

	| condition |
	condition _ self evaluateCondition.
	condition & lastState not ifTrue: [lastState _ true. ^ true].  "trigger on false->true transition"
	lastState _ condition.
	^ false
! !


!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:54'!
handlesMouseOver: evt

	^ self argMorph isKindOf: BlockMorph
! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:54'!
handlesMouseOverDragging: evt

	^  self argMorph isKindOf: BlockMorph
! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 10:08'!
mouseDown: evt

	argMorph editSpec! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/15/2010 23:39'!
mouseEnter: evt

	self argMorph showEdgePlaceHolders! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:54'!
mouseEnterDragging: evt

	"self argMorph showArgumentPlaceHolders"! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:14'!
mouseLeave: evt

		self argMorph hideArgumentPlaceHolders! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2010 20:10'!
mouseLeaveDragging: evt

	self argMorph hideArgumentPlaceHolders! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 09:16'!
rootForGrabOf: aMorph

	(owner isKindOf: ScratchScriptsMorph) ifTrue: [^nil].

	^ super rootForGrabOf: aMorph! !

!ProcedureHatBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 09:11'!
template: aBlock
	self replaceArgMorph: self argMorph by: aBlock! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ProcedureHatBlockMorph class
	instanceVariableNames: ''!

!ProcedureHatBlockMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2010 09:11'!
on: aBlockMorph
	^self new template: aBlockMorph! !


CommandBlockMorph subclass: #ReporterBlockDropTargetMorph
	instanceVariableNames: 'isBoolean feedbackMorph lambdaMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 00:08'!
argument
	| am |
	am _ argMorphs first.
	(am isKindOf: ReporterBlockMorph) ifTrue: [ ^am ].
	(am isKindOf: BooleanArgMorph) ifTrue: [^nil ].
	^am labelMorph contents! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:46'!
argument: aMorphOrNumber
	(aMorphOrNumber isKindOf: ReporterBlockMorph)
		ifTrue: [^self replaceArgMorph: argMorphs first by: aMorphOrNumber ].
	argMorphs first stringExpression: aMorphOrNumber! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:23'!
drawOn: aCanvas

	aCanvas fillRectangle: self bounds color: color.
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 17:40'!
initialize
	super initialize.
	isBoolean _ false.
	self color: Color transparent! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/17/2008 10:29'!
isBoolean: aBoolean
	isBoolean _ aBoolean! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:43'!
label: aString
	|dropSpec|
	dropSpec _ ' %s'.
	isBoolean ifTrue: [dropSpec _ ' %b'].
	self commandSpec: aString, dropSpec! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:16'!
labelColor
	^Color gray: 0.3
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 03:12'!
layoutChanged
	| be |
	super layoutChanged.
	be _ self ownerThatIsA: BlockEditorFrameMorph.
	be ifNotNil: [ be adjustExtentToAnswerField ]
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/20/2009 22:42'!
replaceSubmorph: oldMorph by: newMorph
	| index itsPosition w |
	oldMorph stopStepping.
	itsPosition _ oldMorph referencePositionInWorld.
	index _ submorphs indexOf: oldMorph.
	(submorphs includes: newMorph) ifTrue: [ index _ index -1 ].
	oldMorph privateDelete.
	self privateAddMorph: newMorph atIndex: index.
	newMorph referencePositionInWorld: itsPosition.
	(w _ newMorph world) ifNotNil:
		[w startSteppingSubmorphsOf: newMorph].
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/11/2009 23:40'!
rightButtonMenu

! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/17/2008 13:04'!
rootForGrabOf: aMorph
	"prevent myself from being extracted."

	^nil! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/19/2010 20:29'!
step
	"Give feedback about possible drop targets."

	| feedbackColor h b targetArg targetAssoc targetP targetBlock |
	feedbackMorph
		ifNil: [feedbackMorph _ BorderedMorph new borderWidth: 3]  "create feedback morph if necessary"
		ifNotNil: [feedbackMorph delete].  "remove old feedback"
	feedbackColor _ Color white.
	feedbackMorph useSquareCorners.

	lambdaMorph
		ifNotNil: [lambdaMorph delete. lambdaMorph _ nil].  "remove old lambda feedback"

	h _ World activeHand.
	"h toolType = 'CutTool' ifTrue: [^ self showDeleteFeedback]."

	(self bounds containsPoint: h position) ifFalse: [ ^ self].
	h submorphCount = 1 ifFalse: [^ self].
	(self uncoveredAt: h cursorPoint) ifFalse: [^ self].

	b _ h firstSubmorph.
	(b isKindOf: BlockMorph) ifFalse: [ ^ self].
	(b isKindOf: HatBlockMorph) ifTrue: [ ^ self ].

	b isReporter ifTrue: [ "reporter block"

		targetArg _ (self allMorphs) detect: [:m | (m isKindOf: ArgMorph) and: [m bounds containsPoint: h position]] ifNone: [nil].
		targetArg ifNil: [

			(targetArg _ self topArgMorphAt: b bounds exclude: nil) ifNil: [^ self]].

		(targetArg acceptsTypeOf: b) ifFalse: [ ^ self].
		feedbackMorph
			bounds: (targetArg bounds expandBy: 5);
			color: (feedbackColor alpha: 0.4);
			borderColor: feedbackColor;
			useRoundedCorners.

		(targetArg isKindOf: OSlotMorph) ifTrue: [
			feedbackMorph
				bounds: (targetArg bounds expandBy: 8)].

		((targetArg isKindOf: SpecialArgMorph) 
		and: [(#(reporterslot booleanslot) includes: targetArg type)
		and: [(targetArg owner isKindOf: ReporterScriptBlockMorph) not]]) ifTrue: [
			feedbackMorph
				color: (feedbackColor);
				bounds: (targetArg bounds insetBy: 3).
			lambdaMorph _ ImageMorph new form: ((b imageForm outlineWidth: 3 color: Color gray depth: 8) 
														withOutlineColor: Color lightGray lighter width: 1)].
	
		lambdaMorph ifNotNil: [
			lambdaMorph position: b position - 4.
			h addMorphBack: lambdaMorph].

		h addMorph: feedbackMorph].




	"non-reporter (i.e. command block)"
	targetAssoc _ b closestAttachTargetIn: self.
	targetAssoc ifNil: [
		(b bottomBlock isKindOf: CBlockMorph) ifFalse: [
			targetAssoc _ b bottomBlock closestAttachTargetIn: self.
			targetAssoc ifNotNil:[
				(targetAssoc value owner isKindOf: BlockMorph) ifTrue:[
					targetAssoc _ nil]]]].
	targetAssoc ifNil: [^ self].

	targetP _ targetAssoc key.
	targetBlock _ targetAssoc value.
	feedbackMorph borderColor: feedbackColor; color: feedbackColor.

	"subtract the attachment point x from the width so that the feedback in CBlock won't stick out"
	ScratchTranslator isRTL
		ifTrue: [feedbackMorph extent: (targetP x - targetBlock left)@5.
			h addMorphFront: (feedbackMorph position: targetP - (feedbackMorph width@0))]
		ifFalse: [feedbackMorph extent: (targetBlock right - targetP x)@5.
			h addMorphFront: (feedbackMorph position: targetP)].! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 10:11'!
stepTime
	"Answer the desired time between steps in milliseconds. This default implementation requests that the 'step' method be called once every second."

	^0
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/15/2010 21:18'!
topArgMorphAt: aRectangle exclude: aMorph
	"Give feedback about possible drop targets."

	| stack argM area |
	"find the top block or stack under the given point, excluding the given morph"

	area _ [:morph |
			| space |
			space _ morph bounds.
			({CSlotMorph. OSlotMorph} includes: morph class)
				ifTrue: [space _ morph bounds expandBy: 5].
			((morph isKindOf: SpecialArgMorph) and: [
				#(reporterslot booleanslot) includes: morph type])
					ifTrue: [space _ morph bounds insetBy: 8].
			space].

	stack _ submorphs
		detect: [:m | (m ~~ aMorph) and: [(m isKindOf: BlockMorph) and: [m fullBounds intersects: aRectangle]]]
		ifNone: [ ^ self argumentAt: 1].

	stack allMorphsDo: [:b |
		((b isKindOf: CommandBlockMorph) and:
		 [(b isKindOf: HatBlockMorph) not]) ifTrue: [
			1 to: b argumentCount do: [:i |
				argM _ b argumentAt: i.

				(argM isKindOf: MultiArgMorph) ifTrue: [
					argM elements do: [:elmt |
						((area value: elmt) intersects: aRectangle) ifTrue: [
							^elmt]]].

				(((area value: argM) intersects: aRectangle) and:
				 [argM acceptsDroppedReporters])
					ifTrue: [^ argM]]]].

	(stack isKindOf: ReporterBlockMorph "ReporterScriptBlockMorph")
		ifTrue: [^ stack]
		ifFalse: [^ nil].
! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/15/2010 20:59'!
uncoveredAt: aPoint
	"Return true if the receiver is not covered by any submorphs at the given point."

	| w morphsAbove be  |
	(w _ self world) ifNil: [^ true].

	morphsAbove _ w morphsAt: aPoint.
	(morphsAbove size = 0) ifTrue: [^ true ].

	be _ self ownerThatIsA: DialogBoxMorph.

	morphsAbove do: [:m | ((m isKindOf: DialogBoxMorph) and: [m ~= be])
		ifTrue: [^ false ]].

	^ true! !

!ReporterBlockDropTargetMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 02:13'!
wantsDroppedMorph: aMorph event: evt
	| topArg |

	(aMorph isKindOf: CommandBlockMorph) ifFalse: [^false ].
	topArg _ self topArgMorphAt: aMorph bounds exclude: nil.
	topArg ifNil: [^ false].
	^ topArg acceptsTypeOf: aMorph 
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ReporterBlockDropTargetMorph class
	instanceVariableNames: ''!

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/12/2009 00:31'!
booleanLabelled: aString argument: aMorphOrNumber
	 | m |
	m _ self new isBoolean: true; label: aString; color: Color  lightGray twiceLighter twiceLighter.
	(aMorphOrNumber isKindOf: ReporterBlockMorph) ifTrue: [m argument: aMorphOrNumber ].
	^m! !

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:37'!
labelled: aString
	^self new label: aString! !

!ReporterBlockDropTargetMorph class methodsFor: 'as yet unclassified' stamp: 'jens 10/13/2008 13:49'!
labelled: aString argument: aMorphOrNumber
	^self new label: aString; argument: aMorphOrNumber! !


LambdaBlockMorph subclass: #ReporterScriptBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ReporterScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/25/2010 15:09'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawSlotBorderOn: aCanvas! !

!ReporterScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/25/2010 15:13'!
drawSlotBorderOn: aCanvas

	(argMorphs first isKindOf: SpecialArgMorph)
		ifFalse: [^ self].

	aCanvas paintImage: (argMorphs first imageForm outlineEmbeddedAdjustedColor: color)
				at: argMorphs first position - 1


! !


!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:43'!
addItem
	| varBlock pos pname |
	super addItem.
	pos _ (argMorphs reject: [:m | m == self nextBlock]) size.
	(self isKindOf: CommandScriptBlockMorph)
		ifFalse: [pos _ pos - 1 ].
	pname _ ('#', pos printString) asUTF8.
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #getVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: pname.
	(self isKindOf: CommandScriptBlockMorph)
		ifTrue: [ self replaceArgMorph: (self argumentAt: pos) by: varBlock ]
		ifFalse: [ self replaceArgMorph: (self argumentAt: pos + 1) by: varBlock].
	parameters add: pname.
	initialFrame add: pname
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:42'!
addRemove
	| varBlock pos |
	super removeItem.

	pos _ (argMorphs reject: [:m | m == self nextBlock]) size.
	(self isKindOf: CommandScriptBlockMorph)
		ifFalse: [pos _ pos - 1 ].
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		receiver: nil;	
		selector: #getBlockVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: '#', pos printString.
	(self isKindOf: CommandScriptBlockMorph)
		ifTrue: [ self replaceArgMorph: (self argumentAt: pos) by: varBlock ]
		ifFalse: [ self replaceArgMorph: (self argumentAt: pos + 1) by: varBlock]! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:40'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(function functionWithArgs) includes: selector) ifFalse: [^ self ].

	argMorphs size > 1 
		ifTrue: [
			sdict _ Dictionary new
				at: #function put: #functionWithArgs;
				yourself]
		ifFalse: [
			sdict _ Dictionary new
				at: #functionWithArgs put: #function;
				yourself].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.

	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.

	self commandSpec: newSpec.
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/4/2009 21:54'!
args
	^argMorphs! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:22'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg argList |
	blockTuple _ Array new: argMorphs size + 9.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: parameters asArray;
		at: 5 put: variables asArray;
		at: 6 put: type;
		at: 7 put: declarations;
		at: 8 put: isAtomic.

	argList _ argMorphs.
	argList _ self organizeArgs: argList.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph)
			ifTrue: [blockTuple at: i + 8 put: arg evaluate]
			ifFalse: [blockTuple at: i + 8 put: arg asBlockTuple]].

	^ blockTuple
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/1/2011 15:47'!
body
	(argMorphs first isKindOf: BlockMorph)
		ifTrue: [^ argMorphs first fullCopy].
	^ nil! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:20'!
deleteVariableTemplate: aVarBlockMorph

	aVarBlockMorph delete.
	argMorphs remove: aVarBlockMorph.
	self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3)! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:10'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	^'reporterLambda'! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 21:09'!
initialize

	super initialize.
	type _ #any
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 23:10'!
isBooleanFunction
	^ isBoolean! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:18'!
isFunction
	^ true! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 02:36'!
nestedBlock
	^self args first! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/1/2010 20:33'!
optimized
	| newBlock reportBlock sel body a rcv |

	rcv _ self receiver.
	rcv ifNil: [rcv _ ScriptableScratchMorph new].
	(#(function #autoBlock) includes: selector)
		ifTrue: [sel _ #procedure]
		ifFalse: [sel _ #procedureWithArgs].
	newBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: sel) 
							color: (ScriptableScratchMorph blockColorFor: 'operators').

	newBlock isAtomic: (isAtomic or: [self isKindOf: OSlotMorph]).

	reportBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #doAnswer) 
							color: (ScriptableScratchMorph blockColorFor: 'control').

	body _ self body.
	body ifNotNil:[
		reportBlock replaceArgMorph: (reportBlock argMorphs first) by: body].

	2 to: argMorphs size - 1 do: [:i |
		newBlock addItem ].

	2 to: argMorphs size do: [:i |
		a _ (argMorphs at: i) fullCopy.
		newBlock replaceArgMorph: (newBlock argMorphs at: i - 1) by: a ].

	newBlock attachBlock: reportBlock.
	newBlock parameters: parameters.
	newBlock variables: variables.
	newBlock fixInitialFrame.
	^newBlock! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:32'!
privateBody
	"no copy"
	(argMorphs first isKindOf: BlockMorph)
		ifTrue: [^ argMorphs first].
	^ nil! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 03:03'!
removeItem
	argMorphs size > self minArgs ifTrue: [
		self removeLastArg.
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !


ReporterScriptBlockMorph subclass: #CommandScriptBlockMorph
	instanceVariableNames: 'nestedBlock topBarBottom blockBottom stretchHeight '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/30/2009 01:40'!
canBecomeWatcher
	^false
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:31'!
drawBottomBarOn: aCanvas 

	| left barTop barBottom |

	barBottom _ self bottom - 3.
	self drawSmoothBottomEdgeOn: aCanvas.

	barTop _ barBottom - (CBlockBracketThickness - 3).
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
		color: shadowColor.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 22:58'!
drawInnerTopY: y on: aCanvas

	| left right gapStart gapEnd |
	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: (right - 1) y: y color: color on: aCanvas.
	self drawHLineFrom: left to: (right - 2) y: y + 1 color: color on: aCanvas.

	"fill in upper-left inside corner"
	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 2 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (right - 1)@y color: shadowColor on: aCanvas.
	self drawPoint: (right - 2)@(y + 1) color: shadowColor on: aCanvas.

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/16/2010 22:37'!
drawOn: aCanvas 

	| c |

	topBarBottom _ self top + self topBarHeight.
	self isForever
		ifTrue: [blockBottom _ self bottom - 3]
		ifFalse: [blockBottom _ self bottom - 7].
	self contrastColor.

	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.
	self drawTopEdgeOn: c.
	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:18'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |


	aCanvas
		fillRectangle: (self left@(self top + 5) corner: (self right - 1)@topBarBottom)
		color: color.
	aCanvas
		fillRectangle: ((self right - 1)@(self top + 3) corner: self right @topBarBottom)
		color: shadowColor.

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: (right - 1) y: y color: color on: aCanvas.
	self drawHLineFrom: left to: (right - 2) y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 2 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (right - 1)@y color: shadowColor on: aCanvas.
	self drawPoint: (right - 2)@(y + 1) color: shadowColor on: aCanvas.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 23:18'!
drawTopEdgeOn: aCanvas

	| right |

	right _ self width - 1.
	self drawHLineFrom: 2 to: right-2 y: 0 color: highlightColor1 on: aCanvas.
	self drawHLineFrom: 1 to: right-1 y: 1 color: highlightColor2 on: aCanvas.
	self drawHLineFrom: 0 to: right y: 2 color: color on: aCanvas.
	self drawHLineFrom: 0 to: right y: 3 color: color on: aCanvas.
	self drawHLineFrom: 0 to: right y: 4 color: color on: aCanvas.

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 10/29/2009 22:59'!
drawVerticalBarOn: aCanvas 

	| left top barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.
	top _ self top.
	
	aCanvas
		fillRectangle: (left@(top + 5) corner: barRight@blockBottom)
		color: color.
	aCanvas
		fillRectangle: (left@(top + 2) corner: (left + 2)@blockBottom)
		color: highlightColor2.

	aCanvas
		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.
! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 5/11/2010 13:11'!
fixBlockLayout
	"Update the positions of my submorphs."

	self fixBlockLayoutNoWrap! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 5/11/2010 13:13'!
fixBlockLayoutNoWrap
	"Update the positions of my submorphs."

	| oldExtent newW newH |
	blockLayoutNeeded ifFalse: [^ self].
	super fixBlockLayoutNoWrap.

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	"color = owner color ifFalse: [self color: owner color]."

	oldExtent _ self extent.
	newW _ oldExtent x max: 60.
	"newW _ newW max: self blockWidth."

	newH _ self topBarHeight + CBlockBracketThickness.
	"self isForever ifFalse: [newH _ newH + 4]."

	nestedBlock
		ifNil: [newH _ newH + 14]
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ newH + nestedBlock fullBounds height - 1.
			ScratchTranslator isRTL
				ifTrue: [nestedBlock position: self topRight - ((CBlockBracketThickness + nestedBlock width)@0)
					+ (0@(self topBarHeight + 3))]
				ifFalse: [nestedBlock position: self position + (CBlockBracketThickness@(self topBarHeight + 3))].
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].
	self extent: newW@newH + (0@stretchHeight).
	ScratchTranslator isRTL ifTrue: [
		self left: self left + (oldExtent x - newW)].

! !

!CommandScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 12/17/2009 02:33'!
nestedBlock
	^nestedBlock! !


!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/14/2009 04:25'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	((aBlockMorph isKindOf: CommandBlockMorph) and: [
		(aBlockMorph isKindOf: HatBlockMorph) not ])
			ifTrue: [^true].
	^super acceptsTypeOf: aBlockMorph! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 01:09'!
addItem
	| quoted |
	quoted _ nestedBlock.
	super addItem.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:39'!
adjustInternals
	"private"

	| newSelector sdict quoted newSpec |
	(#(procedure procedureWithArgs) includes: selector) ifFalse: [^ self ].

	argMorphs size > 0 
		ifTrue: [
			sdict _ Dictionary new
				at: #procedure put: #procedureWithArgs;
				yourself]
		ifFalse: [
			sdict _ Dictionary new
				at: #procedureWithArgs put: #procedure;
				yourself].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.

	quoted _ nestedBlock.
	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.

	self commandSpec: newSpec.

	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/30/2010 19:49'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg argList val eval |
	blockTuple _ Array new: argMorphs size + 9.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: parameters asArray;
		at: 5 put: variables asArray;
		at: 6 put: type;
		at: 7 put: declarations;
		at: 8 put: isAtomic.


	argList _ argMorphs.
	argList _ self organizeArgs: argList.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph)
			ifTrue: [(arg isKindOf: ExpressionArgMorph)
				ifTrue: [
					val _ arg getExpression.
					arg isNumberExpression
						ifTrue: [val = ' ' asUTF8
							ifTrue: [eval _ val]
							ifFalse: [eval _ val asNumberNoError]]
						ifFalse: [eval _ arg evaluate]]
				ifFalse: [eval _ arg evaluate].
				blockTuple at: i + 8 put: eval]
			ifFalse: [blockTuple at: i + 8 put: arg asBlockTuple]].

	nestedBlock
		ifNil: [blockTuple at: blockTuple size put: nil]
		ifNotNil: [blockTuple at: blockTuple size put: nestedBlock tupleSequence]. 
	^ blockTuple

! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 00:46'!
attachBlock: aBlockMorph
	"Attach the given block to me. Assume the block has been positioned correctly."

	self addMorph: aBlockMorph.
	nestedBlock _ aBlockMorph.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 00:49'!
attachBlockNested: aBlockMorph
	"Attach the given block to me. Assume the block has been positioned correctly."

	(stretchHeight = 0)
			ifTrue: [self position: (aBlockMorph left)@(aBlockMorph top - self height + 4)].
	self addMorph: aBlockMorph.
	nestedBlock _ aBlockMorph.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:48'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ScratchTranslator isRTL
			ifTrue: [result _ result copyWith: ((self topRight + (-12@(self topBarHeight + 7))) -> self)]
			ifFalse: [result _ result copyWith: ((self topLeft + (12@(self topBarHeight + 7))) -> self)]]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 11:47'!
blockWidth
	| maxWidth |
	maxWidth _ 0.
	self firstBlockList do: [:b |
		maxWidth _ maxWidth max: b blockWidth ].
	^self width max: self bracketThickness + maxWidth! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/1/2010 20:35'!
body
	nestedBlock ifNil: [^nil].
	^nestedBlock fullCopy! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/17/2010 00:29'!
bodyLeft
	^self left! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/17/2010 00:29'!
bodyRight
	^self fullBounds right! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 22:50'!
bracketThickness

	^ CBlockBracketThickness
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/18/2010 02:15'!
containsPoint: aPoint

	cachedForm ifNil: [self updateCachedForm].
	^ (cachedForm isTransparentAt: aPoint - self fullBounds origin) not 
		and: [self fullBounds containsPoint: aPoint]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:22'!
deleteVariableTemplate: aVarBlockMorph

	| quoted |
	quoted _ nestedBlock.
	super deleteVariableTemplate: aVarBlockMorph.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/30/2009 10:51'!
firstBlockList
	"Answer an array containing the block sequence for my first (and only) nested block. (An if-then-else block would have a second block list.)"

	nestedBlock
		ifNil: [^ #()]
		ifNotNil: [^ nestedBlock blockSequence].


! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/19/2009 23:17'!
firstBlockList: aBlockMorph
	"Add the given block as my first nested block sequence. Delete the old nested blocks, if any."

	nestedBlock ifNotNil: [nestedBlock delete].
	nestedBlock _ aBlockMorph.
	aBlockMorph ifNotNil: [self addMorph: aBlockMorph].

! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:10'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	^'commandLambda'! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 22:43'!
initialize

	super initialize.
	type _ #none.
	stretchHeight _ 0.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/4/2010 00:22'!
isBooleanFunction

	| reporter |
	reporter _ self allMorphs detect: [:m|
		(m isKindOf: CommandBlockMorph) and: [
			m selector = #doAnswer ]] ifNone: [^false].
	^ (reporter argMorphs first isKindOf: ReporterBlockMorph) and: [
			reporter argMorphs first isBooleanReporter]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/4/2010 00:18'!
isFunction
	self allMorphsDo: [:m|
		((m isKindOf: CommandBlockMorph) and: [
			m selector = #doAnswer ]) ifTrue: [^ true]].
	^ false! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:54'!
isKindOf: aClass
	aClass = CBlockMorph
		ifTrue: [^true ].
	^super isKindOf: aClass! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 22:50'!
nestedBlockAt: aPoint

	^ nestedBlock
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/20/2009 00:22'!
nextBlock

	^nil! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:49'!
nonControlFlowSubmorphs
	"Answer a collection of submorphs minus any blocks that are part of the control flow. For example, command blocks omit their submorph that is the next block in the block sequence, C-blocks omit both their next block and the first block of their nested block list, etc."

	^ submorphs select: [:m | m ~~ nestedBlock ]
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 11:15'!
optimized
	^self fullCopy! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:33'!
privateBody
	"no copy"
	nestedBlock ifNil: [^nil].
	^nestedBlock! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/3/2009 01:10'!
removeItem
	| quoted |
	quoted _ nestedBlock.
	super removeItem.
	quoted ifNotNil: [
		self attachBlock: quoted ]! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 10/29/2009 23:52'!
stretchHeight: aNumber

	(stretchHeight = aNumber) ifTrue: [^ self].
	stretchHeight _ aNumber.
	blockLayoutNeeded _ true.
	self fixBlockLayout.
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/28/2010 20:25'!
tabFields

	| nst |

	nst _ self nestedBlock.
	nst ifNotNil: [
		^ nst tabFields ].

	^ OrderedCollection new
! !

!CommandScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/8/2010 04:23'!
topBarHeight
	"Answer the height of the top bar."

	| nonBlockSubmorphs |
	nonBlockSubmorphs _ self submorphs select: [:m |
		(m isKindOf: BlockMorph) not or: [argMorphs includes: m]].
	^ nonBlockSubmorphs inject: CBlockBracketThickness into: [:h :m | h max: (m height + 4)].

! !


CommandScriptBlockMorph subclass: #CSlotMorph
	instanceVariableNames: 'implicitValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 20:02'!
blockWidth
	| maxWidth |
	maxWidth _ 0.
	self firstBlockList do: [:b |
		maxWidth _ maxWidth max: b blockWidth ].
	^ 10 "2" + maxWidth! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/20/2010 22:57'!
computeHighlightColors

	| h s v |
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	highlightColor1 _ Color h: h s: (s - 0.13) v: (v + 0.1).
	highlightColor2 _ Color h: h s: s v: (v + 0.07).
	shadowColor _ color mixed: 0.55 with: Color black.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 3/17/2010 12:40'!
drawBottomBarOn: aCanvas 

	| left barTop barBottom |

	barBottom _ self bottom.

	barTop _ barBottom - 3.
	left _ self left.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 1)@(barTop + 1))
		color: highlightColor1.

	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 7/22/2010 22:29'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	c
		fillRectangle: self bounds
		color: Color lightGray "(color mixed: 0.6 with: Color darkGray)".

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self nestedBlock ifNotNil: [ c paintImage: (nestedBlock imageForm withOutlineColor: Color gray width: 4) 
					at: self position + (1@3) ].

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas.

! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 20:11'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |

	left _ 0.
	right _ self width - 1.
	y _ topBarBottom - self top.

" ---- original: ---------
	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.
"
	gapStart _ left + PuzzleInset + 9.
	gapEnd _ gapStart + PuzzleWidth - 8.

	nestedBlock ifNil: [
		gapStart _ left + PuzzleInset - 4.
		gapEnd _ gapStart + PuzzleWidth - 5 ].


	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 1 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.


! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 3/17/2010 12:42'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ left.

	aCanvas
		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.

	aCanvas
		fillRectangle: ((self bounds topRight + (-1@0)) corner: (self bounds corner ))
		color: color.

	aCanvas
		fillRectangle: ((self bounds topRight + (-1@2)) corner: (self bounds corner - (0@3)))
		color: highlightColor2.
! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/20/2010 22:57'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newW newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	newW _ 28 max: self blockWidth.

	newH _ self topBarHeight + 12 "+ self bracketThickness!!".

	nestedBlock
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ "newH +" nestedBlock fullBounds height + 10.
			nestedBlock position: self position + (5 "1"@(self topBarHeight + 4)).
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].
	self extent: newW@newH

! !

!CSlotMorph methodsFor: 'drawing' stamp: 'jens 4/6/2010 22:12'!
topBarHeight
	"Answer the height of the top bar."

	| nonBlockSubmorphs |
	nonBlockSubmorphs _ self submorphs select: [:m |
		(m isKindOf: BlockMorph) not or: [argMorphs includes: m]].
	^ nonBlockSubmorphs inject: 3 into: [:h :m | h max: (m height + 3)].

! !


!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 01:01'!
acceptsDroppedReporters

	^ true
! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/25/2011 00:17'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	aBlockMorph isReporter ifFalse: [^ false].
	^ (aBlockMorph isKindOf: VariableBlockMorph) or: [

		^ #(
			autoLambda
			loopLambda
			getLine:ofList:
			getVar:
			procedure
			procedureWithArgs
			doReport
			doCallBlockWithArgs
			doCallBlockWithArgList
			doCustomBlock
			getAttribute:of:
			attribute:of:
		) includes: aBlockMorph selector]! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 17:28'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ result _ result copyWith: ((self topLeft + (1@(self topBarHeight + 3))) -> self)]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.

! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/16/2010 21:41'!
handlesMouseDown: evt

	^false! !

!CSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/17/2010 02:20'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #autoLambda! !


!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:19'!
defaultValue: default
	"do nothing"! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:13'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^ super evaluate! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:15'!
evaluateWithArgs: rawArgs

	implicitValue notNil
		ifTrue: [^implicitValue].
	^super evaluateWithArgs: rawArgs! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:20'!
fixArgLayout
	"Fix my layout. This default implementation does nothing."! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:11'!
implicitValue
	^ implicitValue! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:11'!
implicitValue: anObject
	implicitValue _ anObject! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:09'!
isEmptySlot
	^ nestedBlock isNil! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/17/2010 20:08'!
isKindOf: aClass
	aClass = ArgMorph 
		ifTrue: [^ true].
	^ super isKindOf: aClass
! !

!CSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 6/22/2010 20:29'!
isLambdaForm
	^ false! !


CSlotMorph subclass: #CArgSlotMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/8/2010 23:07'!
blockWidth

	| bw |
	bw _ 0.
	(owner isKindOf: BlockMorph) ifTrue: [
		bw _ owner width].
	^ 50 max: bw! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 23:52'!
drawBottomBarOn: aCanvas 


	| left barTop barBottom |

	barBottom _ self bottom.


	barTop _ barBottom - 3.
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		aCanvas
			fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
			color: shadowColor]

! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/8/2010 22:50'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas


! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/13/2010 23:52'!
drawTopBarOn: aCanvas 

	| left right y gapStart gapEnd |

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.

	gapStart _ left + PuzzleInset + 1.
	gapEnd _ gapStart + PuzzleWidth.

	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: gapStart to: gapEnd y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 3 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 1 to: gapEnd - 1 y: y + 4 color: color on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 5 color: color on: aCanvas.

	self drawHLineFrom: (left + 2) to: gapStart y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapEnd to: right - 1 y: y + 2 color: shadowColor on: aCanvas.
	self drawHLineFrom: gapStart + 2 to: gapEnd - 2 y: y + 6 color: shadowColor on: aCanvas.

	self drawPoint: gapStart@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: gapStart@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapStart + 1)@(y + 5) color: shadowColor on: aCanvas.

	self drawPoint: (gapEnd - 1)@(y + 3) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 1)@(y + 4) color: shadowColor on: aCanvas.
	self drawPoint: (gapEnd - 2)@(y + 5) color: shadowColor on: aCanvas.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		self drawPoint: (right "- 1")@y color: shadowColor on: aCanvas.
		self drawPoint: (right - 1 "2")@(y + 1) color: shadowColor on: aCanvas]
! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:45'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.

	aCanvas

		fillRectangle: (self topLeft corner: (barRight @ self bottom))
		color: color;

		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.
! !

!CArgSlotMorph methodsFor: 'drawing' stamp: 'jens 7/6/2010 21:37'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [self color: owner color]].

	"fix nestedBlock and nextBlock in case they've been removed from me"
	(nestedBlock notNil and: [nestedBlock owner ~~ self]) ifTrue: [nestedBlock _ nil].

	newH _ self topBarHeight + 14.

	nestedBlock
		ifNotNil: [
			stretchHeight _ 0.
			nestedBlock fixBlockLayout.
			newH _ nestedBlock fullBounds height + 2.
			nestedBlock position: self position + (CBlockBracketThickness @ (self topBarHeight)).
			nestedBlock blockSequence last isStopOrForever ifTrue: [newH _ newH + 4]].

	self height: newH.


	(owner isKindOf: ReporterBlockMorph) 
		ifTrue: [nestedBlock ifNotNil: [
			self width: nestedBlock fullBounds width + CBlockBracketThickness]]

! !


!CArgSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/9/2010 02:19'!
blockAttachPoints: aSet
	"Answer a collection of possible attachment points for me. Each entry is an Association mapping a point to the morph to which a dropping command block could be attached."

	| result |

	result _ #().

	nestedBlock
		ifNil: [ result _ result copyWith: ((self topLeft + (CBlockBracketThickness@(self topBarHeight + 3))) -> self)]
		ifNotNil: [nestedBlock blockAttachPoints: aSet].

	aSet addAll: result.

! !

!CArgSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/9/2010 02:20'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #loopLambda! !


ReporterScriptBlockMorph subclass: #OSlotMorph
	instanceVariableNames: 'implicitValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 23:28'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	^ aBlockMorph isReporter! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
defaultValue: default
	"do nothing"! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^ super evaluate! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
evaluateWithArgs: rawArgs

	implicitValue notNil
		ifTrue: [^implicitValue].
	^super evaluateWithArgs: rawArgs! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
fixArgLayout
	"Fix my layout. This default implementation does nothing."! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
implicitValue
	^ implicitValue! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:57'!
implicitValue: anObject
	implicitValue _ anObject! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:58'!
isEmptySlot
	^ self body isNil! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:55'!
isKindOf: aClass
	aClass = ArgMorph 
		ifTrue: [^ true].
	^ super isKindOf: aClass
! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 6/22/2010 20:29'!
isLambdaForm
	^ false! !


!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/23/2010 21:54'!
handlesMouseDown: evt

	^false! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 16:13'!
initialize
	super initialize.
	isSpecialForm _ true.
	minArgs _ 0.
	maxArgs _ 0.
"	self type: #reporterslot."
	removeElementMorph ifNotNil: [
		removeElementMorph delete]! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/7/2010 00:07'!
receiver

	^receiver ifNil: [
		(owner respondsTo: #receiver)
			ifTrue: [^receiver _ owner receiver]
			ifFalse: [^nil]]	! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 16:06'!
type: aSymbol

	type _ aSymbol.

	#reporterslot = type ifTrue: [
		selector _ #autoBlock.
		self commandSpec: '%Z'].

	#booleanslot = type ifTrue: [
		selector _ #autoPredicate.
		self commandSpec: '%Y'].

	self addLabel.

	removeElementMorph ifNotNil: [
		removeElementMorph delete]
! !


!OSlotMorph methodsFor: 'drawing' stamp: 'jens 5/19/2010 04:08'!
drawOn: aCanvas 

	(owner respondsTo: #color) ifTrue: [
		color = owner color ifFalse: [
			color _ owner color]].

	self nestedBlock ifNil: [
		aCanvas
			fillRectangle: self bounds color: color].

	self drawSlotOn: aCanvas! !

!OSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:33'!
drawSlotOn: aCanvas

	| dark |

	(type = #booleanslot and: [argMorphs first isKindOf: SpecialArgMorph])
		ifTrue: [^ self].

	dark _ Color gray " (color mixed: 0.45 with: Color darkGray)". 

	(argMorphs first isKindOf: ReporterBlockMorph) ifTrue: [
		argMorphs first isBooleanReporter
			ifTrue: [
				aCanvas paintImage: ((argMorphs first imageForm withOutlineColor: dark width: 4) 
					withHalfEmbeddedOutlineColor: dark)
					at: (argMorphs first position - 5).
				^self ]
			ifFalse: [
				aCanvas paintImage: ((argMorphs first imageForm withOutlineColor: dark width: 4) 
					"withHalfEmbeddedOutlineColor: dark)"
					withEmbeddedOutlineColor: dark width: 1)
					at: (argMorphs first position - 5).
				^self ]].

	aCanvas paintImage: (argMorphs first imageForm outlineEmbeddedAdjustedColor: dark) 
		at: (argMorphs first position - 1)

! !


!OSlotMorph methodsFor: 'stack/tuple conversion' stamp: 'jens 7/7/2010 01:07'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg |
	
	blockTuple _ Array new: 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	arg _ self nestedBlock.
	(arg isKindOf: ReporterBlockMorph)
		ifTrue: [blockTuple at: 4 put: (Array with: argMorphs first asBlockTuple)]
		ifFalse: [blockTuple at: 4 put: nil]. 
	^ blockTuple! !


OSlotMorph subclass: #CReporterSlotMorph
	instanceVariableNames: 'topBarBottom blockBottom '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 7/7/2010 01:44'!
computeHighlightColors

	| h s v |
	owner ifNotNil: [
		color = owner color ifFalse: [
			self color: owner color]].
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	highlightColor1 _ Color h: h s: (s - 0.13) v: (v + 0.1).
	highlightColor2 _ Color h: h s: s v: (v + 0.07).
	shadowColor _ color mixed: 0.55 with: Color black.
! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:43'!
drawBottomBarOn: aCanvas 


	| left barTop barBottom |

	barBottom _ self bottom.


	barTop _ barBottom - 3.
	left _ self left + CBlockBracketThickness - 1.

	aCanvas fillRectangle: (left@(barTop - 2) extent: 1@1) color: color.
	aCanvas fillRectangle: (left@(barTop - 1) extent: 2@1) color: color.
	aCanvas fillRectangle: (left@barTop extent: 3@1) color: color.

	aCanvas
		fillRectangle: ((left + 3)@barTop corner: (self right - 2)@(barTop + 1))
		color: highlightColor1.
	aCanvas
		fillRectangle: (self left@(barTop + 1) corner: (self right - 1)@barBottom)
		color: color.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		aCanvas
			fillRectangle: ((self right - 1)@(barTop + 2) corner: self right@barBottom)
			color: shadowColor]

! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:44'!
drawOn: aCanvas 

	| c |
	topBarBottom _ self top.
	blockBottom _ self bottom.
	self computeHighlightColors.
	c _ FormCanvas extent: self extent depth: 32.
	c _ c copyOffset: self topLeft negated.

	self drawTopBarOn: c.
	self drawVerticalBarOn: c.
	self drawBottomBarOn: c.

	self drawFinalOn: aCanvas fromCanvas: c.

	self drawInlinePaletteOn: aCanvas


! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:57'!
drawTopBarOn: aCanvas 

	| left right y |

	left _ CBlockBracketThickness - 1.
	right _ self width - 1.
	y _ topBarBottom - self top.

	self drawHLineFrom: left to: right y: y color: color on: aCanvas.
	self drawHLineFrom: left to: right y: y + 1 color: color on: aCanvas.

	self drawHLineFrom: left to: (left + 2) y: y + 2 color: color on: aCanvas.
	self drawHLineFrom: left to: (left + 1) y: y + 3 color: color on: aCanvas.
	self drawPoint: (left + 1)@(y + 3) color: shadowColor on: aCanvas.

	self drawHLineFrom: (left + 2) to: right - 1 "gapStart" y: y + 2 color: shadowColor on: aCanvas.

	(owner isKindOf: CustomReporterBlockMorph) ifFalse: [
		self drawPoint: (right "- 1")@y color: shadowColor on: aCanvas.
		self drawPoint: (right - 1 "2")@(y + 1) color: shadowColor on: aCanvas]
! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:45'!
drawVerticalBarOn: aCanvas 

	| left barRight |
	left _ self left.
	barRight _ (left + CBlockBracketThickness) - 1.

	aCanvas

		fillRectangle: (self topLeft corner: (barRight @ self bottom))
		color: color;

		fillRectangle: (barRight@(topBarBottom + 4) corner: (barRight + 1)@blockBottom)
		color: shadowColor.! !

!CReporterSlotMorph methodsFor: 'drawing' stamp: 'jens 7/6/2010 22:24'!
fixBlockLayout
	"Update the positions of my submorphs."

	| newH |
	blockLayoutNeeded ifFalse: [^ self].
	owner ifNotNil: [
		color = owner color ifFalse: [self color: owner color]].

	newH _ 14.

	self nestedBlock
		ifNotNil: [ (self nestedBlock respondsTo: #fixBlockLayout)
			ifTrue: [ self nestedBlock fixBlockLayout].
			self nestedBlock position: self position + (12@3).
			(self nestedBlock isKindOf: SpecialArgMorph) ifFalse: [
				newH _ self nestedBlock fullBounds height + 6]].

	self height: newH.


	(owner isKindOf: ReporterBlockMorph) 
		ifTrue: [self nestedBlock ifNotNil: [
			self width: self nestedBlock fullBounds width + CBlockBracketThickness]]

! !


!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:01'!
displayForm
	^Form dotOfSize: 1! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:15'!
initialize
	super initialize.
	isSpecialForm _ true.
	selector _ #cLambda.
	self commandSpec: '%Z'.
	self addLabel.

	removeElementMorph ifNotNil: [
		removeElementMorph delete]
! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 01:02'!
isEmptySlot
	^ self nestedBlock isNil! !

!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/7/2010 00:55'!
nestedBlock
	self args ifNil: [^ nil].
	self args size < 1 ifTrue: [^ nil].
	^ super nestedBlock! !


ArgMorph subclass: #SpecialArgMorph
	instanceVariableNames: 'type skin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 23:25'!
acceptsDroppedReporters

	^ true
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 23:25'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	^ true
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/22/2010 22:23'!
drawOn: aCanvas

	(owner isKindOf: CReporterSlotMorph)
		ifTrue: [^ self].

	skin ifNil: [
		(owner isKindOf: BlockMorph) ifTrue: [
			#reporterslot = type
				ifTrue: [^ aCanvas fillOval: self bounds color: Color lightGray " (owner color mixed: 0.6 with: Color darkGray)" ]
				ifFalse: [

	| h s v darkerC lighterC right topY bottomY xInset c |

	color _ (owner color mixed: 0.6 with: Color darkGray).
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	darkerC _ Color h: h s: (s - 0.3) v: (v - 0.3).
	lighterC _ Color h: h s: (s - 0.2) v: (v + 0.2).

	color _ Color lightGray.

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	[topY >= 0] whileTrue: [
		self drawHLineFrom: xInset to: (xInset + 2) y: topY color: darkerC on: aCanvas.
		c _ (topY <= 1) ifTrue: [darkerC] ifFalse: [color].
		self drawHLineFrom: xInset + 2 to: right - (xInset + 1) y: topY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 1)) to: (right - xInset) y: topY color: darkerC on: aCanvas.

		self drawHLineFrom: xInset to: (xInset + 1) y: bottomY color: lighterC on: aCanvas.
		c _ (bottomY >= (self height - 2)) ifTrue: [lighterC] ifFalse: [color].
		self drawHLineFrom: xInset + 1 to: right - (xInset + 1) y: bottomY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 2)) to: (right - xInset) y: bottomY color: lighterC on: aCanvas.

		xInset _ xInset + 1.	
		bottomY _ bottomY + 1.
		topY _ topY - 1].
^self

]
		]].

	aCanvas paintImage: skin at: self position! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2010 00:22'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^nil
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 15:20'!
stringExpression: obj

	"default is not to do anything"! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 22:14'!
type
	^type! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:40'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
*    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
*    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
*    #command	- a round reporter block that answers a procedure (a command block)
*    #reporter	- a round reporter block that answers a function (a reporter block)
*    #predicate	- a hexagonal reporter block that answers a reporter of a boolean 
    #template	- a sunken variable blob that represents an externalized block variable
*   #reporterslot
*	#booleanslot
*	*objSlot

the ones marked by asterix (*) are represented by this class
"
	type _ aSymbol.
	#objSlot = type ifTrue: [
		skin _ ScratchFrameMorph skinAt: #objSlot].
	(#(reporterslot booleanslot objSlot) includes: type) ifFalse: [
		skin _ ScratchFrameMorph skinAt: ('type', type asString capitalized) asSymbol].
	self 
		borderWidth: 0;
		cornerStyle: #square;
		extent: (skin ifNil: [type = #reporterslot ifTrue: [18@12] ifFalse: [23@14]] ifNotNil: [skin extent]).! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpecialArgMorph class
	instanceVariableNames: ''!

!SpecialArgMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2010 02:40'!
example
	| script dict block |
	"self example"

	script _ nil.
	dict _ Dictionary new.
	dict
		at: 'Any type' put: '%s';
		at: 'Number' put: '%n';
		at: 'Boolean (T/F)' put: '%b';
		at: 'Text' put: '%T';
		at: 'List' put: '%t';
		at: 'Command' put: '%o';
		at: 'Reporter' put: '%r';
		at: 'Predicate (Reporter of Boolean)' put: '%p'.

	dict keysDo: [:key |
		block _ CommandBlockMorph new
			commandSpec: key, ': ', (dict at: key).
		script
			ifNil: [script _ block]
			ifNotNil: [script bottomBlock attachBlock: block]].
	script openInWorld! !


OSlotMorph subclass: #TypeInReporterSlotMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!TypeInReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/8/2010 23:22'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg |
	
	blockTuple _ Array new: 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	arg _ self nestedBlock.
	(arg isKindOf: ReporterBlockMorph)
		ifTrue: [blockTuple at: 4 put: (Array with: argMorphs first asBlockTuple)]
		ifFalse: [blockTuple at: 4 put: arg evaluate]. 
	^ blockTuple! !

!TypeInReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/8/2010 22:44'!
evaluate

	"empty slot and implicit values need yet to be supported"

	| rcv answerBlock reportBlock |

	(submorphs first isKindOf: ExpressionArgMorph)
		ifFalse: [^ super evaluate].

	rcv _ self receiver.
	rcv ifNil: [rcv _ ScriptableScratchMorph new].
	answerBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #procedure) 
							color: (ScriptableScratchMorph blockColorFor: 'operators').
	answerBlock isAtomic: true.
	reportBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #doAnswer) 
							color: (ScriptableScratchMorph blockColorFor: 'control').
	reportBlock argMorphs first defaultValue: submorphs first evaluate.
	answerBlock attachBlock: reportBlock.
	^ answerBlock

"

	answerBlock _ ReporterBlockMorph new.
	answerBlock
		isSpecialForm: true;
		selector: #doAnswer;
		commandSpec: '%s'.
	answerBlock argMorphs first defaultValue: submorphs first evaluate.
	^ answerBlock
"! !

!TypeInReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/8/2010 23:17'!
initialize
	super initialize.
	self selector: #typeInLambda.
	self commandSpec: '%s'.
	removeElementMorph ifNotNil: [
		removeElementMorph delete]! !

!TypeInReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/8/2010 23:42'!
isEmptySlot

	(argMorphs first isKindOf: ExpressionArgMorph) ifTrue: [
		^ argMorphs first isEmptySlot].

	^ super isEmptySlot! !


BooleanArgMorph subclass: #UnevaluatedBooleanArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!UnevaluatedBooleanArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/22/2010 23:46'!
evaluate

	"empty slot and implicit values need yet to be supported"

	| lambdafy |

	lambdafy _ [:xpr |
		| rcv answerBlock reportBlock bool |
		rcv _ owner receiver.
		rcv ifNil: [rcv _ ScriptableScratchMorph new].
		answerBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #procedure) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').
		answerBlock isAtomic: true.
		reportBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #doAnswer) 
									color: (ScriptableScratchMorph blockColorFor: 'control').
		(xpr isKindOf: Boolean)
			ifTrue: [
				xpr
					ifTrue: [bool _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #getTrue) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').]
					ifFalse: [bool _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #getFalse) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').].
				reportBlock replaceArgMorph: reportBlock argMorphs first by: bool]
			ifFalse: [reportBlock argMorphs first defaultValue: xpr].
		answerBlock attachBlock: reportBlock.
		answerBlock ].

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [ (implicitValue isKindOf: LambdaBlockMorph)
			ifTrue: [ ^implicitValue]
			ifFalse: [ ^ lambdafy value: implicitValue ]].

	^ lambdafy value: false

! !


ExpressionArgMorph subclass: #UnevaluatedExpressionArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!UnevaluatedExpressionArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/22/2010 23:44'!
evaluate

	"empty slot and implicit values need yet to be supported"

	| lambdafy |

	lambdafy _ [:xpr |
		| rcv answerBlock reportBlock bool |
		rcv _ owner receiver.
		rcv ifNil: [rcv _ ScriptableScratchMorph new].
		answerBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #procedure) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').
		answerBlock isAtomic: true.
		reportBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #doAnswer) 
									color: (ScriptableScratchMorph blockColorFor: 'control').
		(xpr isKindOf: Boolean)
			ifTrue: [
				xpr
					ifTrue: [bool _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #getTrue) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').]
					ifFalse: [bool _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #getFalse) 
									color: (ScriptableScratchMorph blockColorFor: 'operators').].
				reportBlock replaceArgMorph: reportBlock argMorphs first by: bool]
			ifFalse: [reportBlock argMorphs first defaultValue: xpr].
		answerBlock attachBlock: reportBlock.
		answerBlock ].

	(self isEmptySlot and: [implicitValue notNil])
		ifTrue: [ (implicitValue isKindOf: LambdaBlockMorph)
			ifTrue: [ ^implicitValue]
			ifFalse: [ ^ lambdafy value: implicitValue ]].

	^ lambdafy value: labelMorph savedContents

! !

!UnevaluatedExpressionArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/20/2010 22:18'!
initialize

	super initialize.
	isNumber _ false.
! !


MultiArgCommandBlockMorph subclass: #VariableDeclarationBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!
!VariableDeclarationBlockMorph commentStamp: 'jens 1/25/2010 13:12' prior: 0!
VariableDeclarationBlockMorph new commandSpec: 'local variables'; color: ScratchFrameMorph palettePaneColor; openInWorld
!


!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:33'!
addItem
	| varBlock pos vname names |
	names _ #(a b c d e f g h i j k l m n o p q r s t u v w x y z foo bar baz).
	super addItem.
	pos _ argMorphs size.
	pos > names size
		ifTrue: [vname _ ('z', (pos - names size + 1) printString) asUTF8]
		ifFalse: [vname _ (names at: pos) asString asUTF8].
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		selector: #getVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: vname.
	self replaceArgMorph: (self argumentAt: pos) by: varBlock.! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 02:47'!
args
	^argMorphs! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/25/2010 19:59'!
defaultArgs: anArray
 	"override my superclass, do nothing"! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:08'!
deleteVariableTemplate: aVarBlockMorph

	aVarBlockMorph delete.
	argMorphs remove: aVarBlockMorph.
	self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3)! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 02:43'!
isPartsBin
	^true! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:51'!
removeItem
	argMorphs size > self minArgs ifTrue: [
		self removeLastArg.
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 20:54'!
removeLastArg

	| idx |
	idx _ argMorphs size.
	(argMorphs at: idx) delete.
	argMorphs at: idx put: nil.
! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 21:01'!
renameParm: old to: new

	(self variables includes: new) ifTrue: [
		DialogBoxMorph warn: 'This variable name already exists'.
		^false ].
	^true! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 21:01'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nextBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].

	^ super rootForGrabOf: aMorph
! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 20:56'!
variables
	^argMorphs collect: [:a |
		a variable ]! !


Object subclass: #VariableFrame
	instanceVariableNames: 'vars '
	classVariableNames: 'ScopeContrast '
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:12'!
add: varName
	vars at: varName put: 0

! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2010 01:44'!
changeVar: varName by: increment
	"Change the value of the given variable of this object by the given amount."

	|  n |
	n _ vars at: varName asString ifAbsent: [^ self].
	self setVar: varName to: n asNumberNoError + increment asNumberNoError.
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2011 01:23'!
convertStacksToTuples

	| obj isCyclic |
	vars keysDo: [:key |
		obj _ vars at: key. 
		(obj isKindOf: ScriptableScratchMorph)
			ifTrue: [ vars at: key put: obj asReferenceTuple ]
			ifFalse: [
			(obj respondsTo: #convertStacksToTuples) ifTrue: [		"this must be a list or another variable"
				obj convertStacksToTuples ].
			(obj respondsTo: #asBlockTuple) ifTrue: [ 				"this must be a block"

				isCyclic _ obj allMorphs anySatisfy: [ :m |
					(m isKindOf: SetterBlockMorph) | (m isKindOf: VariableBlockMorph) and: [
						m receiver == self or: [(m receiver isKindOf: self class) and: [m receiver isReferencing: self]] ]].
				isCyclic
					ifTrue: [ obj receiver: nil]
					ifFalse: [ vars at: key put: obj asBlockTuple ]]]]

! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2011 01:29'!
convertTuplesToStacks

	"format conventions:

		sprite:
					1 - #sprite
					2 - name

		stage:		#stage

		block: 
					1 - #block
					2 - receiver
					3 - tupleSequence

		named list reference:

					1 - #namedList
					2 - target obj name
					3 - list name

		variable-bound anonymous list reference:

					1 - #variableList
					2 - target obj name
					3 - var name

		anonymous list (either within a list or bound to a variable):

					converted to tuples in place"

	| obj stage rcvr block |

	stage _ ScratchFrameMorph someInstance workPane.

	vars keysDo: [:key |
		obj _ vars at: key.

		(obj isKindOf: Array) ifTrue: [

			obj second = 'Stage'
				ifTrue: [rcvr _ stage ]
				ifFalse: [rcvr _ stage coerceSpriteArg: obj second ].

			#block = obj first ifTrue: [
				block _ stage stackFromTupleList: obj third receiver: rcvr.
				vars at: key put: block ].

			#namedList = obj first ifTrue: [
				vars at: key put: (stage listNamed: obj third targetName: obj second)].

			#variableList = obj first ifTrue: [
				vars at: key put: (stage listInVarNamed: obj third targetName: obj second)].

			#stage = obj first ifTrue: [
				vars at: key put: stage].	

			#sprite = obj first ifTrue: [
				vars at: key put: (stage coerceSpriteArg: obj second)]].

		(obj isKindOf: ScratchListMorph) ifTrue: [
			obj convertTuplesToStacks ]]! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/16/2009 00:52'!
fieldsVersion

	^ 1
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 9/25/2008 10:25'!
forNames: aCollectionOfStrings
	aCollectionOfStrings do:[:eachVarName |
		vars at: eachVarName put: 0 ]! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 22:56'!
getVar: varName
	"Answer the value of the given user variable of this object, or 0 if the variable has been deleted."

	^ vars at: varName asString ifAbsent: [0]
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 3/28/2011 00:21'!
getVar: varName block: aVariableBlockMorph
	"Answer the value of the given user variable of this object, or 0 if the variable has been deleted."

	^ vars at: varName asString ifAbsent: [0]
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/16/2009 00:55'!
initFieldsFrom: anObjStream version: classVersion
	"Set my instance variables from the given object stream."

	self initFieldsNamed: #(
		vars
	) from: anObjStream.
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 9/25/2008 10:23'!
initialize
	super initialize.
	vars _ Dictionary new.! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 6/13/2009 20:00'!
interpretStringAsNumberIfPossible: anObject
	"If the argument is a string that can be interpreted as a number, such as '123', then return it's value as a number. Otherwise, return the original object."

	| s digits hasDigit |
	(anObject isKindOf: String) ifFalse: [^ anObject].
	anObject size = 0 ifTrue: [^ anObject].

	(anObject first isKindOf: Character)
		ifTrue: [s _ ReadStream on: anObject asByteArray]
		ifFalse: [s _ ReadStream on: anObject].

	"see if the string can be parsed as a Scratch number:"
	digits _ '0123456789' asByteArray.
	hasDigit _ false.
	(s atEnd not and: [s peek = $- asciiValue]) ifTrue: [s next].
	[s atEnd not and: [digits includes: s peek]] whileTrue: [hasDigit _ true. s next].
	(s atEnd not and: [s peek = $. asciiValue]) ifTrue: [s next].
	[s atEnd not and: [digits includes: s peek]] whileTrue: [hasDigit _ true. s next].

	(s atEnd and: [hasDigit])
		ifTrue: [^ anObject asNumberNoError]
		ifFalse: [^ anObject].

! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 5/19/2010 01:34'!
isMaxNestedAt: int
	"kludge-alert!!"

	vars do: [:each |
		(each respondsTo: #isMaxNestedAt:)
			ifTrue: [ (each isMaxNestedAt: int + 1)
				ifTrue: [^ true]]].
	^ false! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 6/30/2010 22:35'!
isReferencing: aVarFrame

	| obj |
	
	vars keysDo: [:key |
		obj _ vars at: key. 
		(obj isKindOf: BlockMorph) ifTrue: [
			(obj allMorphs anySatisfy: [ :m |
				(m isKindOf: SetterBlockMorph) | (m isKindOf: VariableBlockMorph) and: [
					m receiver == aVarFrame or: [
						(m receiver isKindOf: self class) and: [
							m receiver isReferencing: aVarFrame]]]])
				ifTrue: [^ true]].
		(obj isKindOf: ScratchListMorph) ifTrue: [
			(obj asArray anySatisfy: [ :item |
				(item isKindOf: SetterBlockMorph) | (item isKindOf: VariableBlockMorph) and: [
					item receiver == aVarFrame or: [
						(item receiver isKindOf: self class) and: [
							item receiver isReferencing: aVarFrame]]]])]].
	^ false

! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 7/27/2010 17:16'!
references: obj
	"kludge-alert: answer true if any part of me contains a reference to obj"

	vars do: [:each |
		each == obj ifTrue: [^ true].
		(each respondsTo: #references:)
			ifTrue: [ (each references: obj)
				ifTrue: [^ true]]].
	^ false! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 23:08'!
remove: varName
	vars removeKey: varName! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 5/12/2010 19:08'!
renameVar: old to: new

	| value |
	(vars includesKey: old)
		ifTrue: [ 
			value _ vars at: old.
			self remove: old]
		ifFalse: [ value _ 0 ].
	vars at: new put: value! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 1/27/2010 01:26'!
scope

	^self varNamesMenu! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 16:55'!
setVar: varName to: newValue
	"Set the value of the given variable of this object to the given value."

"	|  v |
	v _ self interpretStringAsNumberIfPossible: newValue."

	vars at: varName put: newValue.
! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/16/2009 00:54'!
storeFieldsOn: anObjStream

	self storeFieldsNamed: #(
		vars
	) on: anObjStream.

! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 12/18/2009 00:45'!
varNamesMenu
	^vars keys asSortedCollection asArray! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 22:49'!
variableBlockColor

	^ self class variableBlockColor! !

!VariableFrame methodsFor: 'as yet unclassified' stamp: 'jens 5/20/2010 22:53'!
vars
	"private"
	^ vars! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

VariableFrame class
	instanceVariableNames: ''!

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 9/25/2008 10:26'!
forNames: aCollection
	^self new forNames: aCollection! !

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 23:12'!
initialize

	"VariableFrame initialize"

	super initialize.
	ScopeContrast _ false.! !

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 5/18/2010 23:46'!
maxNestingDepth
	"kludge alert!!"

	^ 100! !

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 23:21'!
scopeContrast

	^ ScopeContrast! !

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 23:12'!
scopeContrast: bool

	ScopeContrast _ bool! !

!VariableFrame class methodsFor: 'as yet unclassified' stamp: 'jens 8/3/2010 13:26'!
variableBlockColor

	ScopeContrast
		ifTrue: [^ (Color brown darker mixed: 0.8 with: Color orange) lighter]
		ifFalse: [^ ScriptableScratchMorph blockColorFor: 'variables']
	
! !

BlockEditorFrameMorph initialize!
BlockLabelFragmentDialog initialize!
DebuggerFrameMorph initialize!
ElementsEditorFrameMorph initialize!
VariableFrame initialize!